
require.config({
    baseUrl: './',
    // 3rd party library alias names
    paths: {
        jquery: 'vendor/jquery/jquery',
        underscore: 'vendor/lodash/dist/lodash',
        backbone: 'vendor/backbone/backbone',
        marionette: 'vendor/backbone.marionette/lib/backbone.marionette',
        handlebars: 'vendor/handlebars/handlebars.min',
        text: 'vendor/requirejs-text/text',
        json2xml: 'vendor/json2xml/json2xml',
        xml2json: 'vendor/xml2json/xml2json',
        localstorage: 'vendor/backbone.localStorage/backbone.localStorage-min',
        i18next: 'vendor/i18next/i18next',
        hbs: 'vendor/require-handlebars-plugin/hbs',
        hammer: 'vendor/hammerjs/hammer.min',
        syphon: 'vendor/backbone.syphon/backbone.syphon.min',
        validator: 'vendor/validator-js/validator.min',
        funcs: 'apps/common/lib/functions',
        log: 'apps/log',
        moment: 'vendor/moment/min/moment.min',
        md5: 'vendor/jsmd5/js/md5.min',
        toggles: 'vendor/toggles/toggles',
        bluebird: 'vendor/bluebird/bluebird.min',
        'socket.io': 'vendor/socket.io/socket.io',
        royalslider: 'vendor/royalslider/jquery.royalslider.min',
        fastclick:'vendor/fastclick/fastclick',
        'retry':'vendor/jquery.retry/jquery-ajax-retry'
    },
    hbs: { // optional
        helpers: true, // default: true
        i18n: false, // default: false
        templateExtension: 'html', // default: 'hbs'
        partialsUrl: '' // default: '',

    },
    // Sets the configuration for your third party scripts that are not AMD compatible
    shim: {
         'retry':{
            'deps':['jquery'],
            'exports':'jQuery'
        },
        'backbone': {
            'deps': ['underscore'],
            // Exports the global window.Backbone object
            'exports': 'Backbone'
        },
        'marionette': {
            'deps': ['underscore', 'backbone', 'jquery'],
            // Exports the global window.Marionette object
            'exports': 'Marionette'
        },
        'handlebars': {
            'exports': 'Handlebars'
        },
        'syphon': {
            'deps': ['backbone'],
            'exports': 'Backbone.Syphon'
        },
        'toggles': {
            deps: ['jquery']
        },
        // 'io': {
        //     exports: 'io'
        // },
        'underscore': {
            exports: '_'
        }
    },
    waitSeconds: 200
});

