

define(['App', 'log', 'retry', 'jquery', 'backbone', 'marionette', 'underscore', 'handlebars', 'json2xml',
	'bluebird'

], function(App, log, retry, $, Backbone, Marionette, _, Handlebars, json2xml, Promise) {

	App.module('api', function(Module, App) {
		var userInfo = App.request('entities:user_info');

		//PRE
		//var server = 'http://stg.swingerpeople.com';
		//var chat = 'http://im.swingerpeople.com:3017';
		//PRO
		var server = 'http://prd.swingerpeople.com';
		var chat = 'http://im.swingerpeople.com:3016';

		Module.chat = chat;
		//PRO
		var defaultTime = 7000;
		var retryTimes = 5;
		App.vent.on('app:logged', function() {
			defaultTime = 8000;
			retryTimes = 3;
		});
		var k = 'AzBV541:,HCmlhg89#';
		var connOk= function(data) {

			App.execute('network_manager:connected');
			return data;
		};

		var failFnc = function() {
			App.execute('network_manager:api_error');

		};

		App.server = server;

		server = server + '/wbscr';

		var str = '<?xml version=\'1.0\' standalone=\'yes\'?>';

		var common = {
			peticion: {
				validation_code: btoa(k + userInfo.get('email')),
				petition: 'login',
				lang: 'es',
				platform: 'iPhone OS',
				version: '3.0'
			}
		};


		//FUNCIONES DE LA API...
		App.reqres.setHandler('api:login', function(user, pass) {
			//Comprovar userInfo

			if (userInfo.get('email') === undefined) {
				userInfo.set('email', user);
			}
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			userInfo.save();

			var obj = common;
			obj.peticion.petition = 'login';
			obj.peticion.data = {
				email: user,
				passwd: pass,
				UDID: 'C3DC4EAC-0AB3-4609-A8D9-9C0D7A2CDC61'
			};
			var res = json2xml(obj);


			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk).then(connOk);
		});
		App.reqres.setHandler('api:invite_friend', function(email) {
			window.alert(email + ' Falta API');

			/*if (userInfo.get('email') === undefined) {
			    userInfo.set('email', user);
			}
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			userInfo.save();

			var obj = common;
			obj.peticion.petition = 'login';
			obj.peticion.data = {
			    email: userInfo.get('email'),
			    passwd: pass,
			    UDID: 'C3DC4EAC-0AB3-4609-A8D9-9C0D7A2CDC61'
			};
			var res = json2xml(obj);


			return $.ajax({url:server,type: 'POST',timeout:defaultTime, data:{
			    xml: str + res
			});*/
		});

		App.reqres.setHandler('api:unsubscribe', function() {
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'unsubscribe';
			obj.peticion.data = {
				reg_id: userInfo.get('reg_id')
			};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});


		App.reqres.setHandler('api:get_tzones', function() {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'tzone_list';
			obj.peticion.data = {};


			var res = json2xml(obj);
			return new Promise(function(resolve, reject) {

				var succFunc = function(data) {
					var d = JSON.parse(data);

					if (d.response) {
						reject(data);
					} else {

						resolve(data);
					}
				};
				$.ajax({
					url: server,
					type: 'POST',
					timeout: defaultTime,
					data: {
						xml: str + res
					},
					success: succFunc
				}).retry({
					times: retryTimes
				}).fail(failFnc).then(connOk);
			});

		});

		App.reqres.setHandler('api:twilight', function(data) {



			delete data.active;
			delete data.name;

			data.state = 1;

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'tzone';
			obj.peticion.data = data;


			var res = json2xml(obj);


			return new Promise(function(resolve) {
				$.ajax({
					url: server,
					type: 'POST',
					timeout: defaultTime,
					data: {
						xml: str + res
					},
					success: function(data) {
						resolve(data);
					}
				}).retry({
					times: retryTimes
				}).fail(failFnc).then(connOk);
			});

		});

		App.reqres.setHandler('api:get_map', function(data) {
			var search = App.request('entities:search');
			var profile = App.request('entities:profile');
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'get_positions';




			obj.peticion.data = {
				lat: data.lat,
				lon: data.lon
			};

			var imSingle = false;
			if (parseInt(userInfo.get('registeredAs'), 10) === 1 ||  parseInt(userInfo.get('registeredAs'), 10) === 2) {
				imSingle = true;
			}

			if (profile.get('isSingle') || imSingle) {

				obj.peticion.data.clients = 0;
				obj.peticion.data.locals = search.get('clubs') ? 1 : 0;
				obj.peticion.data.verified = search.get('verified') ? 1 : 0;
				obj.peticion.data.residents = search.get('residents') ? 1 : 0;

				obj.peticion.data.singleW = parseInt(search.get('onlywomen'), 10) || 1;
				obj.peticion.data.singleM = parseInt(search.get('onlymen'), 10) || 1;

			} else {

				obj.peticion.data.clients = search.get('clients') ? 1 : 0;
				obj.peticion.data.locals = search.get('clubs') ? 1 : 0;
				obj.peticion.data.verified = search.get('verified') ? 1 : 0;
				obj.peticion.data.residents = search.get('residents') ? 1 : 0;
				obj.peticion.data.singleW = search.get('onlywomen') ? 1 : 0;
				obj.peticion.data.singleM = search.get('onlymen') ? 1 : 0;
			}

			if (search.get('residents')) {

				obj.peticion.data.country_code = search.get('country');
			}
			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				data: {
					xml: str + res
				}
			});
		});
		//Get UserData
		App.commands.setHandler('api:set_user_cache_imgs', function(id, imgs ){
			if (Module.userCache['' + id] !== undefined && id !== userInfo.get('id_swinger')) {
				console.log(Module.userCache['' + id]);

				var json = JSON.parse(Module.userCache['' + id]);
				json.data.imgs = imgs;
				Module.userCache['' + id] = JSON.stringify(json);
			}
		})
		App.reqres.setHandler('api:get_user', function(id, no_cache, email) {

			if (!Module.userCache) {
				Module.userCache = {};
			}
			return new Promise(function(ok) {

				if (Module.userCache['' + id] !== undefined && id !== userInfo.get('id_swinger')) {

					return ok(Module.userCache['' + id]);
				}
				common.peticion.validation_code = btoa(k + userInfo.get('email'));
				var obj = common;
				obj.peticion.petition = 'get_user';


				obj.peticion.data = {
					id: id
				};
				if (email) {
					obj.peticion.data = {
						email: email
					};
				}

				var res = json2xml(obj);

				return $.ajax({
					url: server,
					type: 'POST',
					timeout: defaultTime,
					data: {
						xml: str + res
					}
				}).retry({
					times: retryTimes
				}).fail(failFnc).then(connOk).then(function(res) {

					if (id !== userInfo.get('id_swinger')) {
						Module.userCache['' + id] = res;
					}
					ok(res);
				});
			});

		});
		// //Get Desplegables

		//Registrar Usuari
		App.reqres.setHandler('api:new_user', function(data) {


			var user = {
				nickname: data.nickname,
				passwd: data.passwd,
				email: data.email

			};
			var obj = common;
			obj.peticion.petition = 'new_user';
			obj.peticion.data = user;

			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});
		//Editar Usuari
		App.reqres.setHandler('api:edit_user', function(data) {
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var json = {
				short_desc: data.get('short_desc'),
				id_client: data.get('id_client'),
				nickname: data.get('nickname'),
				description: data.get('description'),
				passwd: data.get('passwd'),
				email: data.get('email'),
				edad_he: data.get('edad_he'),
				edad_she: data.get('edad_she'),
				id_nationality_he: data.get('id_nationality_he'),
				id_nationality_she: data.get('id_nationality_she'),
				id_or_he: data.get('id_or_he'),
				id_or_she: data.get('id_or_she'),
				id_raza_he: data.get('id_raza_he'),
				id_raza_she: data.get('id_raza_she'),
				id_pais_residencia: data.get('id_pais_residencia'),
				id_tipo_relacion: data.get('id_tipo_relacion'),
				capacidad_alojamiento: data.get('capacidad_alojamiento'),
				experiencia: data.get('experiencia'),
				peso_he: data.get('peso_he'),
				peso_she: data.get('peso_she'),
				altura_he: data.get('altura_he'),
				altura_she: data.get('altura_she'),
				id_estetica_he: data.get('id_estetica_he'),
				id_estetica_she: data.get('id_estetica_she'),
				langs: data.get('langs')
			};

			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'modify_user';
			obj.peticion.data.json = JSON.stringify(json);

			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);

		});
		App.reqres.setHandler('api:position', function(data) {

			//Nomes actualizamos si no estamos ocultos..
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var info = {
				lon: data.lon,
				lat: data.lat,
				tz: 0
			};

			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'position';
			obj.peticion.data = info;

			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});

		// App.reqres.setHandler('api:get_datos', function() {
		//     common.peticion.validation_code = btoa(k + userInfo.get('email'));
		//     var obj = common;
		//     obj.peticion.petition = 'get_datos';
		//     var res = json2xml(obj);

		//     return $.ajax({url:server,type: 'POST',timeout:defaultTime, data:{
		//         xml: str + res
		//     });
		// });

		App.reqres.setHandler('api:report_user', function(umail, motive) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'report_user';
			obj.peticion.data = {
				email_user_to_report: umail,
				extra: motive
			};

			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});

		App.reqres.setHandler('api:get_local', function(id) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'get_local';
			obj.peticion.data = {
				id: id
			};

			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});
		App.reqres.setHandler('api:get_party', function(id) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'get_party';
			obj.peticion.data = {
				id: id
			};

			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});

		App.reqres.setHandler('api:get_info', function(swingers, locals, parties) {

			swingers = _.map(swingers, function(swingers) {
				return '' + swingers;
			});

			locals = _.map(locals, function(locals) {
				return 'l_' + locals;
			});
			parties = _.map(parties, function(party) {
				return 'p_' + party;
			});
			//swingers = _.union(swingers, locals);
			var items = _.union(swingers, locals);
			items = _.union(items, parties);

			if (!Module.get_info_swingers_cache) {
				Module.get_info_swingers_cache = {};
			}
			var cached_ids = _.keys(Module.get_info_swingers_cache);
			var pending_ids = _.difference(items, cached_ids);
			var pending_loc_ids = _.difference(locals, cached_ids);
			var pending_par_ids = _.difference(parties, cached_ids);

			pending_ids = _.union(pending_ids, pending_loc_ids);
			pending_ids = _.union(pending_ids, pending_par_ids);
			cached_ids = _.intersection(cached_ids, items);




			return new Promise(function(ok /*, reject*/ ) {

				//Si  los tengo todos  en cache.. acabo..
				if (pending_ids.length === 0) {
					var cached = _.map(cached_ids, function(el) {

						return Module.get_info_swingers_cache[el];
					});
					return (ok(cached));
				}



				//PREPARO PETICION..
				common.peticion.validation_code = btoa(k + userInfo.get('email'));
				var obj = common;
				obj.peticion.petition = 'get_info';

				obj.peticion.data = {};
				obj.peticion.data.arrSw = pending_ids.join(',');
				obj.peticion.data.arrLo = pending_loc_ids.join(',');
				obj.peticion.data.arrLo = obj.peticion.data.arrLo.replace(/l_/g, '');
				obj.peticion.data.arrParty = pending_par_ids.join(',');
				obj.peticion.data.arrParty = obj.peticion.data.arrParty.replace(/p_/g, '');
				//PATCH para bug de server..
				if (obj.peticion.data.arrLo === '') {
					obj.peticion.data.arrLo = '1';
				}
				//BUG parties??
				if (obj.peticion.data.arrParty === '') {
					obj.peticion.data.arrParty = '1';
				}
				var res = json2xml(obj);

				//LANZAMOS PETICION..
				return $.ajax({
					url: server,
					type: 'POST',
					timeout: defaultTime,
					data: {
						xml: str + res
					}
				}).retry({
					times: retryTimes
				}).fail(failFnc).then(connOk).then(function(result) {


					result = JSON.parse(result);

					//Recuperamos cacheados..
					var cached = _.map(cached_ids, function(el) {
						return Module.get_info_swingers_cache[el];
					});




					//Por ultimo Los cacheamos..
					_.each(result, function(el) {
						if (el.id_swinger) {
							if (typeof el === 'object') {
								try {

									el.idiomas = JSON.parse(el.idiomas);
								} catch (e) {

								}
							}
							Module.get_info_swingers_cache[el.id_swinger] = el;
						} else if (el.id_party ||  el.party_name) {

							//TODO: treure hardcode
							// Module.get_info_swingers_cache['p_' + el.id_party] = el;
							Module.get_info_swingers_cache.p_3 = el;
						} else {

							Module.get_info_swingers_cache['l_' + el.id_local] = el;
						}
					});
					//DEVOLVEMOS RESULTADO..
					result = _.union(result, cached);
					ok(result);


				});
			});
		});
		App.reqres.setHandler('api:change_visibility', function(data) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'change_visibility';
			obj.peticion.data = {
				value: data
			};
			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});
		App.reqres.setHandler('api:get_favorites', function() {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'favorites_list';
			obj.peticion.data = {};
			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});

		App.reqres.setHandler('api:get_confirms', function() {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'confirm_list';
			obj.peticion.data = {};
			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});
		App.reqres.setHandler('api:get_reports_list', function() {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'report_list';
			obj.peticion.data = {};
			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});
		App.reqres.setHandler('api:set_favorite', function(id_swinger, state) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'favorite';
			obj.peticion.data = {
				id_swinger_favorite: id_swinger,
				state: state
			};
			var res = json2xml(obj);

			if (state) {
				var fav = App.request('entities:favorites');
				fav.add({
					id_swinger_favorite: id_swinger
				});
			}


			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});
		App.reqres.setHandler('api:verify', function(email) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'confirm_user';
			obj.peticion.data = {
				email_user_to_confirm: email
			};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});
		App.reqres.setHandler('api:get_block', function() {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'bloqueo_list';
			obj.peticion.data = {};
			var res = json2xml(obj);



			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});

		App.reqres.setHandler('api:set_blocked', function(id_swinger, state) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'bloqueo';
			obj.peticion.data = {
				id_swinger_bloqueado: id_swinger,
				state: state
			};
			var res = json2xml(obj);
			if (state) {
				var fav = App.request('entities:block');
				fav.add({
					id_swinger_bloqueado: id_swinger
				});
			}

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});


		App.reqres.setHandler('api:forgotten_pass', function(email) {

			common.peticion.validation_code = btoa(k + email);
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'remember_pass';
			obj.peticion.data = {};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);
		});

		/**
		    PETICION PECULIAR
		    HAY QUE HACER UN SEND PARA QUE FUNCIONE...
		**/
		App.reqres.setHandler('api:set_photo', function(pict) {
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'set_photo';

			obj.peticion.data = {
				ext: '.jpg',
				img: pict
			};
			var res = json2xml(obj);


			var xhr = new XMLHttpRequest();
			Module.actualXhr = xhr;
			xhr.file = pict;

			xhr.open('post', server, true);


			var data = new FormData();
			data.append('xml', res);

			//La lanzamos 1ms despues para poder añadir handlers desde login..
			setTimeout(function() {
				xhr.send(data);
			}, 1);
			return xhr;

		});
		App.reqres.setHandler('api:new_chat_image', function(pict) {
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'newChatImage';

			obj.peticion.data = {
				ext: '.jpg',
				img: pict
			};
			var res = json2xml(obj);


			var xhr = new XMLHttpRequest();
			Module.actualXhr = xhr;
			xhr.file = pict;

			xhr.open('post', server, true);


			var data = new FormData();
			data.append('xml', res);

			//La lanzamos 1ms despues para poder añadir handlers desde login..
			setTimeout(function() {
				xhr.send(data);
			}, 1);
			return xhr;

		});
		App.commands.setHandler('api:cancel_pict', function() {

			try{

		  	Module.actualXhr.abort();
			}
			catch(e){
				console.log('Error in cancel..');
			}
		});
		App.reqres.setHandler('api:delete_image', function(id_picture) {




			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'delete_image';
			obj.peticion.data = {
				id_foto: id_picture
			};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);

		});
		App.reqres.setHandler('api:like_image_photo', function(client_id, id_picture) {

			console.log('.......',Module.get_info_swingers_cache);
			console.log(Module.get_info_swingers_cache[client_id]);
			delete Module.get_info_swingers_cache[client_id];
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'like_image_photo';
			obj.peticion.data = {
				id_foto: id_picture
			};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);

		});
		App.reqres.setHandler('api:get_image', function( id_picture) {

			console.log('inside get image api');
			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'get_image';
			obj.peticion.data = {
				id_foto: id_picture
			};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);

		});
		App.reqres.setHandler('api:write_photo_comments', function( id_picture,comment) {


			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'write_photo_comments';
			obj.peticion.data = {
				id_foto: id_picture,
				comment: comment

			};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);

		});
		App.reqres.setHandler('api:wall', function(lon, lat) {




			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.data = {};
			obj.peticion.petition = 'wall';
			obj.peticion.data = {
				lon: lon,
				lat: lat
			};
			var res = json2xml(obj);

			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);

		});
		App.reqres.setHandler('api:delete-chat', function(id_client) {

			common.peticion.validation_code = btoa(k + userInfo.get('email'));
			var obj = common;
			obj.peticion.petition = 'delete-chat';
			obj.peticion.data = {
				id_client: id_client
			};
			var res = json2xml(obj);
			return $.ajax({
				url: server,
				type: 'POST',
				timeout: defaultTime,
				data: {
					xml: str + res
				}
			}).retry({
				times: retryTimes
			}).fail(failFnc).then(connOk);

		});

	});



	return App;

});
