

define(['App',
        'underscore',
        'apps/block/views',
        'apps/common/views/common_views',
        'backbone',
        'apps/common/lib/spinner',
        'apps/block/entities'
    ],
    function(App, _, Views, CommonViews, Backbone, spinner) {

        App.module('block.list.controller', function(Module, App) {
            //var list = App.request('entities:block');


            Module.show = function() {
                spinner(true);
                App.request('api:get_block').then(function(list) {
                    //spinner(false);
                    list = JSON.parse(list);
                    var ids_client = _.pluck(list, 'id_swinger_bloqueado');

                    App.request('api:get_info', ids_client, [1]).then(function(elems) {
                        //Removes the

                        elems = _.filter(elems, function(elem) {
                            return elem.id_swinger;
                        });


                        elems = new Backbone.Collection(elems);
                        var view = new Views.List({
                            collection: elems
                        });

                        //Return map..
                        view.on('back', function() {
                            App.execute('app:map', 'right');
                        });
                        //View profile..
                        view.on('item:view_profile', function(a, info) {
                            var model = info.model;
                            spinner(true);
                            var data = {
                                id_client: parseInt(model.get('id_swinger'), 10),
                                back: 'block'
                            };
                            App.execute('app:profile:show', 'left', data);

                        });
                        //Eliminar
                        view.on('item:remove', function(info) {
                            //Llamamos api
                            App.request('api:set_blocked', info.model.get('id_swinger'), 0);

                            //Destruimos modelo..
                            _.find(list,function(elem) {
                                return elem.id_swinger_bloqueado === info.model.get('id_swinger');
                            });
                            info.model.trigger('destroy', info.model, info.model.collection);
                        });

                        App.mainRegion.slideShow(view, 'left');
                    });
                });
            };

        });

        return App.block.list.controller;

    });
