

define(['App',
    'underscore',
    'apps/chat/list/controller',
    'apps/chat/conversation/controller',
    'apps/chat/quickmap/controller',
    'apps/chat/entities',
    'moment',
    'socket.io',
    'api',
    'templates/helpers/cleanmessage'
], function (App, _, chatListController, chatController, quickViewController, ent, moment, io, api, cleanmessage) {

    App.module('chat', function (Module, App) {
        var retry = false;
        var oneHello = false;
        var userInfo, chat_list, prof, pending;
        var firstTime = true;
        var firstTimeEvent = 'app:map';
        var firstTimeParams = null;
        var totalPendings = null;
        var lastTimeHello = moment();

        Module.addInitializer(function () {
            userInfo = App.request('entities:user_info');
            chat_list = App.request('entities:chat_list');
            prof = App.request('entities:profile');
            pending = App.request('entities:pending_messages');


            setInterval(function () {
                Module.checkTotalPendings();
                Module.send1Pending();
                try {
                    if (App.mainRegion.oid && App.mainRegion.oid.indexOf('chat') > -1) {

                        return;
                    } else {

                    }
                    if (!totalPendings && window.push) {


                        window.push.setApplicationIconBadgeNumber(function () {

                        }, function () {

                        }, 0);

                        window.push.clearAllNotifications();

                    } else if (window.push) {

                        var value = parseInt(totalPendings, 10)

                        if (value < 0) {
                            value = 0;
                        }
                        window.push.setApplicationIconBadgeNumber(function () {

                        }, function () {

                        }, value);
                    }
                } catch (e) {
                    alert('errorcleaning push');
                }
            }, 1000);

            setInterval(function () {
                Module.updateHello();
            }, 5 * 1000);
        });

        App.vent.on('app:logged', function () {
            initializeWebSocket();

            //Si chat update no està, recuperamos conversaciones de 20 dias atras..
            if (!userInfo.get('chat_last_update')) {
                userInfo.set('chat_last_update', moment().add('days', -20).unix());
            }
            Module.UpdatePicts();
        });

        //Acciones de intercambio entre modulos...
        App.commands.setHandler('app:chat', function (type) {

            chatListController.show(type);
        });

        App.reqres.setHandler('app:chat:check', function (me, them) {

            var obj = {
                me: false,
                them: true
            };
            var picts = me.get('imgs');
            if (picts.length > 1) {

                _.each(picts, function (pict) {
                    if (pict.validation === 1) {
                        obj.me = true;
                    }
                });
            } else {
                var pict = me.get('imgs')[0];
                if (pict && parseInt(pict.validation, 10) !== -1) {
                    obj.me = true;
                }
            }

            // picts = them.get('imgs')[0];
            // if (pict && (parseInt(pict.validation, 10) !== -1)) {
            //     obj.them = true;
            // }

            return obj;
        });
        App.commands.setHandler('app:chat:no_chat_me', function () {
            chatController.noChatMe();
        });
        App.commands.setHandler('app:chat:no_chat_them', function () {
            chatController.noChatThem();
        });
        App.commands.setHandler('app:chat:conversation', function (id_client, data, type) {


            if (firstTime) {
                firstTimeEvent = 'app:chat:conversation';
                firstTimeParams = id_client;
            }
            if (!type) type = 'left';
            chatController.show(id_client, data, type);
            
        });
        App.commands.setHandler('app:chat:conversationPayment', function (id_client, data, type) {





            if (typeof store !== "undefined") {

                var p = store.get('appconnect4u.sw.anual');

                if (!p) {
                    
                } else {
                    //alert('STATE'+ p.state);
                    if (p.state == store.OWNED) {
                        setTimeout(function () {
                            // body...
                            App.execute('app:chat:conversation',id_client, data, type);
                        }, 2);

                    } else {

                        store.order("appconnect4u.sw.anual").then(function () {
                            setTimeout(function () {
                                if (p.state == store.OWNED) {
                                    setTimeout(function () {
                                        // body...
                                        App.execute('app:chat:conversation',id_client, data, type);
                                    }, 2);
                                }
                            }, 3000);

                        });
                    }
                }
            } else {
                App.execute('app:chat:conversation',id_client, data, type);
            }


        });
        App.commands.setHandler('app:chat:quickmap', function (id_client, data) {
            quickViewController.show(id_client, data);
        });

        App.commands.setHandler('app:chat:remove_conv', function () {

        });
        //EVENTOS DE WEBSERVICE..
        App.commands.setHandler('app:chat:ws_error', function () {

            retry = true;
            //setTimeout(initializeWebSocket, 5 * 1000);
        });

        //NUEVO CHAT DESDE MAPA
        App.commands.setHandler('app:chat:new_message', function (data) {


            //data.email = 'marc@icmbdemi.com';
            //Busco el modelo del email solicitado
            var model = _.find(chat_list.models, function (model) {
                return model.get('id_swinger') === data.id_swinger;
            });

            //Si no hay.. creo un modelo
            if (!model) {

                Module.createNewChat(data, function (err, model) {
                    chatController.show(model.id, data, null, oneHello);
                });


            } else {
                chatController.show(model.id, data, null, oneHello);
            }
        });


        //Mensaje nuevo para enviar DESDE CONVERSACION
        App.vent.on('app:chat:conversation:new_message', function (info) {
            Module.newMessage(info);
        });


        Module.newMessage = function (info) {
            var date = moment().unix();
            if (info.date) {
                date = info.date;
            }
            //Monto objeto mensaje
            var obj = {
                sender: prof.get('id_client'),
                receiver: info.id_swinger,
                message: info.message,
                date: date,
                action: 'new_message'
            };

            //GUARDO MENSAJE EN PENDING...
            pending.create(obj);

            try {

                //Module.connection.emit('message', obj);
            } catch (e) {
                App.execute('app:chat:ws_error');
            }


        };

        Module.updateHello = function () {
            //Si hace mas de 15 segundos que no recibimos hello.. lo hacemos...
            if (moment().unix() - lastTimeHello.unix() > 15000) {

                Module.doHello();
            }
        };
        //Funcion usada para refrescar la cache...
        Module.UpdatePicts = function () {
            App.execute('app:pictures:update_picts', chat_list.models);
        };

        Module.getTotalPendings = function () {
            return _.reduce(chat_list.models, function (memo, el) {


                if (el.get('pending') === 0) {
                    return memo + 0;
                } else {
                    return memo + 1;
                }
            }, 0);
        };
        Module.checkTotalPendings = function () {
            if (totalPendings === null) {

                totalPendings = Module.getTotalPendings();
            } else {
                totalPendings = Module.getTotalPendings();

            }
            App.commands.execute('app:map:chat_icon', totalPendings);

        };
        Module.doHello = function () {

            var obj = {
                action: 'hello',
                id_swinger: prof.get('id_client'),
                date: userInfo.get('chat_last_update')
            };


            try {

                Module.connection.emit('message', obj);
                lastTimeHello = moment();
            } catch (e) {

            }

            Module.send1Pending();

        };

        Module.registerDevice = function () {
            var devId = 'no_cordova' + (new Date()).getTime();
            if (typeof device !== 'undefined') {

                devId = device.uuid || 'no_cordova' + (new Date()).getTime();
            }



            var obj = {
                action: 'register',
                id_client: prof.get('id_client'),
                reg_id: userInfo.get('reg_id'),
                nickname: prof.get('nickname'),
                uuid: devId,
                device: userInfo.get('device')
            };


            Module.connection.emit('message', obj);




        };
        Module.send1Pending = function () {
            var pend = pending.first();
            if (pend) {
                var obj = pend.toJSON();
                delete obj.cid;
                delete obj.id;

                Module.connection.emit('message', obj);
                //pending.create(obj);
            }

        };
        Module.confirmReceived = function (obj) {

            //Recupero de pending la lista de mensajes..
            var toInt = function (elem) {
                return parseInt(elem, 10);
            };
            if (pending.models.length > 0) {

                var model = _.find(pending.models, function (model) {
                    model = model.toJSON();
                    return toInt(obj.receiver) === toInt(model.receiver) && toInt(obj.sender) === toInt(model.sender) && toInt(obj.internal_id) === toInt(model.date);
                });
                if (model) {
                    model.destroy();

                    Module.doHello();
                }
            }
        };
        //Añadimos mensaje...
        Module.addMessage = function (elem) {



            var model = chat_list.get(Module.obtainChatIdFromElem(elem));
            var arr = model.get('messages');
            while (arr.length > 50) {

                arr.shift();
            }
            var exist = _.find(arr, function (mess) {
                return elem.id === mess.id;
            });

            if (!exist) {

                elem.date = elem.internal_id;
                //No teniamos el mensaje..
                arr.push(elem);
                arr = _.sortBy(arr, 'date');
                model.set('messages', arr);
                //Si el que envia es otro...

                if (parseInt(elem.sender, 10) !== parseInt(prof.get('id_client'), 10)) {

                    if (model.get('pending') != null) {
                        model.set('pending', model.get('pending') + 1);
                    } else {
                        model.set('pending', 1);
                    }

                    chatController.newMessage(elem);
                } else {

                    chatController.newMessage(elem);
                }
                console.log('ABANS', elem.message)
                if (elem.message) {

                    var mess = cleanmessage(elem.message);

                    model.set('last_text', mess.substr(0, 40));

                    model.set('last_message', elem.date);
                } else {
                    model.set('last_message', '');
                }


                model.save();
            }


        };
        Module.obtainChatIdFromElem = function (elem) {
            var chatId;
            if (parseInt(elem.sender, 10) === parseInt(prof.get('id_client'), 10)) {
                //Sender soy yo,
                chatId = elem.receiver;
            } else {
                chatId = elem.sender;
            }
            return chatId;
        };
        Module.createNewChat = function (elem, cb) {

            var model;

            //Nos llega chat desde Hello, puede ser nuestro o de los otros

            if (elem.receiver) {
                var chatId;
                if (parseInt(elem.receiver, 10) === parseInt(prof.get('id_client'), 10)) {
                    chatId = elem.sender;
                } else {
                    chatId = elem.receiver;
                }

                model = App.request('entities:chat_list_new', parseInt(chatId, 10));

                App.request('api:get_info', [chatId], []).then(function (info) {

                    var obj = _.find(info, function (el) {
                        return parseInt(el.id_swinger, 10) === parseInt(chatId, 10);
                    });

                    model.set('nickname', obj.nick);
                    if (obj.imgs && obj.imgs.length > 0) {
                        model.set('img', obj.imgs[0]);
                    }
                    model.save();

                    cb(null, model);


                });
            } else {

                //Nosotros iniciamos el chat

                model = App.request('entities:chat_list_new', elem.id_client);
                model.set('nickname', elem.nickname);
                if (elem.imgs && elem.imgs.length > 0) {
                    model.set('img', elem.imgs[0]);
                }
                model.save();


                //AÑADIMOS EL MENSAJE..
                cb(null, model);
            }
        };

        Module.messageReceived = function (elem) {

            //Buscamos mensajes guardados en local
            var model, chatId = Module.obtainChatIdFromElem(elem);

            model = chat_list.get(chatId);
            //Si no existe creamos nuevo model
            if (!model) {

                Module.createNewChat(elem, function () {
                    Module.addMessage(elem);
                });


            } else {

                Module.addMessage(elem);

            }

            userInfo.set('chat_last_update', elem.date);
            //Module.confirmReceived(elem);



        };

        App.commands.setHandler('app:chat:subscribe', function (regId) {
            Module.regId = regId;
        });

        //LOGICA DEL WEBSOCKET...
        var initializeWebSocket = function () {

            window.WebSocket = window.WebSocket || window.MozWebSocket;

            Module.connection = io(api.api.chat); //PRE PROD

            if (!device.uuid) {
                device.uuid = userInfo.get('reg_id');
            }


            Module.connection.on('connect', function () {
                console.log('connected');
                Module.connected = true;

                Module.registerDevice();
            });
            Module.connection.on('disconnect', function () {
                Module.connected = false;
            });

            // most important part - incoming messages
            Module.connection.on('message', function (obj) {
                console.log('mess', obj);
                try {

                    //Cuando  nos llega mensaje..
                    if (obj.action === 'pending') {

                        Module.doHello();
                        console.log('pend', App.mainRegion.oid, 'chat_' + obj.data.sender);
                        if (!App.mainRegion.oid || (App.mainRegion.oid.indexOf('chat') === -1)) {
                            console.log('notifica');
                            App.execute('app:notification', obj.data.nickname, obj.data.message, obj.data);
                        }
                    } else if (obj.action === 'hello_response') {

                        if (firstTime) {
                            //Ejecutamos el map..
                            App.execute(firstTimeEvent, firstTimeParams);
                            firstTime = false;
                        }
                        _.each(obj.messages, function (elem) {

                            if (elem.receiver === prof.get('id_client')) {
                                // App.execute('app:map:pend_messages', true);
                            }

                            Module.messageReceived(elem);



                        });


                        oneHello = true;
                        chatController.activateConversation();
                        chatListController.startOK();

                    } else if (obj.action === 'new_message_response') {

                        Module.confirmReceived(obj.send_elem);

                    } else if (obj.action === 'registered') {
                        Module.doHello();

                    } else {

                    }
                } catch (e) {
                    console.log(e);
                    console.trace(e.stack);
                    Module.doHello();
                }
            });
        };
    });
    return App.chat;

});