

define(['App',
        'underscore',
        'moment',
        'apps/chat/conversation/views',
        'apps/common/lib/spinner',
        'apps/common/views/common_views',
        'i18next'
    ],
    function(App, _, moment, Views, spinner, CommonViews, i18n) {
        App.module('chat.conversation.controller', function(Module, App, Backbone) {
            var prof, xat, pending;
            Module.addInitializer(function() {
                prof = App.request('entities:profile');
                xat = App.request('entities:chat_list');
                pending = App.request('entities:pending_messages');
            });

            var view;
            Module.show = function(id, data, type, active) {
                
                Module.id = id;

                // App.execute('app:map:pend_messages', false);
                var model = xat.get(id);

                //Montamos una vista con datos del modelo y los mensajes existentes..
                var messages = model.get('messages');
                var id_client = parseInt(prof.get('id_client'), 10);

                //inicio prev..
                var prev;
                //Por cada fila

                //Ponemos todos como confirmados..
                _.each(messages, function(mess) {
                    mess.confirm = true;
                });

                //Añadimos pendings..
                var pendings = _.filter(pending.models, function(elem) {

                    elem = elem.toJSON();

                    return parseInt(elem.receiver, 10) === parseInt(id, 10);
                });

                //Marcamos los mines..
                messages.concat(pendings);
                messages = _.reject(messages, function(mess) {

                    return mess.date === undefined;
                });
                _.each(messages, function(mess) {
                    //Marco si es mio
                    if (mess.sender === id_client) {
                        mess.mine = true;
                    }

                    //Marco si tiene Inicio de dia..

                    if (moment.unix(mess.date).date() !== moment.unix(prev).date()) {
                        mess.day = moment.unix(mess.date);
                    } else {
                        mess.day = false;
                    }
                    prev = mess.date;
                });

                model.set('messages', messages);
                var colOfMessages = new Backbone.Collection(model.get('messages'));

                view = new Views.List({
                    model: model,
                    collection: colOfMessages
                });
                var updateChecks = function() {
                    messages = model.get('messages');

                    _.each(messages, function(mess) {
                        if (!mess.confirm) {

                            mess.confirm = true;
                            view.updateMessageReceived(mess.date);
                        }
                    });
                };
                model.on('change', updateChecks);
                view.on('close', function() {

                    model.off('change', updateChecks);
                });

                view.oid = 'conversation';
                view.id_client = id_client;
                App.mainRegion.slideShow(view, type);
                setTimeout(function() {

                    App.mainRegion.oid = 'chat_' + id_client;
                }, 1000)

                Module.view = view;
                // //LANZAMOS EL SPINNER
                // setTimeout(function() {
                //     // body...
                //     if (!active) {
                //         spinner(true);
                //     }
                // }, 1);
                //Pending a false pk hemos hecho show
                model.save({
                    pending: 0
                });

                view.on('sendmsg', function(msg) {

                    // App.execute('app:map:pend_messages', false);
                    msg.id_swinger = model.id;
                    App.vent.trigger('app:chat:conversation:new_message', msg);
                });

                view.on('back', function() {

                    if (data) {

                        var prev = data.back;
                        if (prev === 'profile') {
                            var mod = {};
                            spinner('true');
                            mod.back = 'map';
                            mod.id_client = data.id_client;
                            App.execute('app:profile:show', 'right', mod);
                            return;
                        } else {
                            App.execute('app:chat', 'right');
                        }
                    } else {

                        if (data !== undefined) {
                            App.execute('app:map', 'right');
                        } else {

                            App.execute('app:chat', 'right');
                        }
                    }
                });
                view.on('quickview', function() {
                    spinner(true);
                    var obj = {
                        back: 'app:chat:conversation',
                        id_client: id
                    };
                    App.execute('app:profile:show', 'left', obj);
                });
                view.on('quickmap', function() {
                    spinner(true);
                    App.execute('app:chat:quickmap', id, 'chat');
                });
                var back = null;
                view.on('openGallery', function() {
                    Module.UploadImg('gallery', view);
                });
                view.on('takePhoto', function() {

                    Module.UploadImg('new', view);

                });
                view.on('send_image', function(pictData) {




                    var mess = {
                        date: moment().unix(),
                        mine: true
                    };

                    view.printImage(pictData, mess);

                    var xhr = App.request('api:new_chat_image', pictData);

                    xhr.onreadystatechange = function() {
                            if (xhr.readyState == 4) {



                                // App.execute('app:map:pend_messages', false);
                                var response = JSON.parse(xhr.responseText).data;
                                var msg = '<img class="js-open-image" src="' + response.route_min + '"  data-src="' + response.route + '" />';
                                mess.message = msg;
                                mess.id_swinger = model.id;
                                App.vent.trigger('app:chat:conversation:new_message', mess);
                                //TODO: Enviar url...
                                // view.sendImage();

                            }
                        }
                        // body...
                });


            };
            Module.UploadImg = function(source, chatView) {
                var self = this;

                var options = {
                    quality: 90,
                    destinationType: Camera.DestinationType.DATA_URL,
                    //targetWidth: 370,
                    encodingType: 0, // 0=JPG 1=PNG
                    correctOrientation: true,
                    targetWidth: 400,
                    targetHeight: 400
                };
                if (source === 'new') {
                    options.sourceType = 1;
                } else {
                    options.sourceType = 0;
                }
                var upld = new Views.ImageUpload({
                    model: self.model
                });
                upld.getPic(options);


                upld.on('new_pict', function(pictData) {
                    chatView.previewImage(pictData);
                });

                upld.on('no_pict_selected', function() {
                    //log.error('@INFORMAR  A DEV: no_pict_selected');
                    //Module.Images('right');
                });
                upld.on('upload', function() {
                    App.execute(ok_action);
                });

                upld.on('back', function() {
                    App.execute('api:cancel_pict');
                    if (!self.locked) {
                        Module.Images('right', ok_action, back);
                    }

                });


            };
            Module.noChatMe = function() {
                var modal = new CommonViews.okModal({
                    model: new Backbone.Model({
                        msg: i18n.t('19_chat.no_chat_me')
                    })
                });
                App.modal.show(modal);
                modal.on('back', function() {
                    App.modal.close();
                });
            };
            Module.noChatThem = function() {
                var modal = new CommonViews.okModal({
                    model: new Backbone.Model({
                        msg: i18n.t('19_chat.no_chat_them')
                    })
                });
                App.modal.show(modal);
                modal.on('back', function() {
                    App.modal.close();
                });
            };

            Module.newMessage = function(data) {

                if (Module.view && Module.view && !Module.view.isClosed) {

                    if (parseInt(data.sender, 10) === parseInt(Module.id, 10) || parseInt(data.receiver, 10) === parseInt(Module.id, 10)) {

                        Module.view.newMessage(data);
                    }
                }
            };

            Module.activateConversation = function() {
                if (Module.view) {

                    spinner(false);
                }
            };

        });

        return App.chat.conversation.controller;

    });
