

define(['App', 'backbone', 'localstorage'], function(App, Backbone) {

    App.module('chat.entities', function(Module, App) {

        Module.userInfo = Backbone.Collection.extend({


            /* define localStorage container for this collection */
            localStorage: new Backbone.LocalStorage('chatList')
        });

        Module.userInfoInstance = new Module.userInfo();
        Module.userInfoInstance.fetch();

        Module.Pending = Backbone.Collection.extend({
            localStorage: new Backbone.LocalStorage('pending_messages')
        });
        Module.pending = new Module.Pending();
        Module.pending.fetch();
        App.reqres.setHandler('entities:chat_list', function() {
            return Module.userInfoInstance;
        });
        App.reqres.setHandler('entities:chat_list_new', function(id_swinger) {

            return Module.userInfoInstance.create({
                id: id_swinger,
                id_swinger: id_swinger,
                nickname: '',
                img: '',
                pending: 0,
                messages: []
            });
        });
        App.reqres.setHandler('entities:pending_messages', function() {
            return Module.pending;
        });

    });
    return App.chat.entities;
});
