

define(['App',
        'underscore',
        'apps/chat/list/views',
        'backbone',
        'i18next',
        'apps/common/views/common_views',
        'apps/common/lib/spinner'
        

    ],
    function(App, _, Views, Backbone, i18n, CommonViews, spinner) {
        App.module('chat.list.controller', function(Module, App) {
            var block;
            Module.addInitializer(function() {
                close = new CommonViews.simpleOkModal({});
                block = App.request('entities:block');
            });


            Module.show = function(type) {

                var list = App.request('entities:chat_list');

                var view;
                if (!Module.ok) {

                    view = new Views.Downloading({
                        model: new Backbone.Model()
                    });
                    view.oid = 'downloading';
                    view.on('back', function() {
                        App.execute('app:map', 'right');
                    });
                    App.mainRegion.slideShow(view, type);
                    return;
                }

                list = list.filter(function(list) {

                    var oneMessage = list.get('messages') !== undefined && list.get('messages').length > 0;
                    var isBlocked = _.find(block.models, function(blocked) {

                        return parseInt(blocked.get('id_swinger_bloqueado'), 10) === parseInt(list.get('id_swinger'), 10);
                    });
                    return oneMessage && !isBlocked;
                });

                list = _.sortBy(list, function(elem) {

                    return elem.get('last_message') * -1;
                });

                _.each(list, function(listItem) {
                    var lastText = listItem.get('last_text');
                    var toReturn = '';
                    if (lastText !== undefined) {
                        toReturn = lastText.split('<br/>').join(' ');
                        toReturn = toReturn.split('<br>').join(' ');
                        if (lastText.search('<img') !== -1) {

                            toReturn = i18n.t('19_chat.newImage');
                        }
                    }
                    listItem.set('last_text_parsed', toReturn);
                });


                view = new Views.List({
                    collection: new Backbone.Collection(list)
                });
                Module.view = view;

                view.on('back', function() {

                    App.execute('app:map', 'right');
                });
                view.on('item:deleted', function(e) {
                    var id_client = e.model.id;
                    Module.Delete(id_client, e.model);
                });
                view.on('item:clicked', function(a, info) {
                   
                        App.execute('app:chat:conversationPayment', info.model.get('id'));
                });
                if (!type) {
                    type = 'left';
                }
                view.oid = 'chat-list';
                App.mainRegion.slideShow(view, type);
                if (!Module.ok) {
                    Module.view.show_download_message();
                }


            };

            Module.startOK = function() {

                Module.ok = true;
                if (App.mainRegion.oid === 'downloading') {
                    //     Module.view.hide_download_message();
                    Module.show();
                }

            };

            Module.Delete = function(id_client, model) {
                var modal;
                var obj = new Backbone.Model();

                obj.set('msg', i18n.t('19_chat.delete'));
                modal = new CommonViews.simpleOkModal({
                    model: obj
                });
                modal.on('ok', function() {
                    spinner(true);
                    App.modal.close();
                    App.request('api:delete-chat', id_client).then(function(res) {
                        $('#item-chat-'+id_client).hide();
                        $('#bgline-item-chat-'+id_client).hide();
                        model.destroy();
                        console.log(model);
                        spinner(false);
                    });
                });
                App.modal.show(modal);
                modal.on('back', function() {

                    App.modal.close();
                });



            };
        });

        return App.chat.list.controller;

    });
