


define(['App',
        'underscore',
        'handlebars',
        'hbs!apps/chat/list/templates/list',
        'hbs!apps/chat/list/templates/item',
        'hbs!apps/chat/list/templates/downloading'


    ],
    function(App, _, Handlebars, list, itemTpl, downloading) {

        App.module('chat.list.views', function(Module, App, Backbone, Marionette) {



            Module.Item = Marionette.ItemView.extend({
                template: itemTpl,
                /*   tagName: 'li',
                className: 'chat_elem',*/

                triggers: {
                    'click .list-item-chat': 'clicked',
                    'click .delete': 'deleted',
                },
                onRender: function() {

                },
                initialize: function() {
                    this.model.bind('all', this.render, this);
                }


            });
            Module.Downloading = Marionette.ItemView.extend({
                template: downloading,
                triggers: {
                    'click .back': 'back'
                }
                /*   tagName: 'li',
                className: 'chat_elem',*/


            });
            Module.List = Marionette.CompositeView.extend({
                template: list,
                itemView: Module.Item,
                itemViewContainer: 'div.container',
                itemViewEventPrefix: 'item',
                oid: 'chat-list',
                triggers: {
                    'click .back': 'back'
                },
                onRender: function() {


                    if (this.collection.length === 0) {
                        this.$el.find('.js-no-messages').show();

                    }

                },
                className: 'chat-list',
                hide_download_message: function() {
                    this.$el.find('.downloading_messages').hide();
                },
                show_download_message: function() {
                    this.$el.find('.downloading_messages').show();
                }

            });
        });

        return App.chat.list.views;
    });
