


define(['App',
        'underscore',
        'handlebars',
        'hbs!apps/chat/quickmap/templates/view',
        'funcs',
        'apps/common/lib/map_style'



    ],
    function(App, _, Handlebars, itemTpl, funcs,mapStyle) {

        App.module('chat.quickmap.views', function(Module, App, Backbone, Marionette) {
            var userInfo = App.request('entities:user_info');


            Module.MapView = Marionette.ItemView.extend({
                template: itemTpl,
                /*   tagName: 'li',
                className: 'chat_elem',*/
                triggers: {
                    'click .back': 'back'
                },
                onShow: function() {

                    var mapOptions = {
                        center: new google.maps.LatLng(this.model.get('lat'), this.model.get('lon')),
                        zoom: 12,
                        //minZoom: 10,
                        disableDefaultUI: true,
                        styles: mapStyle
                    };

                    this.map = new google.maps.Map(document.getElementById('quick_map'), mapOptions);
                    new google.maps.Marker({
                        position: new google.maps.LatLng(parseFloat(this.model.get('lat')), parseFloat(this.model.get('lon'))),
                        map: this.map,
                        icon: 'assets/img/point_2.png'
                    });
                    new google.maps.Marker({
                        position: new google.maps.LatLng(parseFloat(userInfo.get('lat')), parseFloat(userInfo.get('lon'))),
                        map: this.map,
                        icon: 'assets/img/p.png'
                    });
                    funcs.gmapHomeControl(this.map, google.maps.ControlPosition.RIGHT_BOTTOM);



                },
                initialize: function() {
                    this.model.bind('all', this.render, this);
                }


            });

        });

        return App.chat.quickmap.views;
    });
