

define(['App', 'underscore', 'backbone', 'localstorage'], function(App, _) {

    App.module('common.entities.twilight', function(Module, App, Backbone) {
        this.startWithParent = false;

        Module.twilight = Backbone.Model.extend({
            localStorage: new Backbone.LocalStorage('twilight')

        });

        App.vent.on('app:logged', function() {
            Module.start();
        });

        Module.twilightInstance = new Module.twilight({
            id: 1
        });
        Module.twilightInstance.fetch();

        Module.getZones = function() {
            var userInfo = App.request('entities:user_info');
            if (userInfo.get('logged')) {
                App.request('api:get_tzones')
                    .then(function(list) {


                        list = JSON.parse(list);


                        var geocoder = new google.maps.Geocoder();

                        _.each(list, function(l) {
                            if (!Module.twilightInstance.get(l.id_zone)) {

                                geocoder.geocode({
                                    location: new google.maps.LatLng(parseFloat(l.lat), parseFloat(l.lon))
                                }, function(results, status) {
                                    var obj = {};
                                    var name;


                                    if (status === google.maps.GeocoderStatus.OK) {
                                        name = results[0].formatted_address;
                                    }

                                    obj[l.id_zone] = {
                                        lat: l.lat,
                                        lon: l.lon,
                                        name: name
                                    };



                                    Module.twilightInstance.set(obj);
                                    Module.twilightInstance.save();
                                });
                            }
                        });
                    });
            }

        };

        Module.addInitializer(function() {

            Module.getZones();
            Module.started = true;

        });



        App.reqres.setHandler('entities:twilight', function() {
            if (!Module.started) {
                //No hauria de passar
                Module.getZones();
            }
            return Module.twilightInstance;
        });

    });
    return App.common.entities.twilight;
});
