
define(['jquery',
    'App',
    'backbone',
    'apps/common/views/common_views',
    'i18next',
    'apps/common/lib/spinner', 'log',
    'underscore'
], function($, App, Backbone, Common, i18n, spinnerFunc, log, _) {
    var userInfo = App.request('entities:user_info');

    var funcs = {

        addError: function(field, text) {
            $(document).find(field).addClass('error');
            if ($('.errortext').length === 0) {
                $('.form-margin').append('<div class="errortext error" style="width: 90%;margin: 0 auto 10px;">' + text + '</div>');
            }
            //$(document).find(field).after('<span></span>');
            //$(document).find(field + ',' + field + '+span').addClass('error');
            //$(document).find(field + '+span').text(text);

        },

        clearError: function() {
            //$(document).find('span.error').remove();
            if ($('.errortext').length === 1) {
                $('.form-margin .errortext').remove();
            }
            $(document).find('.error').removeClass('error');
        },
        spinner: spinnerFunc,
        errorView: function(error_name, trigger) {

            if (i18n.t('def_errors.' + error_name + '.message') === 'def_errors.' + error_name + '.message') {
                log.error('Em falta l\'error :' + error_name);
            }


            var error = new Backbone.Model();
            var errorInfo = {
                msg: i18n.t('def_errors.' + error_name + '.message'),

                menu_title: i18n.t('def_errors.' + error_name + '.menu_title'),

                body: i18n.t('def_errors.' + error_name + '.info')
            };


            error.set(errorInfo);
            var errorView = new Common.ErrorView({
                model: error
            });


            errorView.on('back', function() {
                App.execute(trigger, 'right');
            });
            App.mainRegion.slideShow(errorView, 'left');


        },
        gmapHomeControl: function(map, position, action) {


            var controlDiv = document.createElement('div');
            controlDiv.style.padding = '5px';
            // Set CSS for the control border
            var controlUI = document.createElement('div');
            controlUI.style.cursor = 'pointer';
            controlUI.style.width = '32px';
            controlUI.style.height = '32px';
            controlUI.style.backgroundImage = 'url(\'assets/img/center.png\')';
            controlUI.title = 'Go Home';
            $(controlUI).css('margin-bottom', '10px');
            controlDiv.appendChild(controlUI);

            google.maps.event.addDomListener(controlDiv, 'click', function() {
                action();
                //map.panTo(new google.maps.LatLng(userInfo.get('lat'), userInfo.get('lon')));
            });
            map.controls[position].push(controlDiv);


        },
        gmapWall: function(map, position, action) {


            var controlDiv = document.createElement('div');

            controlDiv.classList.add('map-wall');
            // Set CSS for the control border
            var controlUI = document.createElement('i');
            controlUI.style.cursor = 'pointer';
            controlUI.style.width = '32px';
            controlUI.style.height = '32px';
            controlUI.classList.add('icon-wall');
            //controlUI.style.backgroundImage = 'url(\'assets/img/center.png\')';
            controlUI.title = 'Go Home';
            $(controlUI).css('margin-bottom', '10px');
            controlDiv.appendChild(controlUI);

            google.maps.event.addDomListener(controlDiv, 'click', function() {
                App.execute('app:wall');
                //map.panTo(new google.maps.LatLng(userInfo.get('lat'), userInfo.get('lon')));
            });
            map.controls[position].push(controlDiv);


        },
        gmapVisibility: function(map, position) {


            var controlDiv = document.createElement('div');
            $(controlDiv).addClass('visible').css('display', 'none');
            controlDiv.style.padding = '5px';
            // Set CSS for the control border
            var controlUI = document.createElement('div');
            controlUI.style.cursor = 'pointer';
            controlUI.style.width = '40px';
            controlUI.style.height = '39px';
            controlUI.style.backgroundImage = 'url(\'assets/img/orange_hidden.png\')';
            controlUI.title = 'Go Home';
            controlDiv.appendChild(controlUI);


            map.controls[position].push(controlDiv);


        },
        gmapLoading: function(map, position) {


            var controlDiv = document.createElement('div');
            $(controlDiv).attr('style', 'padding:5px;z-index:0;position:absolute;right:50%;width:40px;height:40px;top:110px!important');
            // Set CSS for the control border
            $(controlDiv).append('<img src="assets/img/loading_map.gif" class="map_spinner" width="40" height="40">');
            /*var controlUI = document.createElement('div');
            controlUI.style.cursor = 'pointer';
            controlUI.style.width = '40px';
            controlUI.style.height = '39px';
            controlUI.style.backgroundImage = 'url(\'assets/img/orange_hidden.png\')';
            controlUI.title = 'Go Home';
            controlDiv.appendChild(controlUI);*/

            google.maps.event.addDomListener(controlDiv, 'click', function() {
                map.panTo(new google.maps.LatLng(userInfo.get('lat'), userInfo.get('lon')));
            });
            map.controls[position].push(controlDiv);


        },
        gmapPlusMinus: function(map, position) {


            var controlDiv = document.createElement('div');
            controlDiv.style.padding = '5px';
            // Set CSS for the control border
            var controlUI = document.createElement('div');
            controlDiv.style.width = '50px;';
            controlDiv.index = 1;

            controlUI.style.cursor = 'pointer';
            controlUI.style.width = '50px';
            controlUI.style.height = '50px';
            controlUI.style.backgroundRepeat = 'no-repeat';
            controlUI.style.backgroundPosition = 'center center';
            controlUI.style.marginBottom = '20px;';
            controlUI.style.backgroundImage = 'url(\'assets/img/plus.png\')';
            controlUI.title = 'Go Home';
            $(controlUI).css('margin-bottom', '20px');
            controlDiv.appendChild(controlUI);

            google.maps.event.addDomListener(controlUI, 'click', function() {
                map.setZoom(map.getZoom() + 1);
            });
            map.controls[position].push(controlDiv);


            // Set CSS for the control border
            var controlUI2 = document.createElement('div');
            controlUI2.style.cursor = 'pointer';
            controlUI2.style.width = '50px';
            controlUI2.style.height = '50px';
            controlUI2.style.backgroundRepeat = 'no-repeat';
            controlUI2.style.backgroundImage = 'url(\'assets/img/minus.png\')';
            controlUI2.style.backgroundRepeat = 'no-repeat';
            controlUI2.style.backgroundPosition = 'center center';
            controlUI2.title = 'Go Home';
            controlDiv.appendChild(controlUI2);

            google.maps.event.addDomListener(controlUI2, 'click', function() {
                map.setZoom(map.getZoom() - 1);
            });
            map.controls[position].push(controlDiv);


        },
        toggle: function() {

        },
        getPictStatus : function(data) {
            if (data.imgs.length === 0) {
                return 'photo_ko';
            }
            // var stats = {
            //     'v_-1': 'photo_ko',
            //     'v_0': 'photo_upload',
            //     'v_1': 'photo_ok'
            // };

            //Buscamos una que sea valida,

            var resp = _.find(data.imgs, function(img) {

                if (img.validation === 1) {

                    return true;
                }
                return false;
            });
            if (!resp) {
                resp = _.find(data.imgs, function(img) {

                    if (img.validation === 0) {

                        return true;
                    }
                    return false;
                });
                if (resp) {
                    return 'photo_upload';
                } else {
                    return 'photo_ko';
                }

                //Sino buscamos una que sea pend_upload
            } else {
                return 'photo_ok';
            }

            //sino invalida

        }
    };
    return funcs;

});
