


define(['App',
        'underscore',
        'handlebars',
        'hbs!apps/favorites/templates/list',
        'hbs!apps/favorites/templates/item'

    ],
    function(App, _, Handlebars, list, itemTpl) {

        App.module('favorites.favorites.views', function(Module, App, Backbone, Marionette) {



            Module.Item = Marionette.ItemView.extend({
                template: itemTpl,

               
                triggers: {
                    'click .nextarrow': 'view_profile',
                    'click .list-remove': 'remove'
                },
                events:{
                    'click .list-check':'toggleCheck'
                },

                toggleCheck: function() {
                    this.$('.list-check .inner').toggleClass('active');
                    this.$('.list-remove').toggleClass('active');
                   
                }


            });
            Module.List = Marionette.CompositeView.extend({
                template: list,
                itemView: Module.Item,
                className: 'favorites',
                itemViewContainer: 'div.elems',
                itemViewEventPrefix: 'item',
                triggers: {
                    'click .back': 'back'

                },
                events:{
                    'click .edit':'editMode'
                },
                editMode: function() {
                   this.$('.list-check').toggleClass('hidden');
                   this.$('.list-remove').removeClass('active');
                }

            });
        });

        return App.favorites.favorites.views;
    });
