


define(['App',
        'underscore',
        'handlebars',
        'hbs!apps/invite/templates/invite',
        'validator',
        'funcs',
        'i18next'

    ],
    function(App, _, Handlebars, inviteTPL, validator, funcs, i18n) {

        App.module('invite.views', function(Module, App, Backbone, Marionette) {



            Module.Info = Marionette.ItemView.extend({
                template: inviteTPL,

                className: 'list-item',
                triggers: {
                    'click .back': 'back'
                },
                events: {
                    'focus input':'clear',
                    'click .send-invite': 'invite'
                },
                clear: function(){
                    this.$el.find('div.error').remove();
                    funcs.clearError();
                },
                invite: function(e) {
                    e.preventDefault();
                    this.clear();
                    var mail = this.$el.find('input[name="friendmail"]').val();
                    if (validator.isEmail(mail)) {

                        this.trigger('invite', mail);
                    }else{
                        this.$el.find('input[name="friendmail"]').after('<div style="width:90%; margin:0 auto;" class="error">'+i18n.t('2_register.mailerror')+'</div>');
                        funcs.addError('input[name="friendmail"]', i18n.t('2_register.mailerror'));

                    }
                }


            });
        });

        return App.invite.views;
    });
