

// Modulo tonto para gestionar la localizacxion
define(['App',
    'underscore',
    'funcs',
    'log',
    'moment',
    'jquery'

], function(App, _, funcs, log, moment, $) {
    var intervalTime = 5;

    var setAccuracy = function(accuracy) {

        if(accuracy < 15){
            intervalTime = 90;
        }
        else if ( accuracy < 50){
            intervalTime = 40;
        }
        else if( accuracy< 100){
            intervalTime = 15;
        }

        //intervalTime = 5;
    };
    var lastUpdate = moment();
    App.module('location_manager', function(Module, App) {
        this.startWithParent = false;
        App.vent.on('app:logged', function() {

            Module.start();
        });
        var userInfo,
            twZones;
        Module.addInitializer(function() {
            userInfo = App.request('entities:user_info');

            twZones = App.request('entities:twilight');

        });

        var updateFuncs = {
            //@param center --> maps.LatLng;
            //returns {lat:1.234, lon:2.34}
            generateRandomPoint: function(center, deep, callback) {

                var  latLon = google.maps.geometry.spherical.computeOffset(center, 1000, _.random(0, 360));

                if (deep === 4) {
                    //PROFUNDIDAD MAXIMA..
                    return callback({
                        lat: latLon.lat(),
                        lon: latLon.lng()
                    });
                } else {

                    var geocoder = new google.maps.Geocoder();
                    geocoder.geocode({
                        location: center
                    }, function(results) {

                        if (results === null || results.length === 0) {

                            updateFuncs.generateRandomPoint(center, deep + 1, callback);
                        } else {
                            var ok = false;
                            _.each(results, function(result) {
                                if (result.location_type !== 'APROXIMATE') {

                                    _.each(result.types, function(type) {
                                        if (type === 'country') {
                                            ok = true;
                                        }
                                    });
                                }
                            });
                            if (ok) {
                                return callback({
                                    lat: latLon.lat(),
                                    lon: latLon.lng()
                                });
                            } else {
                                updateFuncs.generateRandomPoint(center, deep + 1, callback);
                            }
                        }

                    });

                }


            },
            //@param myPosition --> maps.LatLng
            //returns twilight LatLon
            isInTW: function(myPosition) {

                var inTwilight = false;

                _.each(twZones.attributes, function(attr) {

                    if (typeof attr === 'object' && attr.active) {

                        var twlatlon = new google.maps.LatLng(parseFloat(attr.lat), parseFloat(attr.lon));
                        var circle = new google.maps.Circle({
                            center: twlatlon,
                            radius: 1000
                        });

                        if (circle.getBounds().contains(myPosition)) {

                            inTwilight = twlatlon;

                        }
                    }

                });


                return inTwilight;

            },
            //@param position navigation coord.
            //returns {lat:1.234, lon:2.3456}
            getMyPoint: function(position, callback) {

                var myPosition = new google.maps.LatLng(parseFloat(position.coords.latitude), parseFloat(position.coords.longitude));
                //Comprovar si esta dintre de zona de twilight
                var inTwilight = updateFuncs.isInTW(myPosition);
                if (inTwilight) {


                    return updateFuncs.generateRandomPoint(myPosition, 0, function(point) {
                        point.inTwilight = true;
                        return callback(point);
                    });
                } else {

                    return callback({
                        lat: position.coords.latitude,
                        lon: position.coords.longitude,
                        inTwilight: false
                    });
                }

            },
            saveMyPoint: function(info) {
                userInfo.set(info);
                userInfo.save();
                App.execute('app:map:set_my_center', info.lat, info.lon, ({
                    active: info.inTwilight,
                    lat: info.lat,
                    lon: info.lon
                }));

                App.request('api:position', info).then(function() {
                    
                });
            }
        };
        setInterval(function() {

            //Test
            $('.tooolbar').css('top', '0.1px');
            $('.tooolbar').css('top', '0px');

        }, 1000);
        var updatePosition = function(force, center, die) {


            if(!force && moment().diff(lastUpdate, 'seconds') < intervalTime){
                //No fem res.

                return;
            }

            lastUpdate = moment();
            //Si esta oculto // NO ACTUALIZAMOS
            if (userInfo.get('visibility')) {

                App.execute('app:profile:visibility');

            } else {


                var search = App.request('entities:search');

                //SI NO ESTAMOS EN CITY..
                if (!search.get('city')) {

                    if (!force) {

                        //Buscamos la posicion

                        navigator.geolocation.getCurrentPosition(function(position) {

                            
                            setAccuracy(position.coords.accuracy);
                            
                            updateFuncs.getMyPoint(position, function(info) {

                                if(userInfo.get('inTwilight') === false ||  userInfo.get('inTwilight') !== info.inTwilight){
                                    

                                    if(info.lat !== userInfo.get('lat') || info.lon !== userInfo.get('lon')){
                                        var txt = 'nova posicio:'+ position.coords.latitude+ ' --- '+ position.coords.longitude+' --- ACCURACY -->'+ position.coords.accuracy+' m';
                                        
                                        updateFuncs.saveMyPoint(info);
                                    }
                                }

                            });
                        }, function(err) {

                            //REINTENTAMOS pero si no la encontramos morimos
                                if(!die){
                                    updatePosition(force, center, true);
                                }
                        }, {
                            maximumAge: 10000,
                            timeout: 10000,
                            enableHighAccuracy:true
                        });
                    } else {
                        //FORZADA
                        var obj = {
                            coords: {
                                latitude: userInfo.get('lat'),
                                longitude: userInfo.get('lon')
                            }
                        };

                        updateFuncs.getMyPoint(obj, function(info) {
                            updateFuncs.saveMyPoint(info);
                            if(center){
                                App.execute('app:map:update_center');
                            }
                        });
                    }
                }
            }
        };
        this.startWithParent = false;


        App.vent.on('app:logged', function() {
            Module.start();
        });
        //INICIO DE LA APP
        Module.addInitializer(function() {
            userInfo.set('inTwilight', false);
            navigator.geolocation.getCurrentPosition(function(position) {


                var info = {
                    lat: position.coords.latitude,
                    lon: position.coords.longitude
                };
                userInfo.set(info);
                userInfo.save();
                //setAccuracy(position.coords.accuracy);
                updatePosition(true, true);
                //App.execute('app:map:update_center');
                
            }, function() {
               

                //Plugin que te localiza por ip
                $.getJSON('http://www.geoplugin.net/json.gp?jsoncallback=?', function(data) {

                    userInfo.set('lat', data.geoplugin_latitude);
                    userInfo.set('lon', data.geoplugin_longitude);
                    App.execute('app:map:update_center');
                    var info = {
                        lat: data.geoplugin_latitude,
                        lon: data.geoplugin_longitude
                    };
                    App.request('api:position', info).then(function() {

                        App.execute('app:map:set_my_center', info.lat, info.lon, info);
                    });

                });
            }, {
                //maximumAge: 3000,
                timeout: 15000,
                 enableHighAccuracy: true
            });




            //Update posititon cada minuto..
            setInterval(updatePosition,
                
                5*1000
                //intervalTime * 1000
                
            );


        });
        App.commands.setHandler('app:location_manager:force_reload', function() {

            updatePosition(true);

        });
        return App.location_manager;

    });
});
