

define(['App',
    'apps/login/main/controller',
    'apps/login/edit_data/controller',
    'apps/login/picture/controller',
    'apps/login/register/controller'
], function(App, LoginController, EditController, PictureController, RegisterController) {

    App.module('login', function(Module, App, Backbone, Marionette) {

        var actions = {
            login: function() {

                LoginController.show();
            }

        };

        Module.Router = Marionette.AppRouter.extend({
            controller: actions,
            appRoutes: {
                '/': 'login'
            }
        });

        App.commands.setHandler('show_login', function(type) {
            if (!type) type = 'left';
            LoginController.show(type);

        });


        App.commands.setHandler('logged_ok', function(type) {

            if (!type) type = 'left';
            //EL BUENO

            if (!type) type = 'left';
            EditController.fetchUser(type);

        });


        App.commands.setHandler('pict_ok', function(type) {

            if (!type) type = 'left';
            EditController.fetchUser(type);

        });
        App.commands.setHandler('app:show_register', function(type) {

            if (!type) type = 'left';
            RegisterController.show(type);
        });
        App.commands.setHandler('edit_data_ok', function(type) {

            if (!type) type = 'left';
            App.vent.trigger('app:logged');


        });

        App.commands.setHandler('registered_ok', function() {

            PictureController.show('left');
        });
        App.commands.setHandler('show_picture', function(obj) {

            PictureController.show('left', obj);
        });
         App.commands.setHandler('app:exit', function() {
            LoginController.closeapp();
        });
        Module.addInitializer(function() {

            Module.router = new Module.Router();
        });
        Module.start();


    });
    return App.login;

});
