


define(['App',
        'underscore',
        'apps/login/edit_data/views',
        'apps/common/views/common_views',
        'syphon',
        'moment',
        'funcs',
        'apps/common/lib/constants',
        'backbone',
        'i18next'


    ],
    function(App, _, Views, Common, Syphon, moment, funcs, CONS, Backbone, i18n) {
        App.module('login.edit_data.controller', function(Module, App) {


            var userInfo;
            Module.addInitializer(function() {
                userInfo = App.request('entities:user_info');

            });
            Module.fetchUser = function() {
                funcs.spinner(true);


                var profile = App.request('entities:profile');

                if (!profile.get('id_client')) {


                    var user = App.request('api:get_user', null, null, userInfo.get('email'));
                    user.then(function(data) {
                        data = JSON.parse(data);

                        profile.set(data.data);
                        funcs.spinner(false);
                        Module.checkErrors(profile);
                        profile.save();

                    });
                } else {
                    Module.checkErrors(profile);
                }


            };
            Module.checkErrors = function(profile) {
                var data = profile.toJSON();



                if (!profile.get('id_pais_residencia') || profile.get('id_pais_residencia') !== data.id_pais_residencia) {
                    profile.set('id_pais_residencia', data.id_pais_residencia);
                }
                if (!profile.get('edad_he') || profile.get('edad_he') !== data.edad_he) {
                    profile.set('edad_he', data.edad_he);
                }
                if (!profile.get('edad_she') || profile.get('edad_she') !== data.edad_she) {
                    profile.set('edad_she', data.edad_she);
                }
                if (!profile.get('id_tipo_relacion') || profile.get('id_tipo_relacion') !== data.id_tipo_relacion) {
                    profile.set('id_tipo_relacion', data.id_tipo_relacion);
                }
                if (!profile.get('langs') || profile.get('langs') !== data.langs) {
                    profile.set('langs', data.langs);
                }
                if (!profile.get('imgs') || profile.get('imgs') !== data.imgs) {
                    profile.set('imgs', data.imgs);
                }
                profile.set('profile_image', userInfo.get('profile_image'));
                profile.save();
                //userInfo.save();


                // profile.set('user_type', 1);


                var errors = false;
                if (parseInt(profile.get('id_pais_residencia'), 10) === 0) {


                    errors = true;

                }

                if (userInfo.get('forceSingle')) {

                    if (!moment(profile.get('edad_he'), 'YYYY-MM-DD').isValid() && parseInt(profile.get('user_type'), 10) === 0) {


                        errors = true;
                    }
                    if (!moment(profile.get('edad_she'), 'YYYY-MM-DD').isValid() && parseInt(profile.get('user_type'), 10) === 0) {


                        errors = true;
                    }
                }
                if (parseInt(profile.get('id_tipo_relacion'), 10) === 0) {


                    errors = true;
                }
                if (!profile.get('langs') || profile.get('langs').length === 0) {


                    errors = true;

                }


                if (errors) {

                    Module.show('left');
                    App.execute('app:update_mandatory_show');
                    return;

                } else {

                    App.execute('edit_data_ok');

                }
            };

            Module.show = function(type) {
                if (typeof cordova !== 'undefined') {

                    if (device.platform === 'iOS') {
                        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
                    } else {
                        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    }
                }
                var countries = [];
                var langs = [];
                var relationship = [];
                for (var i = 1; i <= 239; i++) {
                    countries.push({
                        id_country: i,
                        printable_name: i18n.t('countries.c_' + i)
                    });
                    if (i <= 187) {
                        langs.push({
                            id_lang: i,
                            selfname: i18n.t('langs.l_' + i)
                        });
                    }
                    if (i <= 6) {
                        relationship.push({
                            id_tipo_relacion: i,
                            tipo_relacion: i18n.t('tipo_relacion.id_tipo_relacion_' + i)
                        });
                    }

                }
                //Ordenacion de lenguas
                langs = _.sortBy(langs, function(el) {
                    return el.selfname;
                });

                var profile = App.request('entities:profile');


                profile.set('relationship', relationship);
                profile.set('paises', countries);
                profile.set('idiomas', langs);
                if (profile.get('imgs')) {
                    profile.set('img', profile.get('imgs')[0]);
                } else {
                    profile.set('img', false);
                }

                var menu = {
                    title: 'Editar Campos Básicos'
                };

                profile.set('menu', menu);



                var editView = new Views.Edit({
                    model: profile
                });

                App.mainRegion.slideShow(editView, type);

                editView.on('confirmSingle', function() {

                    var singleModal = new Views.SingleModal({
                        model: new Backbone.Model({
                            msg: i18n.t('17_profile.single_warning'),
                            acceptButton: i18n.t('app.continue_single')
                        })
                    });

                    App.modal.show(singleModal);

                    singleModal.on('cancel', function() {
                        App.modal.close();
                    });
                    singleModal.on('accept', function() {
                        App.modal.close();
                        editView.isSingle();
                    });

                });

                editView.on('register', function() {
                    var data = Syphon.serialize(this);
                    data.edad_she_sel = $('div[data-name=edad_she_sel]').text();
                    data.edad_he_sel = $('div[data-name=edad_he_sel]').text();
                    data.edad_she = moment(data.edad_she_sel, 'MM/DD/YYYY').format('YYYY-MM-DD');
                    data.edad_he = moment(data.edad_he_sel, 'MM/DD/YYYY').format('YYYY-MM-DD');

                    userInfo.set('registeredAs', 0);

                    if (data.edad_he.toLowerCase() === 'invalid date') {
                        data.edad_he = null;
                        data.edad_he_sel = null;
                        data.isSingle = true;
                        data.isWoman = true;
                        userInfo.set('registeredAs', 1);
                        userInfo.set('originalRegisteredAs', 1);
                    }
                    if (data.edad_she.toLowerCase() === 'invalid date') {
                        data.edad_she = null;
                        data.edad_she_sel = null;
                        data.isSingle = true;
                        data.isMan = true;
                        userInfo.set('registeredAs', 2);
                        userInfo.set('originalRegisteredAs', 2);
                    }

                    var newData = profile;
                    newData.set(data);
                    newData.save();
                    //var dataOld = data;

                    //Em registro com a:

                    userInfo.save();




                    funcs.spinner(true);
                    App.request('api:edit_user', newData).then(function(res) {
                        var data = JSON.parse(res);
                        if (typeof cordova !== 'undefined') {

                            //cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                        }
                        if (data.response === 'OK') {

                            App.execute('edit_data_ok');

                            //userInfo.set('email', dataOld.email);
                            //userInfo.save();
                            //userInfo.set('email', data.email);

                        } else {

                            funcs.errorView(data.message, 'pict_ok');
                        }

                    });
                });


            };


        });



        return App.login.edit_data.controller;

    });
