

define(['App',
    'underscore',
    'hbs!apps/login/edit_data/templates/edit',
    'hbs!apps/common/views/templates/modals/accept-cancel',
    'funcs',
    'i18next',
    'moment'
], function(App, _, mainTpl, singleModalTpl, funcs, i18n, moment) {
    App.module('login.edit_data.views', function(Module, App, Backbone) {

        //var main = Handlebars.compile(mainTpl);
        Module.Edit = Backbone.Marionette.ItemView.extend({
            template: mainTpl,
            events: {
                'click button.submit': 'validate',
                'submit': 'validatr',
                'focus input,select': 'clearError',
                'change select': 'changeInp',
                'focusout select': 'changeInp',
                'click div[data-name="edad_she_sel"]': 'changeShe',
                'click div[data-name="edad_he_sel"]': 'changeHe'

            },

            changeInp: function(e) {

                e.preventDefault();
                var $sel = $(e.target);
                var $inp = $('div[data-name="' + $sel.attr('name') + '_sel"]');


                if (typeof $sel.val() === 'object') {

                    var arr = [];
                    _.each($sel.val(), function(op, i) {

                        arr[i] = $sel.find('option[value=' + op + ']').text();
                    });
                    arr = arr.join(', ');
                    $inp.html(arr);
                } else {
                    $inp.text($sel.find('option:selected').text());
                }

            },
            hasChangedC: false,
            hasChangedL: false,
            hasChangedR: false,
            triggers: {
                'click .back': 'back',
                'click img.imageupload': 'imageupload'

            },
            triggerCountry: function(e) {
                e.preventDefault();
                var self = this;
                if (this.$('select[name="id_pais_residencia"]').find('option').eq(0).is(':selected') && !self.hasChangedC) {
                    self.changeCountry(e);
                }
            },
            changeCountry: function(e) {
                e.preventDefault();
                var option = parseInt($(e.target).val(), 10);
                var select = this.$el.find('select[name="id_pais_residencia"] option:eq(' + (option - 1) + ')').html();

                this.$el.find('input[name="id_pais_residencia_sel"]').val(select);
                this.hasChangedC = true;

            },
            triggerRel: function(e) {
                e.preventDefault();
                var self = this;
                if (this.$('select[name="id_tipo_relacion"]').find('option').eq(0).is(':selected') && !self.hasChangedR) {
                    self.changeRel(e);
                }
            },
            changeRel: function(e) {
                e.preventDefault();

                var option = parseInt($(e.target).val(), 10);
                var select = this.$el.find('select[name="id_tipo_relacion"] option:eq(' + (option - 1) + ')').html();

                this.$el.find('input[name="id_tipo_relacion_sel"]').val(select);
                this.hasChangedR = true;

            },
            changeDate: function(name) {

                var self = this;
                var options = {
                    date: new Date(),
                    mode: 'date'
                };

                // if (typeof cordova === 'undefined') {
                //     var datePicker = {
                //         show: function(options, cb) {

                //             cb(moment('01/09/1991', 'DD/MM/YYYY'));
                //         }
                //     }

                // }
                datePicker.show(options, function(date) {

                    if (moment(date).isValid()) {
                        var val = moment(date).format('MM/DD/YYYY');
                        self.$el.find('div[data-name="' + name + '"]').text(val);
                        // if (self.$('.errortext').length > 0) {

                        //     self.validate();
                        // }

                    }

                });
            },
            changeShe: function(e) {
                this.changeDate('edad_she_sel');
                e.preventDefault();


            },
            changeHe: function(e) {
                this.changeDate('edad_he_sel');
                e.preventDefault();
            },
            onRender: function() {
                this.shePlaceholder = this.$el.find('div[data-name="edad_she_sel"]').text();
                this.hePlaceholder = this.$el.find('div[data-name="edad_he_sel"]').text();
            },

            validate: function(e, forcevalidate) {
                if (e) {
                    e.preventDefault();
                }
                var esMenor = function(date) {
                    var age = moment(date);

                    return moment().diff(age, 'years') < 18;
                };
                funcs.clearError();
                var errors = false;

                var she = this.$el.find('div[data-name="edad_she_sel"]').text();
                var he = this.$el.find('div[data-name="edad_he_sel"]').text();
                var id_pais_residencia = this.$el.find('select[name="id_pais_residencia"]').val();
                var id_tipo_relacion = this.$el.find('select[name="id_tipo_relacion"]').val();
                var langs = this.$el.find('select[name="langs"]').val();

                if (!langs || parseInt(langs, 10) === 0) {
                    errors = true;
                    funcs.addError('div[data-name="langs_sel"]', i18n.t('2_register.mandatory'));
                }
                if (!id_pais_residencia || parseInt(id_pais_residencia, 10) === 0) {
                    errors = true;
                    funcs.addError('div[data-name="id_pais_residencia_sel"]', i18n.t('2_register.mandatory'));
                }
                if (!id_tipo_relacion || parseInt(id_tipo_relacion, 10) === 0) {
                    errors = true;
                    funcs.addError('div[data-name="id_tipo_relacion_sel"]', i18n.t('2_register.mandatory'));
                }

                if (she === this.shePlaceholder && he === this.hePlaceholder) {
                    errors = true;
                    funcs.addError('div[data-name="edad_she_sel"]', i18n.t('2_register.mandatory')); //TODO: Canviar error
                }

                if (she !== this.shePlaceholder && esMenor(she)) {
                    errors = true;
                    funcs.addError('div[data-name="edad_she_sel"]', i18n.t('2_register.adult'));
                }
                if (he !== this.hePlaceholder && esMenor(he)) {
                    errors = true;
                    funcs.addError('div[data-name="edad_he_sel"]', i18n.t('2_register.adult'));
                }

                if (!errors && ((he === this.hePlaceholder && she !== this.shePlaceholder) || (she === this.shePlaceholder && he !== this.hePlaceholder)) && !forcevalidate) {
                    this.trigger('confirmSingle');
                    return;
                }


                if ((!errors && e) || (!errors && forcevalidate))  {

                    this.trigger('register', this);
                }

            },
            isSingle: function() {
                this.validate(null, true);
            },
            clearError: function() {
                funcs.clearError();
            }
        });
        Module.SingleModal = Backbone.Marionette.ItemView.extend({
            template: singleModalTpl,
            triggers: {
                'click .js-cancel': 'cancel',
                'click .js-accept': 'accept'

            }
        });


    });

    return App.login.edit_data.views;

});
