


define(['App',
        'apps/login/main/views',
        'funcs',
        'md5',
        'validator',
        'moment',
        'apps/common/lib/constants',
        'apps/common/views/common_views',
        'i18next',
        'underscore',
        'apps/common/lib/spinner'
    ],
    function(App, Views, funcs, md5, validator, moment, CONS, CommonViews, i18n, _,spinner) {
        App.module('login.main.controller', function(Module, App, Backbone) {

            //Muestra el formulario de login...
            var userInfo;
            var profile;
            Module.addInitializer(function() {
                userInfo = App.request('entities:user_info');
                profile = App.request('entities:profile');
            });

            Module.renderView = function(type) {

                var view = new Views.Login({
                    model: userInfo
                });

                Module.preloadLayout = view;
                Module.preloadLayout.oid = 'login';


                App.mainRegion.slideShow(Module.preloadLayout, type);

                //Events LoginTPL

                view.on('submit', function(email, passwd) {

                    if (passwd === '') {
                        view.setPassError(0);
                    } else if (passwd.length < 4) {
                        view.setPassError(1);
                    } else {
                        userInfo.set('remember', false);
                        userInfo.save();
                        Module.login(email, passwd);
                        //App.execute('app:login_ok', email, passwd);
                    }

                });
                view.on('remember', function(email, passwd) {

                    if (passwd.length < 4) {
                        view.setPassError();
                    } else {
                        userInfo.set('remember', true);
                        userInfo.save();


                        Module.login(email, passwd);
                        //App.execute('app:login_ok', email, passwd);
                    }

                });

                //Events registre
                view.on('register', function() {
                    App.commands.execute('app:show_register');

                });
                view.on('forgotten', function() {
                    Module.RememberPass();
                });
            };
            Module.show = function(type) {



                //Rememberme
                if (userInfo.get('remember')) {

                    Module.login(userInfo.get('email'), null, userInfo.get('passwd'));
                    return;

                }

                //Comprovem que no hagi canviat el nickname des d'un altre mobil...
                if (userInfo.get('logged_val')) {

                    App.request('api:get_user', userInfo.get('id_swinger'), true)
                        .then(function(data) {
                            data = JSON.parse(data).data;
                            if (data && data !== undefined) {


                                if (userInfo.get('logged_val') !== data.nickname || userInfo.get('logged_val') !== data.email) {
                                    userInfo.set('logged_val', data.nickname);
                                    userInfo.save();
                                }
                                Module.renderView(type);
                            } else {
                                userInfo.set(null);
                                userInfo.save();
                                Module.renderView(type);
                            }
                        });

                } else {

                    Module.renderView(type);
                }
            };
            Module.closeapp = function() {
                var obj = new Backbone.Model();
                obj.set('msg', i18n.t('app.close-confirm'));
                var modal = new CommonViews.simpleOkModal({
                    model: obj
                });
                App.modal.show(modal);
                modal.on('back', function() {
                    App.modal.close();
                });
                modal.on('ok', function() {

                    navigator.app.exitApp();
                });
            };

            //El login per si
            Module.login = function(email, passwd, md5p) {


                if (!md5p) {
                    userInfo.set('passwd', md5(passwd));
                }
                userInfo.save();
                funcs.spinner(true);
                var login;
                if (md5p) {
                    login = App.request('api:login', email, md5p);
                } else {

                    login = App.request('api:login', email, md5(passwd));
                }

                login.then(function(data) {
                    var response = JSON.parse(data);
                    if (response.response === 'KO') {
                        userInfo.set('logged_val', false);
                        userInfo.set('remember', false);
                        if (response.message !== 'error_login_wrong_pass') {

                            userInfo.set('passwd', null);
                            userInfo.set('logged', false);

                            userInfo.save();
                        } else {
                            userInfo.set('logged', true);
                        }

                        funcs.errorView(response.message, 'show_login');




                    } else {

                        userInfo.set('email', response.message.email);
                        userInfo.set('logged', true);
                        userInfo.set('logged_val', email);
                        userInfo.set(response.data);
                        userInfo.set('id_swinger', response.message.id_swinger);
                        userInfo.save();

                        var user = App.request('api:get_user', response.message.id_swinger);


                        user.then(function(data) {

                            data = JSON.parse(data);
                            Module.notifyUserChange(response, data);

                        });
                    }
                    userInfo.save();
                });

            };
            Module.notifyUserChange = function(response, data) {

                var registeredAs = parseInt(userInfo.get('registeredAs'), 10);
                if (isNaN(registeredAs)) {
                    registeredAs = -1;
                }
                var userType = parseInt(data.data.user_type, 10);



                //Em vaig registrar com a single pero server diu que soc parella
                if ((registeredAs === 1 || registeredAs === 2) && userType !== registeredAs) {

                    //Admin em canvia, he de guardar aquest canvi
                    userInfo.set('registeredAs', userType);
                    userInfo.save();

                    Module.coupleMessage(data.data, function(changes) {
                        data.data = changes;
                        data.data.passThrough = true;
                        //S'ha modificat tot correctament, canviem registeredAs
                        userInfo.set('registeredAs', data.data.user_type);
                        userInfo.save();
                        Module.pictureMessage(response, data);

                    });
                    return;
                }
                //Em vaig registrar com a parella pero server diu que soc single
                if (registeredAs === 0 && userType !== registeredAs) {
                    //Admin em canvia, he de guardar aquest canvi
                    userInfo.set('registeredAs', userType);
                    userInfo.save();

                    Module.singleMessage(function() {
                        data.data.passThrough = true;
                        Module.pictureMessage(response, data);
                        //S'ha modificat tot correctament, canviem registeredAs
                        userInfo.set('registeredAs', data.data.user_type);
                        userInfo.save();

                    });
                    return;
                }
                Module.pictureMessage(response, data);

            };
            Module.pictureMessage = function(response, data) {
                //SI PETA
                if (response.response === 'KO') {
                    funcs.errorView(response.message, 'show_login');
                    userInfo.set('remember', false);
                    return;
                }

                data = data.data;

                if (parseInt(data.user_type, 10) === 1) {
                    data.isSingle = true;
                    data.isWoman = true;
                }
                if (parseInt(data.user_type, 10) === 2) {
                    data.isSingle = true;
                    data.isMan = true;
                }
                profile.set(data);
                profile.save();

                // Login ok va al mapa
                // Login si falta foto anem a la 2
                // si son antics els tracto com usuari nou..
                // < 30 dies
                //     foto_ok —> res
                //     foto_upload —> res
                //     foto_ko —> Tienes x-  30 dias para subir una foto valida, pasado este periodo no podrás acceder a la app sin antes subir una foto               valida. Boto aceptar.
                // >30 dies
                //     foto_ok  —> res
                //     foto_upload —>   > Su foto esta en proceso de validación Como han pasado mas de 30 días de tu registro recibirás un e-mail
                //                         en las próximas horas y en caso de que sea válida ya podrá usar la aplicación totalmente.
                //     foto_ko —> pant 1.2 (NO s’ha de posar info)


                var regDate = Module.getRegDate(data);
                var pictStatus = funcs.getPictStatus(data);



                var maxDate = regDate.add('days', 30);

                if (maxDate.diff(moment(), 'days') > 0 && !data.passThrough) {

                    //> 30 days...
                    var view;
                    if (pictStatus === 'photo_ok' || pictStatus === 'photo_upload') {
                        App.execute('pict_ok');
                    } else {
                        var obj = new Backbone.Model();
                        obj.set('pend_days', maxDate.diff(moment(), 'days'));
                        view = new Views.CloseApp({
                            model: obj
                        });
                        view.on('next', function() {
                            App.execute('pict_ok');
                        });
                        view.on('upload_pict', function() {
                            App.execute('show_picture');
                        });
                        App.mainRegion.slideShow(view);
                    }
                } else {
                    //<30
                    if (pictStatus === 'photo_ok' || pictStatus === 'photo_upload' || data.passThrough) {
                        //OK
                        App.execute('pict_ok');
                    } else {
                        //OK

                        Module.set30Days(30);
                    }
                }
            };

            Module.singleMessage = function(cb) {
                var message = i18n.t('17_profile.user_warning_single');

                var view = new Views.InfoMessage({
                    model: new Backbone.Model({
                        message: message,
                        acceptButton: i18n.t('app.continue_single'),
                        photoButton: i18n.t('3_2_gallery.photo_couple')
                    })
                });

                view.on('back', function() {
                    navigator.app.exitApp();

                });
                view.on('accept', function() {
                    cb();


                });
                view.on('upload_pict', function() {
                    App.execute('show_picture');
                });
                App.mainRegion.slideShow(view);
            };
            Module.datePicker = function(data, cb) {


                var missingGender = 'he';
                if (data.edad_she === '0000-00-00') {
                    data.edad_she = false;
                }
                if (!data.edad_she) {
                    missingGender = 'she';
                }

                var model = new Backbone.Model(data);

                model.set('message', i18n.t('17_profile.couple_date'));

                var editView = new Views.DatePicker({
                    model: model
                });
                App.mainRegion.slideShow(editView, 'left');
                editView.on('changeDate', function(dates) {
                    var missingDate = {};

                    var formatedDate = moment(dates[missingGender], 'MM/DD/YYYY').format('YYYY-MM-DD');
                    var missingKey = 'edad_' + missingGender;

                    //A enviar a api
                    missingDate[missingKey] = formatedDate;
                    var langs = _.map(data.langs, function(lang) {
                        return lang.id_lang;

                    });
                    missingDate.langs = langs;
                    missingDate.id_client = data.id_client;
                    //Perfil
                    data[missingKey] = formatedDate;


                    App.request('api:edit_user', new Backbone.Model(missingDate))
                        .then(function(res) {
                            res = JSON.parse(res).response;
                            if (res === 'OK') {
                                cb(data);
                            }
                        });
                });

            };
            Module.coupleMessage = function(data, cb) {

                var message = i18n.t('17_profile.user_warning_couple');
                var view = new Views.InfoMessage({
                    model: new Backbone.Model({
                        message: message,
                        acceptButton: i18n.t('app.continue_couple'),
                        photoButton: i18n.t('3_2_gallery.photo_single')
                    })
                });

                view.on('back', function() {
                    navigator.app.exitApp();
                    //App.execute('pict_ok');
                });
                view.on('accept', function() {
                    var isValidShe = moment(data.edad_she).isValid();
                    var isValidHe = moment(data.edad_he).isValid();
                    //Si s'han registrat com a parella, pero amb foto de single. I han acabat sent parella un altre cop.
                    if (isValidShe && isValidHe) {
                        cb(data);
                    } else {
                        Module.datePicker(data, cb);
                    }
                    // navigator.app.exitApp();
                    // App.execute('pict_ok');
                });
                view.on('upload_pict', function() {
                    //Si vol continuar sent single, simplement informem al sistema que continua sent sigle..
                    //console.log('UPLOAD PICT',userInfo.get('originalRegisteredAs'));
                    userInfo.set('forceSingle',userInfo.get('originalRegisteredAs'));
                    //userInfo.save();
                    App.execute('show_picture');
                });
                App.mainRegion.slideShow(view);
            };

            Module.set30Days = function(pend_days) {

                var model = new Backbone.Model();
                model.set('pend_days', pend_days);
                spinner(false);
                var view = new Views.Info30Days({
                    model: model
                });
                view.on('back', function() {
                    navigator.app.exitApp();
                });
                view.on('upload_pict', function() {
                    App.execute('show_picture');
                });
                App.mainRegion.slideShow(view);
            };

            Module.getRegDate = function(data) {
                var isOld = false;

                if (data.intro_date === null || moment(data.intro_date, 'YYYY-MM-DD HH:mm:ss') < moment(CONS.date_app_start)) {

                    isOld = true;
                }
                if (isOld) {
                    //Si ya habia hecho login..

                    if (userInfo.get('intro_date_saved') !== undefined) {

                        data.intro_date = userInfo.get('intro_date_saved');
                    } else {

                        //Seteamos por primera vez el intro_date
                        data.intro_date = moment();
                        userInfo.set('intro_date_saved', data.intro_date);
                        userInfo.save();
                    }
                }
                return moment(data.intro_date);
            };

            Module.RememberPass = function(type) {
                if (!type) type = 'left';
                var pass = new Views.RememberPass();
                pass.on('back', function() {

                    Module.show('right');
                });
                pass.on('remember', function(email) {
                    if (!validator.isEmail(email) && email !== '') {
                        pass.setEmailError();
                    } else {


                        funcs.spinner(true);
                        App.request('api:forgotten_pass', email).then(function(res) {
                            res = JSON.parse(res);
                            if (res.response === 'KO') {
                                pass.setInvalidEmailError();
                            } else {
                                var obj = new Backbone.Model({
                                    msg: i18n.t('login.check_email')
                                });

                                var modal = new CommonViews.okModal({
                                    model: obj
                                });

                                modal.on('back', function() {
                                    App.modal.close();
                                    App.execute('show_login', 'right');
                                });
                                App.modal.show(modal);
                            }
                            funcs.spinner(false);

                        });

                    }

                });
                App.mainRegion.slideShow(pass, type);
            };
        });
        return App.login.main.controller;

    });
