


define(['App',
        'backbone',
        'apps/login/picture/views',
        'apps/common/views/common_views',
        'funcs'


    ],
    function(App, Backbone, Views, Common, funcs) {
        App.module('login.picture.controller', function(Module, App) {


            var userInfo;
            Module.addInitializer(function() {
                userInfo = App.request('entities:user_info');

            });
            Module.show = function(type, obj) {

                if (obj) {
                    if (!obj.next) {

                        obj.next = 'pict_ok';
                    }

                    Module.Images(type, obj.next, obj.back);
                } else {
                    Module.Images(type, 'pict_ok');
                }
            };


            Module.Images = function(type, ok_action, back) {
                var img;


                if (back) {
                    var mod = new Backbone.Model();
                    mod.set('back', back);
                    img = new Views.ImageView({
                        model: mod
                    });
                } else {
                    img = new Views.ImageView({
                        //model: self.model
                    });
                }

                if (type) {
                    App.mainRegion.slideShow(img, type);
                } else {

                    App.mainRegion.slideShow(img, 'left');
                }
                img.on('take', function() {
                    Module.UploadImg('new', ok_action, back);
                });
                img.on('gallery', function() {
                    Module.UploadImg('gallery', ok_action, back);
                });
                img.on('back', function() {

                    App.execute('api:cancel_pict');
                    App.execute(back, 'right');
                });

            };
            Module.UploadImg = function(source, ok_action, back) {

                var self = this;

                var options = {
                    quality: 90,
                    destinationType: Camera.DestinationType.DATA_URL,
                    //targetWidth: 370,
                    encodingType: 0 ,// 0=JPG 1=PNG
                    correctOrientation: true
                };
                if (source === 'new') {
                    options.sourceType = 1;
                } else {
                    options.sourceType = 0;
                }
                var upld = new Views.ImageUpload({
                    model: self.model
                });
                upld.getPic(options);


                upld.on('new_pict', function(pictData) {

                    if(pictData ===''){
                        alert('This photo has not yet been downloaded to your iPhone');
                    }
                    App.mainRegion.slideShow(upld, 'left');
                    upld.showPict(pictData);
                    self.pictData = pictData;


                    upld.showOkButton();


                });
                upld.on('no_pict_selected', function() {
                    //log.error('@INFORMAR  A DEV: no_pict_selected');
                    //Module.Images('right');
                });
                upld.on('upload', function() {
                    upld.showProgressbar();
                     var res = App.request('api:set_photo', self.pictData);
                    if (res.upload) {
                        res.upload.onprogress = function(e) {

                            var done = e.position || e.loaded,
                                total = e.totalSize || e.total;

                            upld.setPercent(Math.floor(done / total * 1000) / 10);
                            if (done === total) {
                                upld.showWait();
                            }
                        };
                    }


                    res.addEventListener('load', function(e) {
                        upld.hideWait();

                        res = JSON.parse(e.currentTarget.response);
                        if (res.response === 'KO') {
                            funcs.errorView('upload_pict_failed', 'show_picture');
                        } else {

                            App.execute(ok_action);

                        }
                    }, false);

                    res.addEventListener('error', function() {
                        funcs.errorView('upload_pict_failed', 'show_picture');
                        //userInfo.set('profile_image', pictData);
                    }, false);

                });

                upld.on('back', function() {
                    App.execute('api:cancel_pict');
                    if (!self.locked) {
                        Module.Images('right', ok_action, back);
                    }

                });


            };


        });

        return App.login.picture.controller;

    });
