

define(['App',

    'hbs!apps/login/picture/templates/imgupload',
    'hbs!apps/login/picture/templates/img'
], function(App, imageUpTPL, imageTPL) {

    App.module('login.picture.views', function(Module, App, Backbone) {


        Module.ImageUpload = Backbone.Marionette.ItemView.extend({
            template: imageUpTPL,
            id: 'upload_img',
            tagName: 'div',
            triggers: {
                'click button.upload': 'upload',
                'click button.reload': 'back',
                'click .back': 'back'

            },
            retries: 0,
            getPic: function(options) {

                var self = this;
                navigator.camera.getPicture(function(imgData) {
                        
                        self.trigger('new_pict', imgData);
                    },
                    function() {

                        self.trigger('no_pict_selected');
                    },
                    options);

            },
            showPict: function(imgData) {
                this.$el.find('.pict').css('background-image', 'url(data:image/jpeg;base64,' + imgData+')');
            },
            showOkButton: function() {
                
                this.$('.upload').show();
                this.$('.reload').show();
            },
            showProgressbar:function() {
                this.$('.progress-bar').show();
            },
            setPercent: function(percent) {
                $('#pb div').stop(true).animate({
                    width: percent + '%'
                }, {
                    duration: 1000
                });
            },
            showWait: function() {
                this.$('.loading_pict').show();
            },
            hideWait: function() {
                this.$('.loading_pict').hide();
            }

        });
        Module.ImageView = Backbone.Marionette.ItemView.extend({
            template: imageTPL,
            id: 'profile_img',
            tagName: 'div',
            triggers: {
                'click button.take-photo': 'take',
                'click button.gallery-access': 'gallery',
                'click .back': 'back'
            }

        });

    });

    return App.login.picture.views;

});
