


define(['App',
        'syphon',
        'underscore',
        'apps/login/register/views',
        'apps/common/views/common_views',
        'funcs',
        'md5'


    ],
    function(App, Syphon, _, Views, Common, funcs, md5) {
        App.module('login.register.controller', function(Module, App, Backbone) {
            var userInfo;
            Module.addInitializer(function() {
                userInfo = App.request('entities:user_info');

            });
            Module.show = function(type) {
                
                var self = this;
                if (!self.model || self.model === undefined) {

                    self.model = new Backbone.Model();
                    self.model.set({
                        checkemail: '',
                        email: '',
                        nickname: '',
                        passwd: '',
                        tos: false
                    });
                }

                var view = new Views.Register({
                    model: self.model
                });

                App.mainRegion.slideShow(view, type);


                //Events vista

                view.on('register', function() {
                    funcs.spinner(true);
                    var data = Syphon.serialize(this);


                    //Pass sin encriptar..
                    self.model.set(data);
                    data.passwd = md5(data.passwd);
                    App.request('api:new_user', data)
                        .then(function(resp) {



                            var response = JSON.parse(resp);

                            //Control errors
                            if (response.response === 'KO') {
                                funcs.errorView(response.message, 'app:show_register');



                            } else {

                                var login = App.request('api:login', data.nickname, data.passwd);


                                login.then(function(data2) {
                                    var response2 = JSON.parse(data2);


                                    userInfo.set('email', response2.message.email);
                                    


                                        //Module.loggedOk();
                                        userInfo.set('logged', true);
                                        userInfo.set('logged_val', data.nickname);
                                        userInfo.set(response2.data);
                                        userInfo.set('id_swinger', response2.message.id_swinger);
                                        userInfo.save();



                                        userInfo.set('email', data.email);
                                        userInfo.set('passwd', data.passwd);
                                        userInfo.save();

                                        var user = App.request('api:get_user', response.message);
                                        user.then(function(data) {
                                            data = JSON.parse(data);
                                            //SI PETA
                                            if (data.response === 'KO') {
                                                return;
                                            }
                                            data = data.data;
                                            var profile = App.request('entities:profile');
                                            profile.set(data);
                                            profile.save();

                                            App.execute('registered_ok');
                                        });


                                });

                            }
                        });
                });


                view.on('back', function() {
                    App.commands.execute('show_login', 'right');
                });

            };
        });

        return App.login.register.controller;

    });
