

define(['App',
    'validator',
    'funcs',
    'i18next',
    'moment',
    'hbs!apps/login/register/templates/register'
], function(App, validator, funcs, i18n, moment, mainTpl ) {
    App.module('login.register.views', function(Module, App, Backbone) {

        //var main = Handlebars.compile(mainTpl);
        Module.Register = Backbone.Marionette.ItemView.extend({
            template: mainTpl,
            events: {
                'click button.submit': 'cont',
                'focus input': 'clearError',
                'click .aviso':'aviso',
                'submit':'cont'
            },
            triggers: {
                'click .back': 'back'

            },
            aviso: function (e){
                e.preventDefault();
                window.open(i18n.t('2_register.toslink'), '_system');
            },
            cont: function(e) {
                e.preventDefault();
                funcs.clearError();
                var errors = false;

                var email = this.$el.find('input[name="email"]').val();
                var checkemail = this.$el.find('input[name="checkemail"]').val();
                var nick = this.$el.find('input[name="nickname"]').val();
                var tos = this.$el.find('input[name="tos"]').prop('checked');
                var pass = this.$el.find('input[name="passwd"]').val();

                //Comprovació Buits/Desmarcats
                if (email === '') {
                    errors = true;
                    funcs.addError('input[name="email"]', i18n.t('2_register.mandatory'));
                }
                if (checkemail === '') {
                    errors = true;
                    funcs.addError('input[name="checkemail"]', i18n.t('2_register.mandatory'));
                }
                if (nick === '') {
                    errors = true;
                    funcs.addError('input[name="nickname"]', i18n.t('2_register.mandatory'));
                }
                if (pass === '') {
                    errors = true;
                    funcs.addError('input[name="passwd"]', i18n.t('2_register.mandatory'));
                }
                if (!tos) {
                    errors = true;
                    funcs.addError('input[name="tos"]', i18n.t('2_register.accepterror'));
                }
                if(pass.length<6){
                    errors = true;
                    funcs.addError('input[name="passwd"]', i18n.t('2_register.min_6_chars'));
                }
                // if(pass.length>8){
                //     errors = true;
                //     funcs.addError('input[name="passwd"]', i18n.t('2_register.max_8_chars'));
                // }
                //Validació Dades

                if (!validator.isEmail(email) && email !== '') {
                    errors = true;
                    funcs.addError('input[name="email"]', i18n.t('2_register.mailerror'));
                }
                if (!validator.equals(email, checkemail) && checkemail !== '') {
                    errors = true;
                    funcs.addError('input[name="checkemail"]', i18n.t('2_register.checkemailerror'));

                }
                if(errors){
                    var $el = $('.errortext');
                    $(window).scrollTop($el.offset().top);
                }
                if (!errors) {

                    //this.trigger('continue', this);
                    this.trigger('register', this);
                    funcs.spinner(true);
                }

            },
            clearError: function() {
                funcs.clearError();
            }
        });



    });

    return App.login.register.views;

});
