

define(['App', 'funcs', 'apps/map/controller'], function(App, funcs, mapController) {
	App.module('map', function(Module, App) {

		App.vent.on('app:logged', function() {

			mapController.show('left');
		});
		App.commands.setHandler('app:map', function(type) {

			mapController.show(type);
		});
		App.commands.setHandler('app:map:chat_icon', function(type) {

			mapController.chatIcon(type);
			
		});

		App.commands.setHandler('app:map:update_center', function() {
			mapController.updatePositionOut();
		});
		App.commands.setHandler('app:map:set_my_center', function(lat, lon, inTwilight) {
			mapController.center(lat, lon, inTwilight);
		});
		App.commands.setHandler('app:map:set_map_center', function(lat, lon, id, distance, isParty) {

			mapController.show();
			mapController.showMap();
			mapController.setMaxZoom();
			if (isParty) {
				mapController.partyClicked(id, distance);
			} else {
				mapController.clubClicked(id, distance);

			}
			mapController.setMapCenter(lat, lon);

		});

		App.reqres.setHandler('app:map:is_loaded', function() {
			return mapController.mapLoaded;
		});


		return App.map;

	});
});
