


define(['App',
		'apps/map/views',
		'apps/map/view_map',
		'moment',
		'underscore',
		'apps/common/lib/spinner'
	],
	function(App, Views, MapView, moment, _, spinner) {


		App.module('map.controller', function(Module, App, Backbone) {
			var userInfo;
			var search;
			Module.addInitializer(function() {
				userInfo = App.request('entities:user_info');
				search = App.request('entities:search');
			});

			//Module.lastMove = moment();
			//Se llama cuando venimos de otro lado
			Module.activeSection = 'map';
			Module.isMapActive = function() {
				if (App.mainRegion.currentView && App.mainRegion.currentView.oid && App.mainRegion.currentView.oid === 'map_view') {
					return true;
				}
				return false;
			};
			Module.showLastTooltip = function() {
				if (Module.preloadLayout.tooltip.currentView && App.showTooltip === true && Module.activeSection === 'map') {
					App.showTooltip = false;
					Module.preloadLayout.tooltip.reOpen();
				}
			}
			Module.show = function(type) {

				



				var loadMap = false;
				var layout = new Views.Layout();
				//Si no hay preload
				if (!Module.preloadLayout) {
					spinner(true);
					Module.preloadLayout = layout;
					Module.preloadLayout.oid = 'map_view';
					//Module.updatePosition();

					Module.updateAPIPoints(userInfo.toJSON(), function(points) {

						Module.points = points;
						Module.updatePosition();
					});
					setInterval(function() {
						//var time = moment().diff(Module.lastUpdate);
						if (App.mainRegion && App.mainRegion.currentView && App.mainRegion.currentView.oid === 'map_view' && Module.activeSection === 'map') {


							Module.refreshAPIPoints();

							Module.refreshList = true;
						}
					}, 120000);
				} else {
					loadMap = true;

				}




				//if(App.mainRegion.currentView !==undefined  && App.mainRegion.currentView.oid !== 'map_view'){
				if (!Module.isMapActive()) {
					App.mainRegion.slideShow(Module.preloadLayout, type);




				}
				//}



				if (!loadMap) {

					Module.activeSection = 'map';
					Module.loadMapStructure();
				}
				Module.hack();
				Module.preloadLayout.tooltip.close();
				if (Module.mapview) {
					Module.mapview.changeVisible();
				}

				//Miramos si hemos de activar filtros..
				Module.showFilters();


				Module.preloadLayout.changeCity(search.get('closer'), search.get('city'));
				Module.preloadLayout.hideMenu();
				if (Module.listview) {
					Module.listview.setScroll();
				}
				Module.showLastTooltip();

			};
			Module.refreshAPIPoints = function() {
				Module.lastUpdate = moment();
				Module.updateAPIPoints(userInfo.toJSON(), function(points) {
					Module.points = points;
				});
			};
			//LLamada madre
			Module.center = function(lat, lon) {
				//Lo metemos en un timeout para que google acabe de ajustar la pantalla..

				setTimeout(function() {
					if (Module.mapview && App.mainRegion && App.mainRegion.currentView && App.mainRegion.currentView.oid === 'map_view' && Module.activeSection === 'map') {
						Module.mapview.updateMyPos(lat, lon, userInfo.get('inTwilight'));

					} else {
						//Retry at a  second..
						setTimeout(function() {
							Module.center(lat, lon);
						}, 1000);
					}
				}, 100);


			};
			Module.setMapCenter = function(lat, lon) {
				Module.mapview.setNewCenter(lat, lon);
			};
			Module.hack = function() {
				Module.mapview.hack();
				// var hack = function() {
				// 	if (google.maps && Module.mapLoaded) {
				// 		Module.mapview.hack();
				// 	}
				// };
				//Parche para utilizar full screen

				//setTimeout(hack, 200);
				//setTimeout(hack, 600);
			};
			//actualizamos posicion...
			Module.updatePositionOut = function() {

				Module.refreshList = true;
				setTimeout(function() {
					// body...
					Module.updatePosition();
				}, 500);
				Module.cleanList();
				if (Module.activeSection !== 'map' && App.mainRegion.currentView && App.mainRegion.currentView.oid === 'map_view') {

					setTimeout(function() {

						spinner(true);
					}, 400);
				}
			};
			Module.updatePosition = function() {

				if (Module.preloadLayout) {
					Module.preloadLayout.showLoad(true);
				}

				if (Module.mapStructureLoaded) {

					Module.show();
					if (!Module.mapLoaded && userInfo.get('lon')) {

						Module.mapview.loadMap();
						Module.mapLoaded = true;
					} else {
						if (!Module.mapLoaded) {

							setTimeout(function() {

								Module.updatePosition();
							}, 200);
							return;
						}

					}
					//PUNTO PROXIMIDAD
					setTimeout(function() {

						if (search.get('closer')) {

							Module.changePosition({
								lat: userInfo.get('lat'),
								lon: userInfo.get('lon')
							});
							Module.mapview.setNewCenter(userInfo.get('lat'), userInfo.get('lon'));

							Module.mapview.updateMyPos(userInfo.get('lat'), userInfo.get('lon'), userInfo.get('inTwilight'));

						} else {


							Module.changePosition({
								lat: search.get('city_lat'),
								lon: search.get('city_lon')
							});
							Module.mapview.setNewCenter(search.get('city_lat'), search.get('city_lon'));
							Module.mapview.updateMyPos(search.get('city_lat'), search.get('city_lon'));
						}
					}, 100);
				} else {

					//Llamamos a la funcion hasta que tengamos posicion..
					setTimeout(function() {

						Module.updatePosition();
					}, 500);
				}
			};
			Module.loadMapStructure = function() {


				//Cargamos menu..
				var menu = new Views.Menu();
				Module.menu = menu;

				menu.on('option:profile', function() {
					Module.preloadLayout.hideMenu();
					App.execute('app:profile:edit');
				});

				menu.on('option:chat', function() {
					Module.preloadLayout.hideMenu();
					App.execute('app:chat');
				});
				menu.on('option:favorites', function() {
					Module.preloadLayout.hideMenu();
					spinner(true);
					App.execute('app:favorites');
				});
				menu.on('option:blockeds', function() {
					Module.preloadLayout.hideMenu();
					spinner(true);
					App.execute('app:block');
				});
				menu.on('option:invite', function() {
					Module.preloadLayout.hideMenu();
					App.execute('app:invite');
				});
				menu.on('option:info', function() {
					Module.preloadLayout.hideMenu();
					App.execute('app:info');
				});
				menu.on('option:info', function() {
					Module.preloadLayout.hideMenu();
					App.execute('app:info');
				});

				menu.on('option:twilight', function() {
					Module.preloadLayout.hideMenu();
					App.execute('app:twilight');
				});
				menu.on('option:map', function() {
					Module.showMap();

				});
				menu.on('option:list', function() {
					Module.activeSection = 'list';
					Module.preloadLayout.$('.map-btn').show();
					Module.preloadLayout.$('.list-btn').hide();
					Module.mapview.hideMap();
					Module.preloadLayout.hideMenu();
					Module.showList();
				});
				menu.on('option:adv_search', function() {

					App.execute('app:search');
				});
				menu.on('option:wall', function() {
					App.execute('app:wall');
				});


				Module.preloadLayout.menu.show(menu);

				//Cargamos mapview
				var col = new Backbone.Collection();

				Module.mapview = new MapView.Map({
					collection: col,
					model: userInfo
				});

				Module.preloadLayout.on('click_list', function() {
					//window.alert('Click list');
					Module.preloadLayout.$('.map-btn').show();
					Module.preloadLayout.$('.list-btn').hide();
					Module.mapview.hideMap();
					Module.preloadLayout.hideMenu();
					Module.showList();
					if (Module.listview) {
						Module.listview.setScroll();
					}
				});
				Module.preloadLayout.on('click_map', function() {
					//window.alert('Click map');

					Module.showMap();
				});
				Module.preloadLayout.on('click_chat', function() {
					Module.preloadLayout.showChat(false);
					App.execute('app:chat');
				});

				Module.preloadLayout.on('filters', function() {
					//window.alert('Click cerca');
					App.execute('app:search');
				});

				Module.mapview.on('map_out', function() {

					Module.changeMapPoints({
						lat: Module.mapview.map.center.lat(),
						lon: Module.mapview.map.center.lng()
					});
				});
				Module.preloadLayout.on('twilight', function() {
					App.execute('app:twilight');
				});

				Module.mapview.on('person_clicked', function(data) {

					App.request('api:get_info', [data.idc], [])
						.then(function(arr) {


							var info = _.find(arr, function(el) {
								return el.id_swinger === data.idc;
							});
							var mod = new Backbone.Model(data);
							mod.set(info);

							mod.set('distancia', data.d);

							if (!info.user_type && info.ut) {
								info.user_type = info.ut;
							}
							info.user_type = parseInt(info.user_type, 10);

							if (info.user_type === 1) {
								mod.set('isSingle', true);
								mod.set('isWoman', true);
							}

							if (info.user_type === 2) {
								mod.set('isSingle', true);
								mod.set('isMan', true);
							}

							data = mod.attributes;
							if (Module.isFav(data)) {
								mod.set('isFav', true);
							}


							var view = new Views.Tooltip({
								model: mod
							});
							Module.preloadLayout.tooltip.show(view);
							view.on('view_profile', function() {

								Module.goProfile(mod);

							});
							view.on('show_picture', function() {

								if (mod.get('imgs').length > 0) {

									Module.showPic(mod);
								}
							});
						});

				});
				Module.mapview.on('club_clicked', function(data) {

					Module.clubClicked(data.idl, data.d);

				});
				Module.mapview.on('party_clicked', function(data) {
					Module.partyClicked(data.idp, data.d);

				});
				Module.setMaxZoom = function() {
					Module.mapview.setZoom(18);
				};
				Module.partyClicked = function(id, distance) {

					spinner(true);
					App.request('api:get_info', [], [], [id])
						.then(function(arr) {
							
							spinner(false);
							var info = _.find(arr, function(el) {
								return el.id_party === id;
							});
							var mod = new Backbone.Model();

							mod.set(info);
							mod.set('distance', distance);
							if (arr[0]) {
								mod.set('p', arr[0].p === 1);
							} else {
								mod.set('p', 0);
							}
							var view = new Views.PartyTooltip({
								model: mod
							});
							Module.preloadLayout.tooltip.show(view);
							view.on('view_party', function() {

								App.execute('app:profile:party', id, distance, null, 'map');

							});
						});
				};
				Module.clubClicked = function(id, distance) {
					//App.execute('app:profile:club', data.idl, data.d, null, 'map');
					spinner(true);
					App.request('api:get_info', [], [id], [])
						.then(function(arr) {
							
							spinner(false);
							var info = _.find(arr, function(el) {
								return el.id_local === id;
							});
							var mod = new Backbone.Model();

							mod.set(info);
							mod.set('distance', distance);
							// if (arr[0]) {
							//
							// 	mod.set('p', arr[0].p === 1);
							// } else {
							// 	mod.set('p', 0);
							// }
							mod.set('p', parseInt(mod.get('p'),10));
							console.log(mod);

							var view = new Views.ClubTooltip({
								model: mod
							});
							Module.preloadLayout.tooltip.show(view);
							view.on('view_club', function() {

								App.execute('app:profile:club', id, distance, null, 'map');

							});
						});
				};
				Module.mapview.on('map_moved', function() {
					Module.preloadLayout.tooltip.close();
				});

				Module.mapview.on('loaded_end', function() {
					Module.mapStructureLoaded = true;
				});
				Module.preloadLayout.map.show(Module.mapview);


				//Accion de ir a HOME: Resetea filtros
				Module.mapview.on('home', function() {

					search.set({
						closer: true,
						city_lon: 0,
						city_lat: 0,
						city: '',
						clients: true,
						clubs: true,
						verified: false,
						residents: false
					});

					Module.preloadLayout.closef();

					Module.updatePosition();
					Module.mapview.setZoom(17);
				});

			};
			Module.updateAPIPoints = function(point, cb) {

				//Contador de tiempo
				Module.milisInit = new Date().getTime();

				//si hay una anterior la paramos..
				if (Module.updatePending) {
					Module.updatePending.abort();
				}

				//Iniciamos la llamada.. por tanto ya no hay pendings porque hemos cogido el ultimo..
				//Module.updatePending = point;
				Module.updatePending = App.request('api:get_map', point);

				Module.updatePending.then(function(points) {

					//Timming stats
					Module.serverTime = new Date().getTime();

					points = JSON.parse(points);

					points = _.filter(points, function(elem) {
						var result = true;
						if (elem.idc && elem.idc === userInfo.get('id_swinger')) {
							return false;
						}
						return result;
					});
					cb(points);
				});

			};
			Module.changeMapPoints = function(point) {

				Module.preloadLayout.showLoad(true);
				//Limpiamos mapa..
				Module.mapview.clearMarkers();

				Module.updateAPIPoints(point, function(points) {
					Module.visibleMapPoints = points;
					//Module.refreshList = true;
					Module.showPointsInMap();
					//Next time hay que refrescar vista..
					if (App.mainRegion.currentView.oid === 'map_view' && Module.activeSection === 'list') {

						//Module.showList();
					} else {
						//Module.mapview.changeVisible();
					}
				});
			};
			//Actualizamos Array de puntos..
			Module.changePosition = function(point) {

				Module.preloadLayout.showLoad(true);

				//Limpiamos mapa..
				Module.mapview.clearMarkers();

				Module.updateAPIPoints(point, function(points) {


					Module.points = points;
					Module.visibleMapPoints = points;

					//Module.refreshList = true;
					Module.showPointsInMap();
					//Next time hay que refrescar vista..
					Module.refreshList = true;
					Module.mapview.changeVisible();
					if (App.mainRegion.currentView && App.mainRegion.currentView.oid === 'map_view' && Module.activeSection === 'list') {

						Module.showList();
					} else {
						Module.mapview.changeVisible();


					}

				});
			};
			Module.showPointsInMap = function() {


				//OPTIMIZACION DEL RADUS..
				//var last = _.last(Module.points);
				//Module.mapview.radius = last.distancia * 0.7;

				//PRECARGAMOS LOS 50 PRIMEROS LOCALES SWINGERS:..---

				var initial = _.first(Module.visibleMapPoints, 50);

				var inf = Module.prepareGetInfo(initial);

				//Los dejamos cargando en cache...
				App.request('api:get_info', inf.sw, inf.loc, inf.par);

				var executed = false;
				Module.updatePending = false;

				if (Module.preloadLayout) {

					Module.preloadLayout.showLoad(true);
				}

				if (Module.visibleMapPoints[40].d < 10) {
					Module.mapview.setZoom(12);
				} else if (Module.visibleMapPoints[40].d < 40) {
					Module.mapview.setZoom(11);
				} else if (Module.visibleMapPoints[10].d < 100) {
					Module.mapview.setZoom(10);
				} else {
					Module.mapview.setZoom(8);
				}

				Module.mapview.loadPoints(Module.visibleMapPoints, function() {

					if (!executed) {
						executed = true;
						Module.refreshList = true;

						if (Module.preloadLayout) {

							Module.preloadLayout.showLoad(false);
						}

					}

				});

			};

			Module.prepareGetInfo = function(arr) {
				var sw = [],
					loc = [],
					par = [];
				_.each(arr, function(el) {
					if (el.idp) {
						par.push(el.idp);
					} else if (el.idc) {
						sw.push(el.idc);
					} else if (el.idl) {
						loc.push(el.idl);
					}
				});
				return {
					sw: sw,
					loc: loc,
					par: par
				};
			};
			Module.goProfile = function(model) {

				if (model.get('id_swinger')) {

					spinner(true);
					var data = {
						id_client: parseInt(model.get('id_swinger'), 10),
						back: 'map'
					};

					App.execute('app:profile:show', 'left', data);


				}
			};
			Module.showPic = function(model) {

				if (model.get('id_swinger')) {

					spinner(true);
					var data = {
						id_client: parseInt(model.get('id_swinger'), 10),
						back: 'map'
					};

					App.execute('app:profile:show', 'left', data, true);


				}
			};
			Module.addListPoints = function(col, pointer) {

				var points = Module.points.slice(pointer, pointer + 50);

				var inf = Module.prepareGetInfo(points);


				App.request('api:get_info', inf.sw, inf.loc, inf.par)
					.then(function(points) {

						if (points.length === 0) {
							Module.pointslength = 0;

						} else {
							Module.pointslength = points.length;

						}

						var arr_to_search = Module.points.slice(pointer, pointer + 50);


						_.each(arr_to_search, function(arr_el) {

							var elem = _.find(points, function(p) {
								if (arr_el.idp) {
									return arr_el.idp === p.id_party;

								} else if (arr_el.idc && p.id_swinger) {
									//Es swinger
									return arr_el.idc === p.id_swinger;
								} else if (arr_el.idl) {

									return arr_el.idl === p.id_local;
								} else {

									return false;
								}
							});


							if (!elem) {
								setTimeout(function() {
									spinner(false);
								}, 1000);

							} else {
								elem.user_type = arr_el.user_type;
								elem.distance = arr_el.d;
								elem = Module.setSingleValues(elem);


								col.add(elem);
							}
						});


						var points = Module.points.slice(pointer + 50, pointer + 100);

						inf = Module.prepareGetInfo(points);


						App.request('api:get_info', inf.sw, inf.loc, inf.par);
						Module.preloadLayout.showLoad(false);

						spinner(true);
						setTimeout(function() {
							spinner(false);
						}, 500);
						// body...


					});
			};
			Module.setSingleValues = function(elem) {
				if (elem.user_type === '1') {

					elem.isSingle = true;
					elem.isWoman = true;
				} else if (elem.user_type === '2') {

					elem.isSingle = true;
					elem.isMan = true;
				}
				return elem;
			};
			Module.isFav = function(data) {
				var favs = App.request('entities:favorites');
				var fav = _.find(favs.models, function(item) {
					return item.get('id_swinger_favorite') === data.id_swinger;
				});


				if (fav !== undefined || data.isFav) {
					return true;
				} else {

					return false;
				}

			};
			Module.showMap = function() {
				Module.activeSection = 'map';
				Module.showFilters();
				Module.hack();
				//Parche para utilizar full screen
				Module.preloadLayout.hideMenu();
				Module.preloadLayout.$('.map-btn').hide();
				Module.preloadLayout.$('.list-btn').show();
				if (Module.listview) {

					Module.listview.hideList();
				}
				Module.preloadLayout.hideMenu();
				Module.mapview.showMap();

			};
			Module.showFilters = function() {

				if (search.get('verified') || search.get('residents') || search.get('city')) {
					Module.preloadLayout.showFilters(true);
				} else {
					Module.preloadLayout.showFilters(false);
				}
			};
			Module.showList = function(inner) {


				Module.activeSection = 'list';
				//Cerramos tootlip por si acaso..
				if (Module.preloadLayout.tooltip) {
					Module.preloadLayout.tooltip.close();
				}
				Module.showFilters();

				if (!Module.listview || inner || Module.refreshList) {
					Module.showListInner();
				} else {
					Module.listview.showList();
					if (Module.listview) {
						Module.listview.setScroll();
					}
				}


			};
			Module.cleanList = function() {
				if (Module.listCol) {

					Module.listCol.reset();
				}
			};
			Module.showListInner = function() {

				spinner(true);
				//Limpiamos tooltip por si acaso..
				//Module.preloadLayout.tooltip.close();
				//Module.mapview.hideMap();
				var listPointer = 0;


				Module.listCol = new Backbone.Collection();
				var list = new Views.List({
					collection: Module.listCol
				});

				Module.refreshList = false;

				Module.list = list;
				//var count = 0;
				list.on('more_points', function() {



					if (!Module.morePointsBlock) {

						Module.preloadLayout.showLoad(true);
						listPointer = listPointer + 50;


						if (listPointer <= Module.points.length) {

							spinner(true);
							Module.addListPoints(Module.listCol, listPointer);
						} else {


						}

						Module.morePointsBlock = true;



						//Evitamos 1 segundo..
						setTimeout(function() {

							if (Module.pointslength === 0) {
								
								spinner(false);
							}

							Module.morePointsBlock = false;
						}, 1000);
					}


				});
				list.on('item:view_profile', function(e, info) {

					Module.goProfile(info.model);
				});
				list.on('item:show_picture', function(e, info) {
					Module.showPic(info.model);
				});
				list.on('item:view_club', function(e, info) {


					App.execute('app:profile:club', info.model.get('id_local'), info.model.get('distance'), null, 'map');
					Module.goProfile(info.model);
				});
				list.on('item:view_party', function(e, info) {
					App.execute('app:profile:party', parseInt(info.model.get('id_party'),10), info.model.get('distance'), null, 'map');

				});


				Module.addListPoints(Module.listCol, 0);
				list.on('loaded_end', function() {
					spinner(false);
				});
				Module.listview = list;
				Module.preloadLayout.list.show(list);
				spinner(true);


			};
			//inicializaciones..
			Module.lastUpdate = moment().add(-1, 'days');
			Module.points = [];
			// Module.showPendMessages = function(value) {
			//     Module.preloadLayout.showChat(value);

			// };
			Module.chatIcon = function(number) {

				if (Module.preloadLayout) {
					if (Module.menu) {

						Module.menu.setChatNumber(number);
						Module.preloadLayout.setMenuIcon(number);
					}
				} else {
					setTimeout(function() {
						Module.chatIcon(number);
					}, 1000);
				}

			};
		});





		return App.map.controller;

	});
