


define(['App',
		'underscore',
		'handlebars',
		'text!apps/map/templates/map.html',
		'hbs!apps/map/templates/layout',
		'hbs!apps/map/templates/menu',
		'hbs!apps/map/templates/tooltip_user',
		'hbs!apps/map/templates/tooltip_local',
		'hbs!apps/map/templates/tooltip_party',
		'hbs!apps/map/templates/list',
		'hbs!apps/map/templates/list_elem',
		'apps/common/lib/spinner',
		'funcs',
		'i18next',
		'moment'

	],
	function(App, _, Handlebars, mapTpl, layoutTpl, menuTpl, tooltipTpl, clubTooltipTpl, partyTooltipTpl, listTpl, listElemTpl, spinner, funcs, i18n, moment) {
		mapTpl = Handlebars.compile(mapTpl);



		App.module('map.views', function(Module, App, Backbone, Marionette, $) {


			Module.Point = Marionette.ItemView.extend({
				render: function() {}
			});


			var tooltipR = Backbone.Marionette.Region.extend({
				//el: '#main-region',
				reOpen: function() {
					var self = this;
					setTimeout(function() {
						self.$el.show();
					}, 0);
				},
				open: function(view) {
					this.$el.hide();
					this.$el.html(view.el);
					this.$el.fadeIn();
				},
				close: function() {
					if (this.$el) {
						this.$el.hide();
					}
				}
			});
			Module.Layout = Marionette.Layout.extend({
				template: layoutTpl,
				regions: {
					map: '.map-region',
					list: '.list-region',
					menu: '#site-menu',
					tooltip: {
						selector: '.tooltip_map',
						regionType: tooltipR
					}

				},
				events: {

					'click .menu-b': 'show_menu',
					'click .back-menu': 'show_menu',
					'click .filters.search-filter-btn': 'prev',
					'click .filters .closef': 'closef'
				},
				closef: function(e) {
					if (e) {
						e.preventDefault();
					}
					$('#toolbar2 span.city').html(i18n.t('22_search.closer_me'));
					$('.filters.search-filter-btn').hide();
				},
				prev: function(e) {
					e.preventDefault();
					e.stopPropagation();
				},
				triggers: {
					'click .list-btn': 'click_list',
					'click .map-btn': 'click_map',
					'click .search-btn': 'filters',
					'click .back': 'close',
					'click .chat-btn-map': 'click_chat',
					'click .mode': 'twilight'

				},
				close: function() {

				},

				showLoad: function(val) {

					if (val) {
						this.$('.map_spinner').show();
					} else {
						this.$('.map_spinner').hide();
					}
				},
				setMenuIcon: function(number) {

					if (number === 0) {
						this.$('.menu-b').css('background-image', 'url(\'assets/img/open.png\')');
						//this.$('.menu-b').css('background', 'url(../img/open.png) center center no-repeat;');
					} else {
						this.$('.menu-b').css('background-image', 'url(\'assets/img/open_chats.png\')');
						//this.$('.menu-b').css('background', 'url(../img/open_chats.png) center center no-repeat;');
					}

				},

				show_menu: function() {
					$('body').toggleClass('noscroll');

					if ($('#site-menu').hasClass('show')) {

						$('#site-menu').removeClass('show');
						$('#site-menu').addClass('hide');
						$('.back-menu').hide();
						// $('body').removeAttr('style');
						// $(document.body).removeClass('noscroll');
						//$('.site-canvas').css('overflow', 'auto');

					} else {
						//$('.site-canvas').css('overflow', 'hidden');
						// $(document.body).addClass('noscroll');
						// $('body').attr('style', 'overflow-y:hidden');

						$('#site-menu').removeClass('hide');
						$('#site-menu').addClass('show');
						$('.back-menu').show();
					}

				},
				hideMenu: function() {

					$(document.body).removeClass('noscroll');
					$('#site-menu').removeClass('show');
					$('#site-menu').addClass('hide');
					$('.back-menu').hide();
					//$('.site-canvas').css('overflow', 'auto');
				},

				// changeVis: function(visibility) {

				//     if (visibility) {

				//         $('#toolbar2 .mode').show();
				//     } else {
				//         $('#toolbar2 .mode').hide();
				//     }
				// },
				changeCity: function(closer) {

					if (closer) {

						$('#toolbar2 span.city').html(i18n.t('22_search.closer_me'));
					} else {
						$('#toolbar2 span.city').html(i18n.t('22_search.search_loc'));
					}
				},
				showFilters: function(filters) {
					var search = App.request('entities:search');


					if (filters) {
						var res = [];

						if (search.get('city')) {
							res.push(i18n.t('22_search.search_loc'));
							$('.fi').css('top', '30px');
							$('.searchres').html(search.get('city'));
						} else {
							$('.searchres').html('');
							$('.fi').css('top', '15px');
						}
						if (search.get('clients')) {
							res.push(i18n.t('22_search.fclients'));
						}
						if (search.get('clubs')) {
							res.push(i18n.t('22_search.fclubs'));
						}

						if (search.get('residents')) {
							res.push(i18n.t('22_search.only_native'));
						}
						if (search.get('verified')) {
							res.push(i18n.t('22_search.only_verified'));
						}

						$('.filters .filt').html(res.join(', '));

						$('.filters').show();
						$('#list-region >div').css('margin-top', '120px');


					} else {
						$('.filters').hide();
						$('#list-region >div').css('margin-top', '0px');

					}
				}

			});
			Module.Menu = Marionette.ItemView.extend({
				template: menuTpl,
				events: {

					'click .snap-drawers li': 'removeY',
					// 'touchmove .chat': 'cancel',
					// 'touchmove .profile': 'cancel',
					// 'touchmove .favoritesi': 'cancel',
					// 'touchmove .blockeds': 'cancel',
					// 'touchmove .info': 'cancel',
					// 'touchmove .invite': 'cancel',
					// 'touchmove .map': 'cancel',
					// 'touchmove .list': 'cancel',
					// 'touchmove .adv_search': 'cancel',
					// 'touchmove .twilight': 'cancel',
					'click .chat': 'listType',
					'click .profile': 'listType',
					'click .favoritesi': 'listType',
					'click .blockeds': 'listType',
					'click .info': 'listType',
					'click .invite': 'listType',
					'click .map': 'listType',
					'click .list': 'listType',
					'click .adv_search': 'listType',
					'click .wall': 'listType',
					'click .twilight': 'listType'

				},
				triggers: {
					// 'click .chat': 'option:chat',
					// 'click .profile': 'option:profile',
					// 'click .favoritesi': 'option:favorites',
					// 'click .blockeds': 'option:blockeds',
					// 'click .info': 'option:info',
					// 'click .invite': 'option:invite',
					// 'click .map': 'option:map',
					// 'click .list': 'option:list',
					// 'click .adv_search': 'option:search',
					// 'click .twilight': 'option:twilight'
				},
				canTouchThis: true,
				cancel: function(e) {
					e.stopPropagation();
					this.canTouchThis = false;
				},
				listType: function(e) {
					e.preventDefault();
					var $el = $(e.target);
					$el = $el.parent('li');
					if (this.canTouchThis) {


						if ($el.hasClass('chat')) {
							this.trigger('option:chat', this);
						} else if ($el.hasClass('profile')) {
							this.trigger('option:profile', this);
						} else if ($el.hasClass('favoritesi')) {
							this.trigger('option:favorites', this);
						} else if ($el.hasClass('blockeds')) {
							this.trigger('option:blockeds', this);
						} else if ($el.hasClass('info')) {
							this.trigger('option:info', this);
						} else if ($el.hasClass('invite')) {
							this.trigger('option:invite', this);
						} else if ($el.hasClass('map')) {
							this.trigger('option:map', this);
						} else if ($el.hasClass('list')) {
							this.trigger('option:list', this);
						} else if ($el.hasClass('adv_search')) {
							this.trigger('option:adv_search', this);
						} else if ($el.hasClass('twilight')) {
							this.trigger('option:twilight', this);
						} else if ($el.hasClass('wall')) {
							this.trigger('option:wall', this);
						}
					}
					this.canTouchThis = true;
				},
				removeY: function() {
					$('body').removeAttr('style');
				},
				setChatNumber: function(number) {
					if (number === 0) {
						this.$('.pend_mess').html('');
					} else {
						this.$('.pend_mess').html('<div class="numdate  ">' + number + '</div>');
					}

				}

			});
			Module.ListElem = Marionette.ItemView.extend({
				initialize: function() {
					this.model.set('p', parseInt(this.model.get('p'),10));
					this.model.set('img', this.model.get('imgs'));
				},
				template: listElemTpl,
				events: {

					'click .img-profile div': 'listType',
					'click .info-profile div': 'listType'

				},

				canTouchThis: true,
				cancel: function(e) {
					e.stopPropagation();
					this.canTouchThis = false;
				},
				listType: function(e) {

					var $el = $(e.target);

					if ($el.parents('.list-item').hasClass('client')) {
						this.trigger('view_profile', this);
					} else if ($el.parents('.list-item').hasClass('club')) {
						this.trigger('view_club', this);
					} else if ($el.parents('.list-item').hasClass('party')) {
						this.trigger('view_party', this);
					}
				},
				onShow: function() {


					if (this.model.get('nick')) {

						//this.$el.addClass('client');
					} else {
						//this.$el.addClass('club');
					}
				},
				className: function() {
					var classname;
					if (this.model.get('nick')) {
						classname = 'client';
					} else if (this.model.get('p')) {
						classname = 'club';
					} else if (this.model.get('party_name')) {
						classname = 'party';
					} else {
						classname = '';
					}
					return 'list-item ' + classname;
				}

			});
			Module.List = Marionette.CompositeView.extend({
				itemView: Module.ListElem,
				template: listTpl,
				itemViewContainer: '.elems',

				itemViewEventPrefix: 'item',
				onShow: function() {
					var self = this;
					var lastElemH;
					var calc;
					this.scrollFunc = function() {

						if(!$('#list-region').length){
							return;
						}
						if ($('.list-item:last').length > 0) {

							lastElemH = $('.list-item:last').offset().top;
							if (document.body.scrollTop !== 0) {

								self.scrollPointer = document.body.scrollTop;

							}

							calc = (lastElemH - document.body.scrollTop - $(window).height());

							if (calc < 100) {

								self.trigger('more_points');
								self.lastElemH = lastElemH;

							}
						}

					};


					this.scrollHandler = $(document).scroll(this.scrollFunc);

					self.trigger('loaded_end');
				},
				hideList: function() {
					this.$el.hide();
				},
				setScroll: function() {
					window.scrollTo(0, this.scrollPointer);
				},
				showList: function() {
					this.$el.show();
					this.setScroll();
				},

				close: function() {

					$(document).off('scroll', this.scrollFunc);

				}


			});
			Module.Tooltip = Marionette.ItemView.extend({
				template: tooltipTpl,
				events: {},
				triggers: {
					'click .footer-icon-inner': 'show_picture',
					'click .nextarrow': 'view_profile'
				}


			});
			Module.ClubTooltip = Marionette.ItemView.extend({
				template: clubTooltipTpl,
				triggers: {
					'click .nextarrow': 'view_club'
				}

			});
			Module.PartyTooltip = Marionette.ItemView.extend({
				template: partyTooltipTpl,
				triggers: {
					'click .nextarrow': 'view_party'
				},
				initialize: function() {
					var date = this.model.get('date');
					this.model.set('date', moment(date).format('DD/MM/YYYY'));
				}

			});

		});

		return App.map.views;
	});
