

define(['App',
        'underscore',
        'backbone',
        'apps/pictures/views',
        'apps/common/lib/spinner'
    ],
    function(App, _, Backbone, Views, spinner) {
        App.module('pictures.list.controller', function(Module, App, Backbone) {

            Module.Gallery = function(picts, back, cid, type, dist, actions) {

                if (!dist) {
                    dist = null;
                }
                

                _.each(picts, function(elem) {
                    
                    elem.showValMessage = elem.validation == 0;
                });
                

                var mod = new Backbone.Model({
                    picts: picts,
                    enableSlider: true,
                    like: (actions && actions.like) || false,
                    trash: (actions && actions.trash) || false

                });

                var gallery = new Views.Gallery({
                    model: mod
                });

                App.mainRegion.slideShow(gallery, type);
                gallery.on('delete', function(id_picture) {
                    
                    App.request('api:delete_image', id_picture).
                    then(function() {
                        
                    });
                    _.each(picts, function(elem,index) {

                        if (parseInt(elem.id_foto, 10) === id_picture){
                            picts.splice(index,1);
                        }
                    });



                    App.execute('api:set_user_cache_imgs', cid, picts);
                    
                    Module.Gallery(picts, back, cid, type, dist, actions)
                    //App.execute('app:profile:edit', 'left');

                });
                gallery.on('new_like', function(id_picture) {
                    var pict = _.find(picts, function(elem) {

                        return parseInt(elem.id_foto, 10) === id_picture;
                    });
                    
                    pict.can_like =false;
                    pict.likes = pict.likes+1;
                    

                    App.execute('api:set_user_cache_imgs', cid, picts);
                    App.request('api:like_image_photo', cid, id_picture).
                    then(function() {
                        
                    });



                });
                gallery.on('detail', function(id_picture) {

                    App.execute('app:pictures:img_detail', picts, back, cid, type, dist, actions, id_picture);




                });
                gallery.on('back', function() {

                    if (back === 'club') {
                        App.execute('app:profile:club', cid, dist, type, 'map');
                    }
                    if (back === 'party') {
                        App.execute('app:profile:party', cid, dist, type, 'map');
                    }
                    if (back === 'map') {
                        App.execute('app:map', 'left');
                    }
                    if (back === 'profile_edit') {
                        App.execute('app:profile:edit', 'left');
                    }
                    if (back === 'profile') {
                        var mod = {
                            id_client: cid,
                            back: 'map'
                        };

                        App.execute('app:profile:show', 'right', mod);
                    }
                });
            };

            Module.imageDetail = function(picts, back, cid, type, dist, actions, id_picture) {
                
                spinner(true);
                App.request('api:get_image', id_picture).
                then(function(image) {
                    var comments = JSON.parse(image).comments;
                    spinner(false);
                    
                    var img = _.find(picts, function(elem) {
                        
                        return parseInt(elem.id_foto, 10) === id_picture;
                    });
                    img.comments = comments;


                    var mod = new Backbone.Model(img);
                    
                    var pict = new Views.PictureDetail({
                        model: mod
                    });

                    App.mainRegion.slideShow(pict, type);
                    pict.on('back', function() {
                        App.execute('app:pictures:show_slider', picts, back, cid, type, dist, actions);
                    });
                    pict.on ('openChat', function() {

                        var user = App.request('api:get_user', JSON.parse(image).id_client, true);
                        user.then(function(data) {
                            var pictureUser = JSON.parse(data);
                            mod.set('back', 'profile');
                            App.execute('app:chat:new_message', pictureUser.data);
                        });
                    });
                    pict.on('goToClient', function(id_client) {


                        var data = {
                            id_client: id_client,
                            back: 'pict',
                            picts: picts,
                            cid: cid,
                            type: type,
                            dist: dist,
                            actions: actions,
                            id_picture: id_picture
                        };
                        App.execute('app:profile:show', 'left', data);

                    });
                    pict.on('new_like', function() {
                        App.request('api:like_image_photo', cid, id_picture).
                        then(function() {
                            
                        });
                    });
                    pict.on('new_message', function(mess) {


                        if (mess == '') {
                            $('#message').addClass('mandatory-message');
                        } else {
                            spinner(true);
                            App.request('api:write_photo_comments', id_picture, mess).
                            then(function() {
                                App.execute('app:pictures:img_detail', picts, back, cid, type, dist, actions,id_picture);
                            });
                        }
                        

                    });
                });
            }


        });

        return App.pictures.list.controller;

    });
