


define(['App',
        'hbs!apps/pictures/templates/slider',
        'hbs!apps/pictures/templates/picture_detail',
        'royalslider',


    ],
    function(App, sliderTpl, detailTpl) {

        App.module('pictures.views', function(Module, App, Backbone) {

            Module.Gallery = Backbone.Marionette.ItemView.extend({
                template: sliderTpl,
                triggers: {
                    'click .back': 'back'
                },
                events: {
                    'click .trash': 'deleteEvt',
                    'click .photo-like': 'like',
                    'click .photo-comment': 'comment'
                },
                deleteEvt: function(e) {

                    e.preventDefault();
                    e.stopPropagation();

                    var $el = $(e.currentTarget);
                    var id_picture = $el.data('picture-id');
                    this.trigger('delete', id_picture);

                },
                comment: function(e) {
                    e.preventDefault();
                    e.stopPropagation();

                    var $el = $(e.currentTarget);
                    this.trigger('detail', $el.data('picture-id'));
                },
                like: function(e) {

                    e.preventDefault();
                    e.stopPropagation();

                    var $el = $(e.currentTarget);
                    if ($el.find('i').hasClass('icon-heart-o')) {
                        $el.find('i').removeClass('icon-heart-o');
                        $el.find('i').addClass('icon-heart');
                        this.trigger('new_like', $el.data('picture-id'));
                        var likes = parseInt($el.find('p span').html(), 10);
                        $el.find('p span').html(likes + 1);

                    }

                },
                onRender: function() {
                    var self = this;
                    if (this.model.get('enableSlider')) {

                        setTimeout(function() {
                            $('.royalSlider').royalSlider({
                                keyboardNavEnabled: true,
                                autoScaleSlider: false,
                                autoHeight: false,
                                navigateByClick: false
                            });


                        }, 0);

                    }
                }
            });
            Module.PictureDetail = Backbone.Marionette.ItemView.extend({
                template: detailTpl,
                triggers: {
                    'click .back': 'back',
                    'click .openChat': 'openChat'

                },
                events: {

                    'click .send': 'send',
                    'click .goToProfile': 'goToClient'
                },

                goToClient: function(e) {
                    e.preventDefault();
                    e.stopPropagation();
                    var $el = $(e.currentTarget);
                    var id_client = $el.data('id');
                    this.trigger('goToClient', id_client);

                },
                send:function(e) {

                    e.preventDefault();
                    e.stopPropagation();
                    var mess = this.$el.find('textarea').val();
                    this.trigger('new_message', mess);
                }
            });
        });

        return App.pictures.views;
    });
