


define(['App',
        'underscore',
        'backbone',
        'apps/profile/club/views'

    ],
    function(App, _, Backbone, Views) {
        App.module('profile.club.controller', function(Module, App) {
            var userInfo;
            Module.addInitializer(function() {

                userInfo = App.request('entities:user_info');
            });
            Module.show = function(id, distance, type, back) {
                App.showTooltip = true;

                var mod = new Backbone.Model();
                App.request('api:get_local', id)
                    .then(function(data) {
                        data = JSON.parse(data).data;

                        data.fotos = data.imgs;
                        data.lat = data.pos_lat;
                        data.lon = data.pos_lon;

                        mod.set(data);
                        mod.set('back', back);
                        mod.set('distance', distance);
                        mod.set('logo', data.img);

                        if (data.fotos && data.fotos.length > 0 && !data.img) {

                            mod.set('img_portada', data.fotos[0].large);
                        } else {
                            mod.set('img_portada', data.img);
                        }
                        var club = new Views.Club({
                            model: mod
                        });

                        App.mainRegion.slideShow(club, type);
                        club.on('back', function() {
                            App.execute('app:map', 'right');
                        });
                        club.on('openroute', function() {
                            window.open('http://maps.google.com/?daddr=' + data.lat + '%20' + data.lon + '&saddr=' + userInfo.get('lat') + '%20' + userInfo.get('lon'), "_system");
                            //window.open('geo:' + data.lat + ',' + data.lon, '_system');
                        });
                        club.on('opengallery', function() {
                            Module.Gallery(data.fotos, id);
                        });
                        club.on('showmap', function() {

                            App.execute('app:map:set_map_center', data.lat, data.lon, id, distance);
                        });

                    });

            };
            Module.Gallery = function(arr, cid) {

                _.each(arr, function(elem) {
                    elem.img = elem.large;
                });

                App.execute('app:pictures:show_slider', arr, 'club', cid, 'left');


            };


        });

        return App.profile.club.controller;

    });
