


define(['App',
        'underscore',
        'apps/profile/edit/views',
        'moment',
        'backbone',
        'i18next',
        'funcs',
        'apps/common/views/common_views',
        'api'

    ],
    function(App, _, Views, moment, Backbone, i18n, func, CommonViews,api) {
        App.module('profile.edit.controller', function(Module, App) {

            var profile, userInfo;

            Module.addInitializer(function() {
                userInfo = App.request('entities:user_info');

                profile = App.request('entities:profile');


            });
            Module.v = function() {

                var isAfter = moment().isAfter(moment(userInfo.get('visibility-time')));

                //Quan hora de desocultació > a ara, desoculta.
                if (isAfter) {
                    App.request('api:change_visibility', true).then(function() {
                        userInfo.set('visibility', false);
                        userInfo.get('visibility-time', 0);
                        userInfo.save();
                    });
                }
            };

            Module.show = function(type) {
                func.spinner(true);


                App.request('api:get_user', userInfo.get('id_swinger'), true)

                    .then(function(user) {


                        if (userInfo.get('visibility')) {
                            Module.v();
                        }
                        user = JSON.parse(user).data;

                        profile.set(user);

                        Module.prepareData();



                        var editView = new Views.Edit({
                            model: profile
                        });
                        Module.editView = editView;

                        App.mainRegion.slideShow(editView, type);

                        editView.on('update', function(d) {
                            var data = d;
                            data.langs = editView.getLangs();
                            data.id_client = profile.get('id_client');

                            var mod = new Backbone.Model();
                            mod.set(data);

                            //Esperemos que vaya bien...
                            App.request('api:edit_user', mod).then(function() {});

                        });
                        editView.on('hide', function(h) {
                            var time = 0;
                            var updateValue = function(time) {
                                userInfo.set('visibility-time', time);
                                userInfo.set('visibility', h);
                                userInfo.save();

                                $('.visible').show();

                                App.request('api:change_visibility', !userInfo.get('visibility')).then(function() {});
                            };

                            if (h) {
                                var hidemodal = new Views.hideModal();
                                App.modal.show(hidemodal);
                                hidemodal.on('back', function() {
                                    time = moment().add(8, 'hours');
                                    //time = moment().add(2, 'minutes');

                                    userInfo.set('visibility-time', time.toDate());
                                    editView.showHideTime('8 hrs 0 m');
                                    updateValue(time.toDate());

                                    App.modal.close();
                                });


                            } else {
                                updateValue(time);
                                editView.showHideTime(0);
                            }



                        });
                        editView.on('clickPict', function() {
                            var back =  'profile_edit';
                            var picts = profile.get('imgs');

                            _.each(picts, function(v, i) {

                                v.img= api.server + '/public/frontend/img/clientes2/' + v.large;
                            });

                            App.execute('app:pictures:show_slider', picts, back, userInfo.id, 'left', '', {trash:true});
                        });
                        
                        editView.on('back', function() {
                            var prev = profile.get('back');
                            if (prev === 'map') {
                                App.execute('app:map', 'right');
                            }

                        });

                        editView.on('clickEmptyShortDesc',function (){
                            $('.short_desc').val('');
                            $('.short_desc').removeClass('short_desc_empty');
                        });
                        //Modal: Editar Pass
                        editView.on('modal:pass', Module.showModalPass);
                        //Modal: Editar Nick
                        editView.on('modal:nick', Module.changeNick);
                        //Modal: Editar Lang
                        editView.on('modal:lang', Module.changeLang);
                        //Modal: Darse de baja
                        editView.on('modal:del', Module.unsubscribe);
                        //Modal: Ocultacion


                        // editView.on('modal:hide', function() {
                        //     log.error('@ modal:hide --> ejecutado');
                        //     var title = new Backbone.Model();



                        //     var hidemodal = new Views.hideModal();
                        //     App.modal.show(modal);
                        //     modal.on('back', function() {
                        //         App.modal.close();
                        //     });

                        //     modal.content.show(hidemodal);
                        //     hidemodal.on('back', function() {
                        //         App.modal.close();
                        //     });

                        // });
                        editView.on('remember', function(rem) {
                            userInfo.set('remember', rem);
                            userInfo.save();
                        });

                        editView.on('editImg', function() {

                            var obj = {
                                back: 'app:profile:edit',
                                next: 'app:profile:edit'
                            };
                            App.execute('show_picture', obj);
                        });
                    });
            };
            Module.prepareData = function() {
                profile.set('ed_s', profile.get('edad_she'));
                profile.set('ed_h', profile.get('edad_he'));

                if(profile.get('short_desc')==="" || ! profile.get('short_desc') || profile.get('short_desc')==="17_profile.short_desc_text"){
                    profile.set('short_desc',i18n.t('17_profile.short_desc_text'));
                    profile.set('extra_short_desc_class','short_desc_empty');
                } else {
                    profile.set('extra_short_desc_class','');
                }
                if (moment(profile.get('edad_she')).isValid()) {
                    profile.set('edad_she_n', moment(profile.get('edad_she')).format('DD-MM-YYYY'));
                    profile.set('edad_she_y', moment().diff(moment(profile.get('edad_she'), 'YYYY-MM-DD'), 'years'));
                } else {
                    profile.set('edad_she_y', false);
                    profile.set('edad_she_n', false);
                }
                if (moment(profile.get('edad_he')).isValid()) {
                    profile.set('edad_he_n', moment(profile.get('edad_he')).format('DD-MM-YYYY'));
                    profile.set('edad_he_y', moment().diff(moment(profile.get('edad_he'), 'YYYY-MM-DD'), 'years'));
                } else {
                    profile.set('edad_he_y', false);
                    profile.set('edad_he_n', false);
                }
                var res = parseInt(profile.get('id_pais_residencia'), 10);
                if (res) {
                    profile.set('pais_residencia', i18n.t('countries.c_' + res));
                } else {
                    profile.set('pais_residencia', null);
                }
                var rel = parseInt(profile.get('id_tipo_relacion'), 10);
                if (rel) {
                    profile.set('tipo_relacion', i18n.t('tipo_relacion.id_tipo_relacion_' + rel));
                } else {
                    profile.set('tipo_relacion', null);
                }
                if (parseInt(profile.get('capacidad_alojamiento'), 10)) {
                    profile.set('capacidad_alojamiento', true);
                } else {
                    profile.set('capacidad_alojamiento', false);
                }

                if (profile.get('langs').length === 0) {

                    profile.set('languages', null);
                } else {
                    var languages = [];
                    _.each(profile.get('langs'), function(v, i) {
                        if (!v.id_lang) {
                            languages[i] = i18n.t('langs.l_' + v);
                        } else {
                            languages[i] = i18n.t('langs.l_' + v.id_lang);
                        }
                    });
                    profile.set('languages', languages.join(', '));
                }
                if (parseInt(profile.get('experiencia'), 10) > 0) {
                    profile.set('experiencia', true);
                } else {
                    profile.set('experiencia', false);
                }
                var est_he = parseInt(profile.get('id_estetica_he'), 10);
                if (est_he > 0) {
                    profile.set('estetica_he', i18n.t('esteticas.id_estetica_' + est_he));
                }
                var est_she = parseInt(profile.get('id_estetica_she'), 10);
                if (est_she > 0) {
                    profile.set('estetica_she', i18n.t('esteticas.id_estetica_' + est_she));
                }

                profile.set('verificacion', moment(profile.get('fecha_last_petition')).format('DD-MM-YYYY'));

                profile.set('back', 'map');

                var countries = [];
                var langs = [];
                var relationship = [];
                var esteticas = [];
                var orientacion = [];

                for (var i = 1; i <= 239; i++) {
                    countries.push({
                        id_country: i,
                        printable_name: i18n.t('countries.c_' + i)
                    });
                    if (i <= 187) {
                        langs.push({
                            id_lang: i,
                            selfname: i18n.t('langs.l_' + i)
                        });
                    }
                    if (i <= 6) {
                        relationship.push({
                            id_tipo_relacion: i,
                            tipo_relacion: i18n.t('tipo_relacion.id_tipo_relacion_' + i)
                        });
                    }
                    if (i <= 3) {
                        esteticas.push({
                            id_estetica: i,
                            estetica: i18n.t('esteticas.id_estetica_' + i)
                        });
                        orientacion.push({
                            id_or: i,
                            or: i18n.t('orientacion.id_or_' + i)
                        });
                    }

                }
                langs = _.sortBy(langs, function(el) {
                    return el.selfname;
                });
                _.each(countries, function(c) {
                    if (c.id_country === parseInt(profile.get('id_nationality_she'), 10)) {
                        profile.set('nationality_she', c.printable_name);
                    }
                    if (c.id_country === parseInt(profile.get('id_nationality_he'), 10)) {
                        profile.set('nationality_he', c.printable_name);
                    }
                });
                _.each(orientacion, function(o) {
                    if (o.id_or === parseInt(profile.get('id_or_she'), 10)) {
                        profile.set('orientacion_she', o.or);
                    }
                    if (o.id_or === parseInt(profile.get('id_or_he'), 10)) {
                        profile.set('orientacion_he', o.or);
                    }
                });

                profile.set('vis0', userInfo.get('visibility'));

                if (userInfo.get('visibility-time')) {
                    var time = moment(userInfo.get('visibility-time')).diff(moment(), 'minutes');
                    profile.set('vtime', Math.floor(time / 60) + 'h ' + time % 60 + ' m');

                } else {
                    profile.set('vtime', i18n.t('7_profile.visible'));

                }
                profile.set('rem', userInfo.get('remember'));

                profile.set('peso', _.range(40, 201));
                profile.set('altura', _.range(150, 301));
                profile.set('relationship', relationship);
                profile.set('paises', countries);
                profile.set('idiomas', langs);
                profile.set('esteticas', esteticas);
                profile.set('orientacion', orientacion);
                var imgs = profile.get('imgs');
                // _.each(profile.get('imgs'), function(img) {
                //     img.validation === 0 ? img.validation = false : img.validation = true;
                // });
                var toShow = {
                    img_url: false,
                    validation: false,
                    error: true
                };
                var imgfound;

                if (imgs.length > 0) {

                    if (imgs[0].validation === 0) {
                        toShow.validation = true;
                        toShow.img_url = imgs[0].tbn;
                        toShow.error = false;
                    }
                    // TE IMATGES

                    if (imgs[0].validation === -1) {


                        if (func.getPictStatus({imgs:imgs}) === 'photo_ok') {
                            imgfound = _.find(imgs, function(img) {
                                return img.validation === 1;
                            });

                            toShow.img_url = imgfound.tbn;
                            toShow.error = false;
                        } else if (func.getPictStatus({imgs:imgs}) === 'photo_upload') {
                            //buscar la imatge pendt de validacio
                            toShow.validation = true;
                            imgfound = _.find(imgs, function(img) {
                                return img.validation === 0;
                            });
                            toShow.img_url = imgfound.tbn;
                            toShow.error = false;
                            //buscar la imatge bona
                        } else {

                        }


                    } else {
                        //1a
                        toShow.img_url = imgs[0].tbn;
                        toShow.error = false;
                    }

                }




                profile.set('img', toShow);





                //img


                //validation

                //upload
                profile.set('imgs', profile.get('imgs'));
            };
            Module.showModalPass = function() {
                var title = new Backbone.Model();
                title.set('title', i18n.t('7_profile.changepass'));


                var passm = new Views.passModal();
                App.modal.show(passm);
                passm.on('back', function() {
                    App.modal.close();
                });

                passm.on('changepass', function(pass) {
                    var mod = new Backbone.Model();
                    mod.set('passwd', pass);
                    mod.set('langs', Module.editView.getLangs());
                    mod.set('id_client', profile.get('id_client'));
                    App.request('api:edit_user', mod)
                        .then(function() {

                            userInfo.set('passwd', pass);
                            userInfo.save();
                            App.modal.close();
                            var obj = new Backbone.Model();
                            obj.set('title', i18n.t('17_profile.pass-changed-title'));
                            obj.set('msg', i18n.t('17_profile.pass-changed-msg'));

                            var modal = new CommonViews.okModal({
                                model: obj
                            });

                            App.modal.show(modal);
                            modal.on('back', App.modal.close);
                        });
                });

            };
            Module.changeNick = function() {



                var nickmodal = new Views.nickModal();
                App.modal.show(nickmodal);
                nickmodal.on('back', function() {
                    App.modal.close();
                });

                nickmodal.on('changenick', function(nick) {
                    var mod = new Backbone.Model();
                    mod.set('nickname', nick);
                    mod.set('langs', Module.editView.getLangs());

                    mod.set('id_client', profile.get('id_client'));

                    App.request('api:edit_user', mod)
                        .then(function(resp) {
                            resp = JSON.parse(resp);
                            if (resp.message === 'nick_exist') {
                                nickmodal.exists();
                            } else {


                                Module.editView.setNick(nick);

                                App.modal.close();

                                userInfo.set('logged_val', nick);
                                userInfo.save();

                                profile.set('nickname', nick);
                                profile.save();

                            }
                        });
                });

            };
            Module.changeLang = function() {
                var mod = new Backbone.Model();

                // var langs = [ 'es', 'en', 'ru', 'fr', 'nl','de', 'ch'];
                var langs = [ 'en','ru', 'es', 'fr', 'ch', 'de'];
                var ln = [];
                _.each(langs, function(l) {
                    ln.push({
                        id_lang: l,
                        l: i18n.t('17_profile.lang.lang_' + l)
                    });
                });

                mod.set('langs', ln);


                var langmodal = new Views.langModal({
                    model: mod
                });
                App.modal.show(langmodal);
                langmodal.on('back', function() {
                    App.modal.close();
                });

                langmodal.on('changelang', function(lang) {


                    localStorage.setItem('lang', lang);
                    setTimeout(function() {
                        window.location.reload();
                    }, 200);

                });
            };
            Module.unsubscribe = function() {

                var mod = new Backbone.Model({
                    title: i18n.t('7_profile.delete'),
                    msg: i18n.t('7_profile.delete-confirm')
                });
                var unsubscribe = new Views.unsubscribeModal({
                    model: mod
                });
                App.modal.show(unsubscribe);
                unsubscribe.on('back', function() {
                    App.modal.close();
                });
                unsubscribe.on('ok', function() {
                    App.request('api:unsubscribe')
                        .then(function() {

                            localStorage.clear();
                            document.location.reload();

                        });
                });
            };
        });

        return App.profile.edit.controller;

    });
