

define(['App',
    'underscore',
    'hbs!apps/profile/edit/templates/edit',
    'hbs!apps/common/views/templates/modals/modal',
    'hbs!apps/common/views/templates/modals/general',
    'hbs!apps/common/views/templates/modals/pass',
    'hbs!apps/common/views/templates/modals/nick',
    'hbs!apps/common/views/templates/modals/hide',
    'hbs!apps/common/views/templates/modals/lang',
    'funcs',
    'i18next',
    'moment',
    'md5',
    'hammer'
], function(App, _, mainTpl, modal, general, modalPass, modalNick, modalHide, modalLang, funcs, i18n, moment, md5) {
    App.module('profile.edit.views', function(Module, App, Backbone) {

        //var main = Handlebars.compile(mainTpl);
        Module.Edit = Backbone.Marionette.ItemView.extend({
            template: mainTpl,
            triggers: {
                'click .back': 'back',
                'click .modal-pass': 'modal:pass',
                'click .modal-nick': 'modal:nick',
                'click .modal-lang': 'modal:lang',
                'click .edit-img': 'editImg',
                'click .modal-del': 'modal:del',
                'click .img-bigxll':'clickPict',
                'click .short_desc_empty': 'clickEmptyShortDesc'
            },
            events: {
                'click .back': 'setShortDesc',
                'change select.form-control': 'changeSel',
                'click select.form-control': 'changeSel',
                'focusout .short_desc':'setShortDesc',
                'focusout select.form-control':'changeSel',
                'change select[name="langs"]': 'changeLangs',
                'click select[name="langs"]':'changeLangs',
                //'click .js-unhide': 'unhide',
                'puta input[name="remember-me"]': 'remember',
                'puta input[name="hide_1"]': 'hideme',
                'puta input[name="hide_2"]': 'triggerhide'

            },
             onRender: function (){
              window.scrollTo(0, 0);
            },
            changeToggle: function(e) {
                e.preventDefault();


            },
            triggerhide: function(e) {
                e.preventDefault();
                this.$('input[name="hide_1"]').click();
            },
            unhide: function(e) {
                e.preventDefault();
                if (!this.$('.vtime').data('enabled')) {
                    //this.trigger('reload');


                    //this.$('input[name="hide_1"]').click();
                    this.fakeToggle();
                }
            },
            fakeToggle:function (){
                this.$('.hide_1 .toggle').toggles(false);
            },
            remember: function(e) {

                this.trigger('remember', $(e.currentTarget).prop('checked'));

            },
            getLangs: function() {
                return this.$el.find('select[name="langs"]').val();
            },
            changeSel: function(e) {
                var self = this;
                setTimeout(function() {

                e.preventDefault();

                $(e.target).siblings('span').html($(e.target).find('option:selected').text());
                var val = $(e.target).val();

                var obj = {};
                if (val === 'false') {
                    val = false;
                }
                if (val === 'true') {
                    val = true;
                }

                obj[$(e.target).attr('name')] = val;
                console.log('UPDATE',val)
                self.trigger('update', obj);
                },1);
            },
            changeLangs: function(e) {
                e.preventDefault();
                var malaApi = this.$el.find('select[name="id_pais_residencia"]').val();

                var opts = ($(e.target).find('option:selected'));
                var arr = [];
                _.each(opts, function(v, i) {

                    arr[i] = $(v).html();
                });

                $(e.target).siblings('span').html(arr.join(', '));
                var obj = {};
                obj[$(e.target).attr('name')] = $(e.target).val();
                obj.id_pais_residencia = malaApi;

                this.trigger('update', obj);
            },
            setShortDesc: function(e) {
                var obj = {};
                obj.short_desc = $('.short_desc').val();
                this.trigger('update', obj);
            },
            setNick: function(nick) {
                this.$('.user-zone h2').html(nick);
            },
            showHideTime: function(time) {


                if (time) {

                    this.$el.find('.vtime').show();
                    this.$el.find('.hide_text').show();
                    this.$el.find('.vtime span').html(time);
                    this.$('.js-unhide').removeClass('hidden');
                } else {
                    this.$el.find('.vtime').hide();
                    this.$el.find('.hide_text').hide();
                }
            },

            hideme: function() {





                //Le enviamos vlaor al controller..
                var hidden = this.$el.find('input[name="hide_1"]').prop('checked');
                this.showHideTime('8h 00 m');
                this.$('.js-unhide').show();
                this.trigger('hide', hidden);

            }
        });
        Module.simpleModal = Backbone.Marionette.Layout.extend({
            template: modal,
            regions: {
                content: '#modal-body'
            },
            triggers: {
                'click .back': 'back'
            },
            onShow: function() {

                this.$el.find('#modal').fadeIn('fast');

            }
            // fade: function() {
            //     this.$el.find('#modal').fadeOut('fast');
            // }

        });

        Module.passModal = Backbone.Marionette.ItemView.extend({
            template: modalPass,
            events: {
                'click button.submit': 'validate',
                'focus input': 'clear'
            },
            triggers: {
                'click .back': 'back'
            },
            validate: function(e) {
                var self = this;
                e.preventDefault();
                this.clear();
                var pass = this.$el.find('input[name="pass"]').val();
                var newpass = this.$el.find('input[name="newpass"]').val();
                var repeatpass = this.$el.find('input[name="repeatpass"]').val();
                var userInfo = App.request('entities:user_info');
                userInfo.fetch({
                    success: function() {

                        var errors = false;
                        if (newpass === '' || repeatpass === '' || pass === '') {
                            errors = true;
                            funcs.addError('input[name="newpass"],input[name="repeatpass"],input[name="pass"]', i18n.t('2_register.mandatory'));
                            self.$el.find('span.generror').addClass('error').html(i18n.t('2_register.mandatory'));
                        }
                        if (md5(pass) !== userInfo.get('passwd')) {

                            errors = true;
                            funcs.addError('input[name="pass"]', i18n.t('7_profile.wrongpass'));
                            self.$el.find('span.passw').addClass('error').html(i18n.t('7_profile.wrongpass'));
                        }
                        if (newpass === pass) {
                            errors = true;
                            funcs.addError('input[name="newpass"] ', i18n.t('7_profile.samepass'));
                            self.$el.find('span.generror').addClass('error').html(i18n.t('7_profile.samepass'));
                        }
                        if (newpass !== repeatpass) {
                            errors = true;
                            funcs.addError('input[name="newpass"],input[name="repeatpass"] ', i18n.t('7_profile.passdontmatch'));
                            self.$el.find('span.generror').addClass('error').html(i18n.t('7_profile.passdontmatch'));
                        }

                        if (newpass.length<6) {
                            errors = true;
                            funcs.addError('input[name="newpass"] ', i18n.t('2_register.min_6_chars'));
                            self.$el.find('span.generror').addClass('error').html(i18n.t('2_register.min_6_chars'));
                        }

                        if (!errors) {
                            self.trigger('changepass', md5(newpass));
                        }
                    }
                });


            },
            clear: function() {
                funcs.clearError();
                this.$el.find('span').html('');
            }
        });
        Module.nickModal = Backbone.Marionette.ItemView.extend({
            template: modalNick,
            events: {
                'click button.submit': 'validate',
                'focus input': 'clear'
            },
            triggers: {
                'click .back': 'back'
            },
            validate: function(e) {
                var self = this;
                e.preventDefault();
                this.clear();
                var pass = this.$el.find('input[name="pass"]').val();
                var nick = this.$el.find('input[name="newnick"]').val();
                var userInfo = App.request('entities:user_info');
                userInfo.fetch({
                    success: function() {

                        var errors = false;
                        if (nick === '' || pass === '') {
                            errors = true;
                            funcs.addError('input[name="newnick"],input[name="pass"]', i18n.t('2_register.mandatory'));
                            self.$el.find('span.generror').addClass('error').html(i18n.t('2_register.mandatory'));
                        }
                        if (md5(pass) !== userInfo.get('passwd')) {

                            errors = true;
                            funcs.addError('input[name="pass"]', i18n.t('7_profile.wrongpass'));
                            self.$el.find('span.generror').addClass('error').html(i18n.t('7_profile.wrongpass'));
                        }

                        if (!errors) {

                            self.trigger('changenick', nick);
                        }
                    }
                });


            },
            clear: function() {
                funcs.clearError();
                this.$el.find('span').html('');
            },
            exists: function() {
                funcs.addError('input[name="newnick"]', i18n.t('7_profile.nickexists'));
                this.$el.find('span.generror').addClass('error').html(i18n.t('7_profile.nickexists'));
            }
        });
        Module.hideModal = Backbone.Marionette.ItemView.extend({
            template: modalHide,
            triggers: {
                'click .back': 'back'

            }
        });
        Module.langModal = Backbone.Marionette.ItemView.extend({
            template: modalLang,
            triggers: {
                'click .back': 'back'
            },
            events: {
                'click .change-lang': 'changelang',
                'change select[name="lang"]': 'changeS',
                'focusout select[name="lang"]': 'changeS'
            },
            changelang: function(e) {
                e.preventDefault();
                var lang = this.$('select[name="lang"]').val();
                this.trigger('changelang', lang);
            },
            changeS: function(e) {
                e.preventDefault();
                if (this.$('select[name="lang"]').val() !=='0') {
                    this.changeSel(e);

                }
            },
            changeSel: function(e) {
                e.preventDefault();
                this.showButton();
                var selOption = this.$('select[name="lang"] option:selected').text();
                this.$('span.lang-val').html(selOption);

            },
            showButton: function(){
                if(this.$('.change-lang').is(':hidden')){
                    this.$('.change-lang').fadeIn();
                }
            }

        });
        Module.unsubscribeModal = Backbone.Marionette.ItemView.extend({
            template: modal,
            triggers: {
                'click .back': 'back',
                'click .ok': 'ok'

            }
        });


    });

    return App.profile.edit.views;

});
