


define(['App',
        'api',
        'underscore',
        'backbone',
        'apps/profile/public/views',
        'apps/common/views/common_views',
        'i18next',
        'moment'
    ],
    function(App, api, _, Backbone, Views, CommonViews, i18n, moment) {
        App.module('profile.pub.controller', function(Module, App) {
            var close, confirms, favorites, reports, block, myProfile;

            Module.addInitializer(function() {

                close = new CommonViews.simpleOkModal({});
                confirms = App.request('entities:confirms');
                favorites = App.request('entities:favorites');
                reports = App.request('entities:reports');
                block = App.request('entities:block');
                myProfile = App.request('entities:profile');
            });
            Module.show = function(type, data, images) {
                App.showTooltip = true;
                Module.data = data;

                if (images) {
                    Module.parsedata(data, type, function(t, d) {
                        Module.Gallery(d.imgs, d.id_client, 'map');
                    });

                } else {

                    Module.parsedata(data, type, function(t, d) {
                        Module.Render(t, d);
                    });
                }

            };
            Module.parsedata = function(data, type, cb) {

                if (moment(data.edad_she).isValid()) {
                    data.edad_she_n = moment(data.edad_she).format('DD-MM-YYYY');
                    data.edad_she_y = moment().diff(moment(data.edad_she, 'YYYY-MM-DD'), 'years');
                } else {
                    data.edad_she_y = false;
                    data.edad_she_n = false;
                }
                if (moment(data.edad_he).isValid()) {
                    data.edad_he_n = moment(data.edad_he).format('DD-MM-YYYY');
                    data.edad_he_y = moment().diff(moment(data.edad_he, 'YYYY-MM-DD'), 'years');
                } else {
                    data.edad_he_y = false;
                    data.edad_he_n = false;
                }
                var res = parseInt(data.id_pais_residencia, 10);
                if (res) {
                    data.pais_residencia = i18n.t('countries.c_' + res);
                } else {
                    data.pais_residencia = null;
                }
                var rel = parseInt(data.id_tipo_relacion, 10);
                if (rel) {
                    data.tipo_relacion = i18n.t('tipo_relacion.id_tipo_relacion_' + rel);
                } else {
                    data.tipo_relacion = null;
                }
                if (parseInt(data.capacidad_alojamiento, 10)) {
                    data.capacidad_alojamiento = true;
                } else {
                    data.capacidad_alojamiento = false;
                }
                if (data.langs.length === 0) {
                    data.languages = null;
                } else {
                    data.languages = [];
                    _.each(data.langs, function(v, i) {
                        data.languages[i] = '<img src="assets/img/langs/' + v.code + '.png" alt="' + i18n.t(
                            'langs.l_' + v.id_lang) + '" title="' + i18n.t('langs.l_' + v.id_lang) + '"></img>';
                    });
                    data.languages = data.languages.join(' ');
                }
                if (parseInt(data.experiencia, 10) > 0) {
                    data.experiencia = true;
                } else {
                    data.experiencia = false;
                }
                var est_he = parseInt(data.id_estetica_he, 10);
                if (est_he > 0) {
                    data.estetica_he = i18n.t('esteticas.id_estetica_' + est_he);
                }
                var est_she = parseInt(data.id_estetica_she, 10);
                if (est_she > 0) {
                    data.estetica_she = i18n.t('esteticas.id_estetica_' + est_she);
                }

                var or_she = parseInt(data.id_or_she, 10);
                if (or_she > 0) {
                    data.orientacion_she = i18n.t('orientacion.id_or_' + or_she);
                }
                var or_he = parseInt(data.id_or_he, 10);
                if (or_he > 0) {
                    data.orientacion_he = i18n.t('orientacion.id_or_' + or_he);
                }

                data.verificacion = moment(data.fecha_last_petition).format('DD-MM-YYYY');

                //Validamos si verificado;





                data.report_active = false;
                //Validamos si lo tiene reportado
                var is = _.find(reports.models, function(el) {
                    return el.get('id_client_to') === data.id_client;
                });
                if (is) {
                    data.report_active = true;
                }
                data.imgs = _.filter(data.imgs, function(img) {

                    return img.validation === 1;
                });

                cb(type, data);





            };

            Module.Render = function(type, data) {

                var mod = new Backbone.Model();
                mod.set(data);
                if (Module.getBloc()) {

                    mod.set('isBloc', true);
                }
                if (Module.getFavs(data)) {

                    mod.set('isFav', true);
                }
                if (Module.isVerified(data)) {

                    mod.set('isVerified', true);
                }

                if (parseInt(data.user_type, 10) === 1) {
                    mod.set('isSingle', true);
                    mod.set('isWoman', true);

                }

                if (parseInt(data.user_type, 10) === 2) {
                    mod.set('isSingle', true);
                    mod.set('isMan', true);

                }



                var profile = new Views.Public({
                    model: mod
                });
                Module.profileView = profile;

                App.mainRegion.slideShow(profile, type);
                profile.on('back', function() {

                    var prev;
                    if (Module.isBlocked()) {
                        prev = 'map';
                    } else {
                        prev = mod.get('back');
                    }

                    if (prev === 'app:chat:conversation') {
                        App.execute('app:chat:conversation', parseInt(mod.get('id_client'), 10), null, 'right');
                    } else if (prev === 'map') {
                        App.execute('app:' + prev, 'right');
                        //App.execute('app:map:update_center');
                    } else if (prev === 'pict') {
                        App.execute('app:pictures:img_detail', data.modData.picts, data.modData.back, data.modData.cid, data.modData.type, data.modData.dist, data.modData.actions,data.modData.id_picture);
                    } else {
                        App.execute('app:' + prev, 'right');
                    }
                });
                profile.on('openchat', function() {
                    var canChat = App.request('app:chat:check', myProfile, mod);
                    // canChat.me = false;

                    if (!canChat.me) {
                        App.execute('app:chat:no_chat_me');
                        return;
                    }
                    if (!canChat.them) {
                        App.execute('app:chat:no_chat_them');
                        return;
                    }

                    if (canChat.me && canChat.them) {
                        mod.set('back', 'profile');
                        App.execute('app:chat:new_message', mod.toJSON());
                    }


                });
                profile.on('gallery', function() {
                    Module.Gallery(data.imgs, data.id_client);
                });
                profile.on('showMap', function() {
                    App.execute('app:chat:quickmap', data.id_client, 'profile');
                });
                profile.on('favorite', function() {

                    Module.Favorites(data);
                });
                profile.on('block', function() {
                    Module.Block();
                });
                profile.on('report', function() {
                    Module.Report(data);
                });
                profile.on('verify', function() {
                    Module.Verify(data);
                });

            };
            Module.Gallery = function(arr, cid, back) {
                if (!back) back = 'profile';


                _.each(arr, function(elem) {

                    elem.img = api.server + '/public/frontend/img/clientes2/' + elem.large;
                });

                App.execute('app:pictures:show_slider', arr, back, parseInt(cid, 10), 'left','',{like:true});



            };



        });

        return App.profile.pub.controller;

    });
