


define(['App',
        'underscore',
        'backbone',
        'apps/profile/public/views',
        'apps/common/views/common_views',
        'i18next',
        'moment',
        'apps/common/lib/spinner'

    ],
    function(App, _, Backbone, Views, CommonViews, i18n, moment, spinner) {

        App.module('profile.pub.controller', function(Module, App) {
            var close,confirms,favorites,reports,block;
            
            Module.addInitializer(function() {

                close = new CommonViews.simpleOkModal({});
                confirms = App.request('entities:confirms');
                favorites = App.request('entities:favorites');
                reports = App.request('entities:reports');
                block = App.request('entities:block');
            });
            Module.getFavs = function(data) {

                var fav = _.find(favorites.models, function(item) {

                    return item.get('id_swinger_favorite') === data.id_client;
                });

                if (fav !== undefined) {
                    return true;
                } else {

                    return false;
                }

            };
            Module.getBloc = function() {

                var blockExist = _.find(block.models, function(item) {

                    return item.get('id_swinger_bloqueado') === Module.data.id_client;
                });

                if (blockExist !== undefined) {
                    return true;
                } else {

                    return false;
                }

            };
            Module.isBlocked = function(){
                return this.blocked;

            };

            Module.isVerified = function(data) {


                //log.error('FALTA API GET_VERIFIEDS');
                //return false;

                var conf = _.find(confirms.models, function(item) {

                    return item.get('id_client_to') === data.id_client;
                });

                return (conf !== undefined);
                

            };
            Module.Favorites = function(data) {

                var obj = new Backbone.Model();
                obj.set('title', i18n.t('17_profile.favorites'));
                var modal;

                if (Module.getFavs(data)) {
                    Module.removeFavorite();

                } else {
                    if (Module.getBloc()) {
                        //YA BLOQUEADO...
                        obj.set('msg', i18n.t('17_profile.fav-is-blocked'));
                        modal = new CommonViews.okModal({
                            model: obj
                        });
                        App.modal.show(modal);
                        modal.on('back', function() {

                            modal.openMenu();
                            App.modal.close();
                        });
                    } else {


                        obj.set('msg', i18n.t('17_profile.fav-confirm'));
                        modal = new CommonViews.simpleOkModal({
                            model: obj
                        });
                        App.modal.show(modal);
                        modal.on('back', function() {

                            modal.openMenu();
                            App.modal.close();
                        });

                        modal.on('ok', function() {
                            App.modal.close();
                            spinner(true);
                            App.request('api:set_favorite', data.id_client, 1).then(function(res) {
                                spinner(false);
                                res = JSON.parse(res);

                                modal.openMenu();
                                App.modal.close();

                                Module.profileView.changeFav(true);



                                var obj = new Backbone.Model({
                                    id_swinger_favorite: data.id_client
                                });
                                favorites.add(obj);

                            });
                        });
                    }

                }

            };

            Module.removeFavorite = function() {
                var obj = new Backbone.Model();
                obj.set('title', i18n.t('17_profile.favorites-remove'));
                obj.set('msg', i18n.t('17_profile.fav-remove-text'));
                var modal = new CommonViews.simpleOkModal({
                    model: obj
                });
                spinner(true);

                modal.on('ok', function() {
                    App.modal.close();
                    App.request('api:set_favorite', Module.data.id_client, 0).then(function() {
                        spinner(false);

                        modal.openMenu();
                        App.modal.close();

                        Module.profileView.changeFav(false);

                        var favs = _.filter(favorites.models, function(item) {

                            return item.get('id_swinger_favorite') === Module.data.id_client;
                        });
                        _.each(favs, function(model) {
                            favorites.remove(model);
                        });


                    });

                });
                modal.on('back', function() {
                    modal.openMenu();
                    App.modal.close();
                });
                App.modal.show(modal);
            };

            Module.Block = function() {


                var obj = new Backbone.Model();
                obj.set('title', i18n.t('18_profile.block'));
                var modal;

                if (Module.getBloc()) {

                    obj.set('title', i18n.t('18_profile.block-del'));
                    obj.set('msg', i18n.t('17_profile.unblock-text'));
                    modal = new CommonViews.simpleOkModal({
                        model: obj
                    });
                    modal.on('ok', function() {
                        Module.UnBlockCall();

                    });
                } else {

                    obj.set('msg', i18n.t('17_profile.block-confirm'));
                    modal = new CommonViews.simpleOkModal({
                        model: obj
                    });
                    modal.on('ok', function() {
                        Module.BlockCall();

                    });
                }


                App.modal.show(modal);
                modal.on('back', function() {
                    modal.openMenu();
                    App.modal.close();
                });


            };
            Module.UnBlockCall = function() {
                var self = this;
                App.modal.close();
                spinner(true);
                App.request('api:set_blocked', Module.data.id_client, 0).then(function(res) {
                    self.blocked = false;

                    res = JSON.parse(res);

                    Module.profileView.changeBlock(false);
                    Module.profileView.changeFav(false);

                    var blockExists = _.filter(block.models, function(item) {

                        return item.get('id_swinger_bloqueado') === Module.data.id_client;
                    });


                    _.each(blockExists, function(model) {
                        block.remove(model);
                        // body...

                    });

                    close.openMenu();
                    spinner(false);


                });
            };
            Module.BlockCall = function() {
                var self = this;
                App.modal.close();
                spinner(true);
                App.request('api:set_blocked', Module.data.id_client, 1).then(function(res) {
                    self.blocked = true;

                    res = JSON.parse(res);

                    Module.profileView.changeBlock(true);
                    Module.profileView.changeFav(false);
                    var obj = new Backbone.Model({
                        id_swinger_bloqueado: Module.data.id_client
                    });
                    block.add(obj);

                    if (Module.getFavs) {
                        App.request('api:set_favorite', Module.data.id_client, 0).then(function() {
                            var modal = new CommonViews.simpleOkModal({
                                model: obj
                            });
                            modal.openMenu();
                            App.modal.close();
                            var favList = _.filter(favorites.models, function(item) {

                                return item.get('id_swinger_favorite') === Module.data.id_client;
                            });
                            _.each(favList, function(model) {

                                favorites.remove(model);
                            });
                            App.execute('app:chat:remove_conv');
                            spinner(false);

                        });
                    } else {
                        spinner(false);
                        close.openMenu();
                    }


                });
            };


            Module.ReportConfirm = function(motivo) {
                var obj = new Backbone.Model();
                obj.set('msg', i18n.t('17_profile.report-confirm'));
                var modal = new CommonViews.simpleOkModal({
                    model: obj
                });

                modal.on('ok', function() {
                    spinner(true);
                    App.modal.close();
                    App.request('api:report_user', Module.data.email, motivo).then(function(res) {
                        spinner(false);
                        res = JSON.parse(res);

                        close.openMenu();
                        //Añadimos el modelo a la coleccion
                        var obj = new Backbone.Model({
                            id_client_to: Module.data.id_client
                        });
                        reports.add(obj);
                        //Actualizamos report
                        Module.profileView.changeReport();

                        //Mostramos mensaje respuesta
                        obj = new Backbone.Model();
                        obj.set('msg', i18n.t('17_profile.report-response'));

                        modal = new CommonViews.okModal({
                            model: obj
                        });
                        modal.on('back', function() {
                            App.modal.close();
                            Module.ReportAndBlock();
                        });
                        App.modal.show(modal);




                    });
                });
                modal.on('back', function() {
                    close.openMenu();
                    App.modal.close();
                });
                App.modal.show(modal);

            };
            Module.ReportAndBlock = function() {
                if (!Module.getBloc()) {

                    var obj = new Backbone.Model();
                    obj.set('msg', i18n.t('17_profile.report-and-block'));
                    var modal = new CommonViews.simpleOkModal({
                        model: obj
                    });
                    modal.on('ok', function() {


                        Module.BlockCall();

                    });
                    modal.on('back', function() {
                        close.openMenu();
                        App.modal.close();
                    });
                    App.modal.show(modal);
                } else {
                    App.modal.close();
                }

            };
            Module.Report = function(data) {
                //Validamos si lo tiene reportado
                var is = _.find(reports.models, function(el) {


                    return el.get('id_client_to') === data.id_client;
                });
                if (is) {
                    data.report_active = false;
                } else {

                    //TODO: Select de motivos
                    var obj = new Backbone.Model();
                    var motives = [];
                    _.each(_.range(0, 6), function(i) {
                        var j = i + 1;
                        motives[i] = {
                            value: j,
                            motive: i18n.t('17_profile.motive.motive_' + j)
                        };
                    });
                    obj.set('motives', motives);

                    var modal = new Views.reportModal({
                        model: obj
                    });

                    //Parche per tancar
                    var close = new CommonViews.simpleOkModal({});

                    App.modal.show(modal);
                    modal.on('back', function() {

                        close.openMenu();
                        App.modal.close();
                    });
                    modal.on('report', function(motivo) {

                        Module.ReportConfirm(motivo);


                    });

                }
            };
            Module.updateUserCache= function (uid) {
                
                if(App.api.userCache[uid]){
                    var json = JSON.parse(App.api.userCache[uid]);
                    json.data.confirms = json.data.confirms +1;
                    App.api.userCache[uid] = JSON.stringify(json);
                }
               
            };
            Module.Verify = function(data) {
                var modal;

                var obj = new Backbone.Model();
                if (Module.isVerified(data)) {
                    //SI ya verificada, no volvemos a verificar..
                    obj.set('msg', i18n.t('17_profile.veri-exists'));
                    modal = new CommonViews.okModal({
                        model: obj
                    });
                    modal.on('ok', function() {
                        App.modal.close();
                    });
                } else {
                    obj.set('msg', i18n.t('17_profile.veri-confirm'));
                    modal = new CommonViews.simpleOkModal({
                        model: obj
                    });
                    modal.on('ok', function() {
                        spinner(true);
                        App.request('api:verify', data.email).then(function(res) {
                            spinner(false);

                            Module.profileView.setInactive();

                            confirms.add({
                                'id_client_to': data.id_client
                            });
                            Module.updateUserCache(data.id_client);
                            res = JSON.parse(res);


                            App.modal.close();

                            Module.profileView.changeVerified();
                            //data.isVerified = true;

                        });
                    });
                }
                App.modal.show(modal);
                modal.on('back', function() {

                    App.modal.close();
                });



            };


        });

        return App.profile.pub.controller;

    });
