

define(['App',

    'hbs!apps/profile/public/templates/profile',
    'hbs!apps/common/views/templates/modals/modal',
    'hbs!apps/common/views/templates/modals/accept-cancel',
    'hbs!apps/common/views/templates/modals/accept',
    'hbs!apps/common/views/templates/modals/report',
    'i18next'
], function(App, publicTPL, modal, acModal, acceptModal, reportModal, i18n) {

    App.module('profile.pub.views', function(Module, App, Backbone) {


        Module.Public = Backbone.Marionette.ItemView.extend({
            template: publicTPL,
            triggers: {
                'click .back': 'back',
                'click .openchat': 'openchat',
                'click .opengallery': 'gallery',
                'click .verifyActive': 'verify',
                'click a.fav ': 'favorite',
                'click a.block ': 'block',
                'click a.report ': 'report',
                'click .picta': 'gallery',
                'click .show_map_profile': 'showMap'


            },
            events: {
                'click #menu-right': 'openMenu'
            },
            onRender: function() {
                window.scrollTo(0, 0);
            },
            openMenu: function(e) {
                if (e) e.preventDefault();
                if (this.$el.find('#profile-menu').hasClass('closed')) {

                    this.$el.find('#profile-menu').removeClass('closed').addClass('opened');


                } else {

                    this.$el.find('#profile-menu').removeClass('opened').addClass('closed');

                }

            },
            changeFav: function(value) {

               
                if(value){

                    $('.is-fav').addClass('active');
                    this.$('.fav span').html(i18n.t('18_profile.favoritos-del'));
                }
                else{
                    $('.is-fav').removeClass('active');
                    this.$('.fav span').html(i18n.t('18_profile.favoritos'));
                }

            },


            changeVerified: function() {
                $('.user-zone.public .veri-txt span').html(parseInt($('.user-zone.public .veri-txt span').html(), 10) + 1);
            },
            setInactive: function() {

                this.$el.find('.verifyActive').addClass('hidden');
                this.$el.find('.verifyInactive').addClass('show');
                this.$el.find('.verifyInactive').removeClass('hidden');
            },
            changeReport: function() {
                this.$('.report').addClass('cross');
            },
            changeBlock: function(value) {

                if (value) {
                    this.$('.block span').html(i18n.t('18_profile.block-del'));
                    this.$('.is-fav').addClass('blocked');
                } else {

                    this.$('.block span').html(i18n.t('18_profile.block'));
                    this.$('.is-fav').removeClass('blocked');

                }
            }




        });
        Module.acModal = Backbone.Marionette.ItemView.extend({
            template: acModal,
            triggers: {
                'click .accept': 'accept',
                'click .back': 'back'
            }

        });
        Module.acceptModal = Backbone.Marionette.ItemView.extend({
            template: acceptModal,
            triggers: {
                'click .accept': 'accept'
            }

        });
        Module.reportModal = Backbone.Marionette.ItemView.extend({
            template: reportModal,
            triggers: {
                'click .accept': 'accept',
                'click .back': 'back'
            },
            events: {

                'click .report': 'report'

            },
            report: function(e) {
                e.preventDefault();
                var motivo = this.$('input[name="report"]:checked + label').text();
                this.trigger('report', motivo);
            }
        });
    });

    return App.profile.pub.views;

});
