


define(['App',
        'underscore',
        'backbone',
        'apps/profile/quick/views',
        'i18next',
        'moment',
        'apps/common/lib/spinner'

    ],
    function(App, _, Backbone, Views, i18n, moment,spinner) {
        App.module('profile.quick.controller', function(Module, App) {

            Module.show = function(id, type) {
                //request user_info

                App.request('api:get_user', parseInt(id, 10), true)
                    .then(function(data) {
                        data = JSON.parse(data);
                        data = data.data;


                        if (moment(data.edad_she).isValid()) {
                            data.edad_she_n = moment(data.edad_she).format('DD-MM-YYYY');
                            data.edad_she_y = moment().diff(moment(data.edad_she, 'YYYY-MM-DD'), 'years');
                        } else {
                            data.edad_she_y = false;
                            data.edad_she_n = false;
                        }
                        if (moment(data.edad_he).isValid()) {
                            data.edad_he_n = moment(data.edad_he).format('DD-MM-YYYY');
                            data.edad_he_y = moment().diff(moment(data.edad_he, 'YYYY-MM-DD'), 'years');
                        } else {
                            data.edad_he_y = false;
                            data.edad_he_n = false;
                        }
                        var res = parseInt(data.id_pais_residencia, 10);
                        if (res) {
                            data.pais_residencia = i18n.t('countries.c_' + res);
                        } else {
                            data.pais_residencia = null;
                        }
                        var rel = parseInt(data.id_tipo_relacion, 10);
                        if (rel) {
                            data.tipo_relacion = i18n.t('tipo_relacion.id_tipo_relacion_' + rel);
                        } else {
                            data.tipo_relacion = null;
                        }
                        if (parseInt(data.capacidad_alojamiento, 10)) {
                            data.capacidad_alojamiento = true;
                        } else {
                            data.capacidad_alojamiento = false;
                        }
                        if (data.langs.length === 0) {
                            data.languages = null;
                        } else {
                            data.languages = [];
                            _.each(data.langs, function(v, i) {
                                data.languages[i] = '<img src="assets/img/langs/' + v.code + '.png" alt="' + i18n.t('langs.l_' + v.id_lang) + '" title="' + i18n.t('langs.l_' + v.id_lang) + '"></img>';
                            });
                            data.languages = data.languages.join(' ');
                        }

                        var mod = new Backbone.Model();
                        mod.set(data);
                        var quick = new Views.Quick({
                            model: mod
                        });
                        App.mainRegion.slideShow(quick, type);
                        quick.on('back', function() {
                            App.execute('app:chat:conversation', id, null, 'right');

                        });
                        quick.on('profile', function() {
                            data.back = 'profile:quickview';
                            spinner(true);
                            App.execute('app:profile:show', 'left', data);


                        });
                    });

            };



        });

        return App.profile.quick.controller;

    });
