
define([], function() {

    var PushNotification = function() {};


    // Call this to register for push notifications. Content of [options] depends on whether we are working with APNS (iOS) or GCM (Android)
    PushNotification.prototype.register = function(successCallback, errorCallback, options) {
        if (errorCallback == null) {
            errorCallback = function() {};
        }

        if (typeof errorCallback !== 'function') {

            return;
        }

        if (typeof successCallback !== 'function') {

            return;
        }
        
        cordova.exec(successCallback, errorCallback, 'PushPlugin', 'register', options);
    };

    // Call this to unregister for push notifications
    PushNotification.prototype.unregister = function(successCallback, errorCallback) {
        if (errorCallback == null) {
            errorCallback = function() {};
        }

        if (typeof errorCallback !== 'function') {

            return;
        }

        if (typeof successCallback !== 'function') {

            return;
        }

        cordova.exec(successCallback, errorCallback, 'PushPlugin', 'unregister', []);
    };


    // Call this to set the application icon badge
    PushNotification.prototype.setApplicationIconBadgeNumber = function(successCallback, badge) {
        

        if (typeof errorCallback !== 'function') {

            return;
        }

        if (typeof successCallback !== 'function') {

            return;
        }

        cordova.exec(successCallback, successCallback, 'PushPlugin', 'setApplicationIconBadgeNumber', [{
            badge: badge
        }]);
    };

    return  new PushNotification;
});
