

define(['App',
        'underscore',

        'apps/search/views',
        'apps/common/views/common_views',
        'backbone',
        'apps/common/lib/spinner',
        'syphon',
        'apps/search/entities'
    ],
    function(App, _, Views, CommonViews, Backbone, spinner, Syphon ) {

        App.module('search.list.controller', function(Module, App) {
            var search, userInfo, profile;
            Module.addInitializer(function() {
                search = App.request('entities:search');
                userInfo = App.request('entities:user_info');
                profile = App.request('entities:profile');

            });


            Module.show = function() {


                var geocoder = new google.maps.Geocoder();

                search.set('closesearch', userInfo.get('closesearch'));

                search.set('isSingle', profile.get('isSingle'));
                search.set('isWoman', profile.get('isWoman'));
                search.set('isMan', profile.get('isMan'));

                var view = new Views.Main({
                    model: search
                });
                var initialSearch = search.toJSON();

                //Back per defecte
                // view.on('back', function() {
                //     search.set(initialSearch);
                //     App.execute('app:map', 'right');
                // });


                view.on('search', function(info) {

                    geocoder.geocode({
                        'address': info.view.$('input[name="city"]').val()
                    }, function(results, status) {

                        _.each(results.address_components, function(comp) {

                        });
                        if (status === google.maps.GeocoderStatus.OK) {

                            view.setOptions(results);
                        } else {

                        }
                    });
                });
                view.on('selected', function(position, city, country) {

                    view.clean();

                    search.set('city_lon', position.lng());
                    search.set('city_lat', position.lat());
                    search.set('city', city);
                    search.set('country', country);


                });
                view.on('closesearch', function(attr) {
                    userInfo.set('closesearch', attr);
                    userInfo.save();


                });


                var actionSubmit = function(info) {
                    var data = Syphon.serialize(info.view);

                    if (data.residents === true && data.closer === true) {
                        search.set(data);
                        spinner(true);


                        //alert('buscamos geocoder');


                        var geocoder = new google.maps.Geocoder();
                        geocoder.geocode({
                            location: new google.maps.LatLng(userInfo.get('lat'), userInfo.get('lon'))
                        }, function(results) {
                            var country = _.find(results[0].address_components, function(comp) {
                                if (comp.types[0] === 'country') {
                                    return true;
                                } else {
                                    return false;
                                }
                            });

                            search.set('country', country.short_name);
                            App.execute('app:map');
                            App.execute('app:map:update_center');

                        });




                    } else {

                        search.set(data);

                        App.execute('app:map:update_center');
                        App.execute('app:map');
                    }

                };
                view.on('submit',actionSubmit);
                view.on('back',actionSubmit);

                App.mainRegion.slideShow(view, 'left');

            };

        });

        return App.search.list.controller;

    });
