


define(['App',
        'underscore',
        'handlebars',
        'hbs!apps/search/templates/list',
        'templates/helpers/toggle'
    ],
    function(App, _, Handlebars, list, Toggle) {

        App.module('search.search.views', function(Module, App, Backbone, Marionette) {



            Module.Main = Marionette.ItemView.extend({
                template: list,
                className: 'search',
                triggers: {
                    'click .back': 'back',
                    'click .adv-search': 'search',
                    //'click input[type=checkbox]': 'option_changed',
                    'submit': 'search',
                    'click .submit_btn:not(.disabled)': 'submit'
                },
                events: {
                    'click .input-city': 'select',
                    'puta input[name="closer"]': 'toggleButton',
                    'puta .toggle_item input': 'isFilter',
                    // 'puta .onlymen input': 'onlyOne',
                    // 'puta .onlywomen input': 'onlyOne',
                    'keypress input': 'activeSearch',
                    'click .js-tab': 'toggleTab'
                        // 'puta .toggle_item.clients input': 'checkSelectedOptions'
                },
                toggleTab: function(e) {
                    var $tab = this.$el.find(e.currentTarget);
                    var $tabContent = this.$el.find('.js-tab-content');
                    var $activeTab = $tabContent.closest('.js-tab-content[data-tab=' + $tab.attr('data-tab') + ']');

                    $tabContent.removeClass('active');
                    $activeTab.addClass('active');
                    this.$el.find('.js-tab').removeClass('active');
                    $tab.addClass('active');

                    // var coord = this.$el.find('.tabs').offset().top;
                    // var coord = 25;


                    // $('html, body').stop().animate({
                    //     scrollTop: coord
                    // }, 500);
                },
                onRender: function() {
                    $('body').removeClass('noscroll');
                    // var hasScroll = $('body').hasClass('noscroll');
                    // if(hasScroll){
                    //   window.alert('EEEP!, algo falla');
                    // }

                },
                onlyOne: function(e) {
                    var self = this;
                    var $el = $(e.target);


                    if ($el.prop('checked')) {
                        if ($el.attr('name') === 'onlywomen') {
                            self.$el.find('.onlymen .toggle').toggles(false);
                        } else {
                            self.$el.find('.onlywomen .toggle').toggles(false);
                        }
                    }

                },
                isFilter: function(e) {

                    if (($(e.target).attr('name') === 'clients' ||
                            $(e.target).attr('name') === 'clubs' ||
                            $(e.target).attr('name') === 'verified' ||
                            $(e.target).attr('name') === 'residents')) {
                        this.showButton();
                    }
                },
                activeSearch: function() {

                    this.$('.adv-search').removeClass('busquedainactiva');
                    this.$('.adv-search').addClass('busquedaactiva');
                },
                inactiveSearch: function() {

                    this.$('.adv-search').removeClass('busquedaactiva');
                    this.$('.adv-search').addClass('busquedainactiva');
                },
                deactivate: function() {
                    this.$('input[name="closer"]').click();
                },
                select: function(e) {
                    //e.preventDefault();
                    $(e.target).select();
                    $(e.target).focus();

                    //this.activeSearch();
                    this.hideButton();
                    this.$el.find('.closer .toggle').toggles(false);

                },

                checkSelectedOptions: function(a, b, c) {

                    // var showUsers = this.$('.clients input').prop('checked');

                    // if (!showUsers) {
                    //     this.$('.clientsOptions').hide();
                    // } else {
                    //     this.$('.clientsOptions').show();
                    // }
                },

                toggleButton: function() {

                    if (this.$('input[name="closer"]').prop('checked')) {
                        this.trigger('closesearch', true);
                        this.$('.input-city').val('');
                        this.showButton();
                        this.inactiveSearch();
                    } else {
                        this.hideButton();
                        this.trigger('closesearch', false);
                    }
                },
                hideButton: function() {
                    this.$('button.submit_btn').addClass('disabled');
                },
                showButton: function() {
                    this.$('button.submit_btn').removeClass('disabled');
                },
                setOptions: function(elems) {
                    var self = this;
                    this.clean();
                    _.each(elems, function(el) {

                        var country = _.find(el.address_components, function(comp) {
                            if (comp.types[0] === 'country') {
                                return true;
                            } else {
                                return false;
                            }
                        });
                        var dom = $('<li/>').text(el.formatted_address);
                        dom.click(function() {
                            self.trigger('selected', el.geometry.location, el.formatted_address, country.short_name);
                            self.$('input[name=city]').val(el.formatted_address);

                            self.$el.find('.closer .toggle').toggles(false);
                            setTimeout(function() {
                                // body...
                                self.showButton();
                                self.inactiveSearch();

                            }, 10);

                        });
                        self.$('.result-list').addClass('visible').append(dom);

                    });
                },
                clean: function() {
                    this.$('.result-list').html('').removeClass('visible');
                }


            });

        });

        return App.search.search.views;
    });
