


define(['App',
        'backbone',
        'apps/twilight/main/views',
        'funcs'
    ],
    function(App, Backbone, Views) {
        App.module('twilight.main.controller', function(Module, App) {
            this.startWithParent = false;
            var twZone, userInfo;
            App.vent.on('app:logged', function() {
                Module.start();
            });
            Module.addInitializer(function() {
                userInfo = App.request('entities:user_info');
                twZone = App.request('entities:twilight');
            });

            Module.pre = function(type) {
                //funcs.spinner(true);
                var accept = new Views.Accept();

                App.mainRegion.slideShow(accept, type);

                accept.on('accept', function() {
                    userInfo.set('twilight-accept', true);
                    userInfo.save();
                    Module.show(type);
                });
                accept.on('back', function() {
                    App.execute('app:map');

                });
            };


            Module.show = function(type) {
                if (!userInfo.get('twilight-accept')) {
                    Module.pre(type);
                } else {
                    //var mod = new Backbone.Model();

                    var list = new Views.Main({
                        model: twZone
                    });
                    App.mainRegion.slideShow(list, type);
                    list.on('map', function(params) {
                        App.execute('app:twilight:map', params);
                    });
                    list.on('back', function() {
                        App.execute('app:map');
                    });
                    list.on('toggle', function(val, name) {
                        Module.twilight(val, name);
                    });
                }

            };
            Module.twilight = function(val, name) {

                var twZones = App.request('entities:twilight');
                var obj;

                if (name === 'tw-address') {
                    obj = twZones.get('address');
                    obj.active = val;
                    twZones.set('address', obj);
                }
                if (name === 'tw-address-alt') {

                    obj = twZones.get('address-alt');


                    obj.active = val;
                    twZones.set('address-alt', obj);
                }
                if (name === 'tw-office') {
                    obj = twZones.get('office');
                    obj.active = val;
                    twZones.set('office', obj);
                }
                if (name === 'tw-office-alt') {
                    obj = twZones.get('office-alt');
                    obj.active = val;
                    twZones.set('office-alt', obj);
                }
                twZones.save();

                App.execute('app:location_manager:force_reload');

            };

        });

        return App.twilight.main.controller;

    });
