

define(['App',
    'underscore',
    'hbs!apps/twilight/main/templates/main',
    'hbs!apps/twilight/main/templates/accept'
], function(App, _, mainTpl, acceptTpl) {
    App.module('twilight.main.views', function(Module, App, Backbone, Marionette) {

        Module.Main = Marionette.ItemView.extend({
            template: mainTpl,
            triggers: {
                'click .back': 'back'
            },
            events: {
                'click .profile-arrow':'map',
                'puta input[type="checkbox"]':'toggle'


            },
            toggle: function(e) {
                this.trigger('toggle', $(e.currentTarget).prop('checked'),$(e.currentTarget).attr('name') );

            },
            map: function (e){
                var params = {
                    lat:$(e.target).closest('div.tw').attr('data-lat'),
                    lon:$(e.target).closest('div.tw').attr('data-lon'),
                    zone:$(e.target).closest('div.tw').attr('class'),
                    text:$(e.target).closest('div.tw').find('.tw-name').html()
                };
                this.trigger('map', params);
            }


        });
        Module.Accept = Marionette.ItemView.extend({
            template: acceptTpl,
            triggers: {
                'click .back': 'back',
                'click .accept': 'accept'
            }


        });

    });

    return App.twilight.main.views;

});
