


define(['App',
        'backbone',
        'apps/twilight/map/views',
        'funcs',
        'underscore'

    ],
    function(App, Backbone, Views, funcs, _) {
        App.module('twilight.map.controller', function(Module, App) {
            this.startWithParent = false;
            App.vent.on('app:logged', function() {
                Module.start();
            });
            var userInfo;

            Module.addInitializer(function() {
                userInfo = App.request('entities:user_info');

            });

            Module.show = function(params) {

                if (!params.lat || !params.lon) {

                    params.lon = userInfo.get('lon');
                    params.lat = userInfo.get('lat');
                    params.text = '';
                    //Rellamamos..
                    Module.show(params);


                } else {
                    var string = params.zone.split(' ')[0];
                    string = string.slice(3, string.length);
                    string = '11_twilight.' + string;
                    // string = i18n.t(string);
                    funcs.spinner(true);
                    var map = new Views.Map({
                        model: new Backbone.Model({
                            lat: params.lat,
                            lon: params.lon,
                            zone: string,
                            text: params.text
                        })
                    });
                    App.mainRegion.slideShow(map, params.type);
                    map.on('map', function(obj) {
                        App.execute('app:twilight:map', obj);
                    });
                    map.on('back', function() {
                        App.execute('app:twilight', 'right');
                    });
                    map.on('search', function(address) {
                        Module.search(address, function(res) {
                            map.setOptions(res);
                        });
                    });
                    map.on('savePos', function(pos, name) {
                        Module.savePos(pos, params.zone, name);
                    });
                }



            };
            Module.search = function(address, cb) {
                var geocoder = new google.maps.Geocoder();
                geocoder.geocode({
                    'address': address
                }, function(results, status) {
                    if (status === google.maps.GeocoderStatus.OK) {
                        cb(results);

                    }
                });
            };
            Module.savePos = function(pos, zone, name) {

                zone = zone.split(' ')[0];
                var twZones = App.request('entities:twilight');
                var info = {
                    lat: pos.lat(),
                    lon: pos.lng(),
                    //lon: pos.B,
                    active: true,
                    name: name
                };
                if (zone === 'tw-address') {
                    twZones.set('address', info);

                }
                if (zone === 'tw-address-alt') {
                    twZones.set('address-alt', info);

                }
                if (zone === 'tw-office') {
                    twZones.set('office', info);

                }
                if (zone === 'tw-office-alt') {
                    twZones.set('office-alt', info);
                }
                var api = _.clone(info);
                api.id_zone = zone.substr(3, zone.length);

                //funcs.spinner;

                App.request('api:twilight', api)
                    .then(function(data) {

                        twZones.save();
                        App.execute('app:location_manager:force_reload');
                        //App.execute('app:map:update_center'); //no va?!!
                        App.execute('app:twilight', 'right');
                    });
            };


        });

        return App.twilight.map.controller;

    });
